#include "soapH.h"

/*noinline*/ void soap_default_byte(struct soap *soap, char *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_byte
	*a = SOAP_DEFAULT_byte;
#else
	*a = (char)0;
#endif
}

/*noinline*/ int soap_write_byte(struct soap *soap, char const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_byte(soap, p, "byte", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_byte(struct soap *soap, const char *URL, char const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_byte(soap, p, "byte", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_byte(struct soap *soap, const char *URL, char const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_byte(soap, p, "byte", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_byte(struct soap *soap, const char *URL, char const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_byte(soap, p, "byte", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_byte(struct soap *soap, char *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_byte(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_byte(struct soap *soap, const char *URL, char *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_byte(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_byte(struct soap *soap, char *p)
{
	if (::soap_read_byte(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_short(struct soap *soap, short *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_short
	*a = SOAP_DEFAULT_short;
#else
	*a = (short)0;
#endif
}

/*noinline*/ int soap_write_short(struct soap *soap, short const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_short(soap, p, "short", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_short(struct soap *soap, const char *URL, short const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_short(soap, p, "short", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_short(struct soap *soap, const char *URL, short const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_short(soap, p, "short", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_short(struct soap *soap, const char *URL, short const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_short(soap, p, "short", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_short(struct soap *soap, short *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_short(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_short(struct soap *soap, const char *URL, short *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_short(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_short(struct soap *soap, short *p)
{
	if (::soap_read_short(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_int(struct soap *soap, int *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_int
	*a = SOAP_DEFAULT_int;
#else
	*a = (int)0;
#endif
}

/*noinline*/ int soap_write_int(struct soap *soap, int const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_int(soap, p, "int", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_int(struct soap *soap, const char *URL, int const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_int(soap, p, "int", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_int(struct soap *soap, const char *URL, int const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_int(soap, p, "int", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_int(struct soap *soap, const char *URL, int const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_int(soap, p, "int", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_int(struct soap *soap, int *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_int(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_int(struct soap *soap, const char *URL, int *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_int(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_int(struct soap *soap, int *p)
{
	if (::soap_read_int(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_LONG64(struct soap *soap, LONG64 *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_LONG64
	*a = SOAP_DEFAULT_LONG64;
#else
	*a = (LONG64)0;
#endif
}

/*noinline*/ int soap_write_LONG64(struct soap *soap, LONG64 const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_LONG64(soap, p, "long", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_LONG64(struct soap *soap, const char *URL, LONG64 const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_LONG64(soap, p, "long", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_LONG64(struct soap *soap, const char *URL, LONG64 const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_LONG64(soap, p, "long", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_LONG64(struct soap *soap, const char *URL, LONG64 const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_LONG64(soap, p, "long", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_LONG64(struct soap *soap, LONG64 *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_LONG64(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_LONG64(struct soap *soap, const char *URL, LONG64 *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_LONG64(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_LONG64(struct soap *soap, LONG64 *p)
{
	if (::soap_read_LONG64(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_unsignedShort(struct soap *soap, unsigned short *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedShort
	*a = SOAP_DEFAULT_unsignedShort;
#else
	*a = (unsigned short)0;
#endif
}

/*noinline*/ int soap_write_unsignedShort(struct soap *soap, unsigned short const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_unsignedShort(soap, p, "unsignedShort", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_unsignedShort(struct soap *soap, const char *URL, unsigned short const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_unsignedShort(soap, p, "unsignedShort", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_unsignedShort(struct soap *soap, const char *URL, unsigned short const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_unsignedShort(soap, p, "unsignedShort", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_unsignedShort(struct soap *soap, const char *URL, unsigned short const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_unsignedShort(soap, p, "unsignedShort", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_unsignedShort(struct soap *soap, unsigned short *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_unsignedShort(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_unsignedShort(struct soap *soap, const char *URL, unsigned short *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_unsignedShort(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_unsignedShort(struct soap *soap, unsigned short *p)
{
	if (::soap_read_unsignedShort(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_unsignedInt(struct soap *soap, unsigned int *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_unsignedInt
	*a = SOAP_DEFAULT_unsignedInt;
#else
	*a = (unsigned int)0;
#endif
}

/*noinline*/ int soap_write_unsignedInt(struct soap *soap, unsigned int const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_unsignedInt(soap, p, "unsignedInt", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_unsignedInt(struct soap *soap, const char *URL, unsigned int const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_unsignedInt(soap, p, "unsignedInt", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_unsignedInt(struct soap *soap, const char *URL, unsigned int const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_unsignedInt(soap, p, "unsignedInt", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_unsignedInt(struct soap *soap, const char *URL, unsigned int const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_unsignedInt(soap, p, "unsignedInt", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_unsignedInt(struct soap *soap, unsigned int *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_unsignedInt(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_unsignedInt(struct soap *soap, const char *URL, unsigned int *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_unsignedInt(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_unsignedInt(struct soap *soap, unsigned int *p)
{
	if (::soap_read_unsignedInt(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_bool(struct soap *soap, bool *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_bool
	*a = SOAP_DEFAULT_bool;
#else
	*a = (bool)0;
#endif
}

/*noinline*/ int soap_write_bool(struct soap *soap, bool const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_bool(soap, p, "boolean", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_bool(struct soap *soap, const char *URL, bool const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_bool(soap, p, "boolean", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_bool(struct soap *soap, const char *URL, bool const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_bool(soap, p, "boolean", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_bool(struct soap *soap, const char *URL, bool const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_bool(soap, p, "boolean", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_bool(struct soap *soap, bool *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_bool(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_bool(struct soap *soap, const char *URL, bool *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_bool(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_bool(struct soap *soap, bool *p)
{
	if (::soap_read_bool(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SymlinkPolicy(struct soap *soap, enum vbox__SymlinkPolicy *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SymlinkPolicy
	*a = SOAP_DEFAULT_vbox__SymlinkPolicy;
#else
	*a = (enum vbox__SymlinkPolicy)0;
#endif
}

/*noinline*/ int soap_write_vbox__SymlinkPolicy(struct soap *soap, enum vbox__SymlinkPolicy const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SymlinkPolicy(soap, p, "vbox:SymlinkPolicy", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SymlinkPolicy(struct soap *soap, const char *URL, enum vbox__SymlinkPolicy const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkPolicy(soap, p, "vbox:SymlinkPolicy", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SymlinkPolicy(struct soap *soap, const char *URL, enum vbox__SymlinkPolicy const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkPolicy(soap, p, "vbox:SymlinkPolicy", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SymlinkPolicy(struct soap *soap, const char *URL, enum vbox__SymlinkPolicy const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkPolicy(soap, p, "vbox:SymlinkPolicy", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SymlinkPolicy(struct soap *soap, enum vbox__SymlinkPolicy *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SymlinkPolicy(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SymlinkPolicy(struct soap *soap, const char *URL, enum vbox__SymlinkPolicy *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SymlinkPolicy(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SymlinkPolicy(struct soap *soap, enum vbox__SymlinkPolicy *p)
{
	if (::soap_read_vbox__SymlinkPolicy(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MetricType(struct soap *soap, enum vbox__MetricType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MetricType
	*a = SOAP_DEFAULT_vbox__MetricType;
#else
	*a = (enum vbox__MetricType)0;
#endif
}

/*noinline*/ int soap_write_vbox__MetricType(struct soap *soap, enum vbox__MetricType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MetricType(soap, p, "vbox:MetricType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MetricType(struct soap *soap, const char *URL, enum vbox__MetricType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MetricType(soap, p, "vbox:MetricType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MetricType(struct soap *soap, const char *URL, enum vbox__MetricType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MetricType(soap, p, "vbox:MetricType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MetricType(struct soap *soap, const char *URL, enum vbox__MetricType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MetricType(soap, p, "vbox:MetricType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MetricType(struct soap *soap, enum vbox__MetricType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MetricType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MetricType(struct soap *soap, const char *URL, enum vbox__MetricType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MetricType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MetricType(struct soap *soap, enum vbox__MetricType *p)
{
	if (::soap_read_vbox__MetricType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CloudImageState(struct soap *soap, enum vbox__CloudImageState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CloudImageState
	*a = SOAP_DEFAULT_vbox__CloudImageState;
#else
	*a = (enum vbox__CloudImageState)0;
#endif
}

/*noinline*/ int soap_write_vbox__CloudImageState(struct soap *soap, enum vbox__CloudImageState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CloudImageState(soap, p, "vbox:CloudImageState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CloudImageState(struct soap *soap, const char *URL, enum vbox__CloudImageState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloudImageState(soap, p, "vbox:CloudImageState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CloudImageState(struct soap *soap, const char *URL, enum vbox__CloudImageState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloudImageState(soap, p, "vbox:CloudImageState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CloudImageState(struct soap *soap, const char *URL, enum vbox__CloudImageState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloudImageState(soap, p, "vbox:CloudImageState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CloudImageState(struct soap *soap, enum vbox__CloudImageState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CloudImageState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CloudImageState(struct soap *soap, const char *URL, enum vbox__CloudImageState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CloudImageState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CloudImageState(struct soap *soap, enum vbox__CloudImageState *p)
{
	if (::soap_read_vbox__CloudImageState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CloudMachineState(struct soap *soap, enum vbox__CloudMachineState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CloudMachineState
	*a = SOAP_DEFAULT_vbox__CloudMachineState;
#else
	*a = (enum vbox__CloudMachineState)0;
#endif
}

/*noinline*/ int soap_write_vbox__CloudMachineState(struct soap *soap, enum vbox__CloudMachineState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CloudMachineState(soap, p, "vbox:CloudMachineState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CloudMachineState(struct soap *soap, const char *URL, enum vbox__CloudMachineState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloudMachineState(soap, p, "vbox:CloudMachineState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CloudMachineState(struct soap *soap, const char *URL, enum vbox__CloudMachineState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloudMachineState(soap, p, "vbox:CloudMachineState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CloudMachineState(struct soap *soap, const char *URL, enum vbox__CloudMachineState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloudMachineState(soap, p, "vbox:CloudMachineState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CloudMachineState(struct soap *soap, enum vbox__CloudMachineState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CloudMachineState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CloudMachineState(struct soap *soap, const char *URL, enum vbox__CloudMachineState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CloudMachineState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CloudMachineState(struct soap *soap, enum vbox__CloudMachineState *p)
{
	if (::soap_read_vbox__CloudMachineState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FormValueType(struct soap *soap, enum vbox__FormValueType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FormValueType
	*a = SOAP_DEFAULT_vbox__FormValueType;
#else
	*a = (enum vbox__FormValueType)0;
#endif
}

/*noinline*/ int soap_write_vbox__FormValueType(struct soap *soap, enum vbox__FormValueType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FormValueType(soap, p, "vbox:FormValueType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FormValueType(struct soap *soap, const char *URL, enum vbox__FormValueType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FormValueType(soap, p, "vbox:FormValueType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FormValueType(struct soap *soap, const char *URL, enum vbox__FormValueType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FormValueType(soap, p, "vbox:FormValueType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FormValueType(struct soap *soap, const char *URL, enum vbox__FormValueType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FormValueType(soap, p, "vbox:FormValueType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FormValueType(struct soap *soap, enum vbox__FormValueType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FormValueType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FormValueType(struct soap *soap, const char *URL, enum vbox__FormValueType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FormValueType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FormValueType(struct soap *soap, enum vbox__FormValueType *p)
{
	if (::soap_read_vbox__FormValueType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestMonitorChangedEventType(struct soap *soap, enum vbox__GuestMonitorChangedEventType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestMonitorChangedEventType
	*a = SOAP_DEFAULT_vbox__GuestMonitorChangedEventType;
#else
	*a = (enum vbox__GuestMonitorChangedEventType)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestMonitorChangedEventType(struct soap *soap, enum vbox__GuestMonitorChangedEventType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestMonitorChangedEventType(soap, p, "vbox:GuestMonitorChangedEventType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestMonitorChangedEventType(struct soap *soap, const char *URL, enum vbox__GuestMonitorChangedEventType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMonitorChangedEventType(soap, p, "vbox:GuestMonitorChangedEventType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestMonitorChangedEventType(struct soap *soap, const char *URL, enum vbox__GuestMonitorChangedEventType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMonitorChangedEventType(soap, p, "vbox:GuestMonitorChangedEventType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestMonitorChangedEventType(struct soap *soap, const char *URL, enum vbox__GuestMonitorChangedEventType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMonitorChangedEventType(soap, p, "vbox:GuestMonitorChangedEventType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestMonitorChangedEventType(struct soap *soap, enum vbox__GuestMonitorChangedEventType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestMonitorChangedEventType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestMonitorChangedEventType(struct soap *soap, const char *URL, enum vbox__GuestMonitorChangedEventType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestMonitorChangedEventType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestMonitorChangedEventType(struct soap *soap, enum vbox__GuestMonitorChangedEventType *p)
{
	if (::soap_read_vbox__GuestMonitorChangedEventType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestMouseEventMode(struct soap *soap, enum vbox__GuestMouseEventMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestMouseEventMode
	*a = SOAP_DEFAULT_vbox__GuestMouseEventMode;
#else
	*a = (enum vbox__GuestMouseEventMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestMouseEventMode(struct soap *soap, enum vbox__GuestMouseEventMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestMouseEventMode(soap, p, "vbox:GuestMouseEventMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestMouseEventMode(struct soap *soap, const char *URL, enum vbox__GuestMouseEventMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMouseEventMode(soap, p, "vbox:GuestMouseEventMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestMouseEventMode(struct soap *soap, const char *URL, enum vbox__GuestMouseEventMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMouseEventMode(soap, p, "vbox:GuestMouseEventMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestMouseEventMode(struct soap *soap, const char *URL, enum vbox__GuestMouseEventMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMouseEventMode(soap, p, "vbox:GuestMouseEventMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestMouseEventMode(struct soap *soap, enum vbox__GuestMouseEventMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestMouseEventMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestMouseEventMode(struct soap *soap, const char *URL, enum vbox__GuestMouseEventMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestMouseEventMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestMouseEventMode(struct soap *soap, enum vbox__GuestMouseEventMode *p)
{
	if (::soap_read_vbox__GuestMouseEventMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__VBoxEventType(struct soap *soap, enum vbox__VBoxEventType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VBoxEventType
	*a = SOAP_DEFAULT_vbox__VBoxEventType;
#else
	*a = (enum vbox__VBoxEventType)0;
#endif
}

/*noinline*/ int soap_write_vbox__VBoxEventType(struct soap *soap, enum vbox__VBoxEventType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__VBoxEventType(soap, p, "vbox:VBoxEventType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__VBoxEventType(struct soap *soap, const char *URL, enum vbox__VBoxEventType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VBoxEventType(soap, p, "vbox:VBoxEventType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__VBoxEventType(struct soap *soap, const char *URL, enum vbox__VBoxEventType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VBoxEventType(soap, p, "vbox:VBoxEventType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__VBoxEventType(struct soap *soap, const char *URL, enum vbox__VBoxEventType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VBoxEventType(soap, p, "vbox:VBoxEventType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__VBoxEventType(struct soap *soap, enum vbox__VBoxEventType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__VBoxEventType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__VBoxEventType(struct soap *soap, const char *URL, enum vbox__VBoxEventType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__VBoxEventType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__VBoxEventType(struct soap *soap, enum vbox__VBoxEventType *p)
{
	if (::soap_read_vbox__VBoxEventType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestDebugIoProvider(struct soap *soap, enum vbox__GuestDebugIoProvider *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestDebugIoProvider
	*a = SOAP_DEFAULT_vbox__GuestDebugIoProvider;
#else
	*a = (enum vbox__GuestDebugIoProvider)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestDebugIoProvider(struct soap *soap, enum vbox__GuestDebugIoProvider const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestDebugIoProvider(soap, p, "vbox:GuestDebugIoProvider", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestDebugIoProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugIoProvider const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestDebugIoProvider(soap, p, "vbox:GuestDebugIoProvider", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestDebugIoProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugIoProvider const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestDebugIoProvider(soap, p, "vbox:GuestDebugIoProvider", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestDebugIoProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugIoProvider const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestDebugIoProvider(soap, p, "vbox:GuestDebugIoProvider", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestDebugIoProvider(struct soap *soap, enum vbox__GuestDebugIoProvider *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestDebugIoProvider(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestDebugIoProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugIoProvider *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestDebugIoProvider(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestDebugIoProvider(struct soap *soap, enum vbox__GuestDebugIoProvider *p)
{
	if (::soap_read_vbox__GuestDebugIoProvider(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestDebugProvider(struct soap *soap, enum vbox__GuestDebugProvider *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestDebugProvider
	*a = SOAP_DEFAULT_vbox__GuestDebugProvider;
#else
	*a = (enum vbox__GuestDebugProvider)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestDebugProvider(struct soap *soap, enum vbox__GuestDebugProvider const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestDebugProvider(soap, p, "vbox:GuestDebugProvider", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestDebugProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugProvider const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestDebugProvider(soap, p, "vbox:GuestDebugProvider", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestDebugProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugProvider const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestDebugProvider(soap, p, "vbox:GuestDebugProvider", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestDebugProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugProvider const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestDebugProvider(soap, p, "vbox:GuestDebugProvider", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestDebugProvider(struct soap *soap, enum vbox__GuestDebugProvider *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestDebugProvider(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestDebugProvider(struct soap *soap, const char *URL, enum vbox__GuestDebugProvider *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestDebugProvider(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestDebugProvider(struct soap *soap, enum vbox__GuestDebugProvider *p)
{
	if (::soap_read_vbox__GuestDebugProvider(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__BandwidthGroupType(struct soap *soap, enum vbox__BandwidthGroupType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BandwidthGroupType
	*a = SOAP_DEFAULT_vbox__BandwidthGroupType;
#else
	*a = (enum vbox__BandwidthGroupType)0;
#endif
}

/*noinline*/ int soap_write_vbox__BandwidthGroupType(struct soap *soap, enum vbox__BandwidthGroupType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__BandwidthGroupType(soap, p, "vbox:BandwidthGroupType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__BandwidthGroupType(struct soap *soap, const char *URL, enum vbox__BandwidthGroupType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__BandwidthGroupType(soap, p, "vbox:BandwidthGroupType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__BandwidthGroupType(struct soap *soap, const char *URL, enum vbox__BandwidthGroupType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__BandwidthGroupType(soap, p, "vbox:BandwidthGroupType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__BandwidthGroupType(struct soap *soap, const char *URL, enum vbox__BandwidthGroupType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__BandwidthGroupType(soap, p, "vbox:BandwidthGroupType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__BandwidthGroupType(struct soap *soap, enum vbox__BandwidthGroupType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__BandwidthGroupType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__BandwidthGroupType(struct soap *soap, const char *URL, enum vbox__BandwidthGroupType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__BandwidthGroupType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__BandwidthGroupType(struct soap *soap, enum vbox__BandwidthGroupType *p)
{
	if (::soap_read_vbox__BandwidthGroupType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__NATProtocol(struct soap *soap, enum vbox__NATProtocol *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NATProtocol
	*a = SOAP_DEFAULT_vbox__NATProtocol;
#else
	*a = (enum vbox__NATProtocol)0;
#endif
}

/*noinline*/ int soap_write_vbox__NATProtocol(struct soap *soap, enum vbox__NATProtocol const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__NATProtocol(soap, p, "vbox:NATProtocol", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__NATProtocol(struct soap *soap, const char *URL, enum vbox__NATProtocol const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NATProtocol(soap, p, "vbox:NATProtocol", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__NATProtocol(struct soap *soap, const char *URL, enum vbox__NATProtocol const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NATProtocol(soap, p, "vbox:NATProtocol", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__NATProtocol(struct soap *soap, const char *URL, enum vbox__NATProtocol const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NATProtocol(soap, p, "vbox:NATProtocol", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__NATProtocol(struct soap *soap, enum vbox__NATProtocol *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__NATProtocol(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__NATProtocol(struct soap *soap, const char *URL, enum vbox__NATProtocol *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__NATProtocol(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__NATProtocol(struct soap *soap, enum vbox__NATProtocol *p)
{
	if (::soap_read_vbox__NATProtocol(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__NATAliasMode(struct soap *soap, enum vbox__NATAliasMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NATAliasMode
	*a = SOAP_DEFAULT_vbox__NATAliasMode;
#else
	*a = (enum vbox__NATAliasMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__NATAliasMode(struct soap *soap, enum vbox__NATAliasMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__NATAliasMode(soap, p, "vbox:NATAliasMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__NATAliasMode(struct soap *soap, const char *URL, enum vbox__NATAliasMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NATAliasMode(soap, p, "vbox:NATAliasMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__NATAliasMode(struct soap *soap, const char *URL, enum vbox__NATAliasMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NATAliasMode(soap, p, "vbox:NATAliasMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__NATAliasMode(struct soap *soap, const char *URL, enum vbox__NATAliasMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NATAliasMode(soap, p, "vbox:NATAliasMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__NATAliasMode(struct soap *soap, enum vbox__NATAliasMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__NATAliasMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__NATAliasMode(struct soap *soap, const char *URL, enum vbox__NATAliasMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__NATAliasMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__NATAliasMode(struct soap *soap, enum vbox__NATAliasMode *p)
{
	if (::soap_read_vbox__NATAliasMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ChipsetType(struct soap *soap, enum vbox__ChipsetType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ChipsetType
	*a = SOAP_DEFAULT_vbox__ChipsetType;
#else
	*a = (enum vbox__ChipsetType)0;
#endif
}

/*noinline*/ int soap_write_vbox__ChipsetType(struct soap *soap, enum vbox__ChipsetType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ChipsetType(soap, p, "vbox:ChipsetType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ChipsetType(struct soap *soap, const char *URL, enum vbox__ChipsetType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ChipsetType(soap, p, "vbox:ChipsetType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ChipsetType(struct soap *soap, const char *URL, enum vbox__ChipsetType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ChipsetType(soap, p, "vbox:ChipsetType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ChipsetType(struct soap *soap, const char *URL, enum vbox__ChipsetType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ChipsetType(soap, p, "vbox:ChipsetType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ChipsetType(struct soap *soap, enum vbox__ChipsetType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ChipsetType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ChipsetType(struct soap *soap, const char *URL, enum vbox__ChipsetType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ChipsetType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ChipsetType(struct soap *soap, enum vbox__ChipsetType *p)
{
	if (::soap_read_vbox__ChipsetType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageControllerType
	*a = SOAP_DEFAULT_vbox__StorageControllerType;
#else
	*a = (enum vbox__StorageControllerType)0;
#endif
}

/*noinline*/ int soap_write_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__StorageControllerType(soap, p, "vbox:StorageControllerType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__StorageControllerType(struct soap *soap, const char *URL, enum vbox__StorageControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__StorageControllerType(soap, p, "vbox:StorageControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__StorageControllerType(struct soap *soap, const char *URL, enum vbox__StorageControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__StorageControllerType(soap, p, "vbox:StorageControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__StorageControllerType(struct soap *soap, const char *URL, enum vbox__StorageControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__StorageControllerType(soap, p, "vbox:StorageControllerType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__StorageControllerType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__StorageControllerType(struct soap *soap, const char *URL, enum vbox__StorageControllerType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__StorageControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__StorageControllerType(struct soap *soap, enum vbox__StorageControllerType *p)
{
	if (::soap_read_vbox__StorageControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__StorageBus
	*a = SOAP_DEFAULT_vbox__StorageBus;
#else
	*a = (enum vbox__StorageBus)0;
#endif
}

/*noinline*/ int soap_write_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__StorageBus(soap, p, "vbox:StorageBus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__StorageBus(struct soap *soap, const char *URL, enum vbox__StorageBus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__StorageBus(soap, p, "vbox:StorageBus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__StorageBus(struct soap *soap, const char *URL, enum vbox__StorageBus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__StorageBus(soap, p, "vbox:StorageBus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__StorageBus(struct soap *soap, const char *URL, enum vbox__StorageBus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__StorageBus(soap, p, "vbox:StorageBus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__StorageBus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__StorageBus(struct soap *soap, const char *URL, enum vbox__StorageBus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__StorageBus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__StorageBus(struct soap *soap, enum vbox__StorageBus *p)
{
	if (::soap_read_vbox__StorageBus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__Reason(struct soap *soap, enum vbox__Reason *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__Reason
	*a = SOAP_DEFAULT_vbox__Reason;
#else
	*a = (enum vbox__Reason)0;
#endif
}

/*noinline*/ int soap_write_vbox__Reason(struct soap *soap, enum vbox__Reason const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__Reason(soap, p, "vbox:Reason", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__Reason(struct soap *soap, const char *URL, enum vbox__Reason const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__Reason(soap, p, "vbox:Reason", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__Reason(struct soap *soap, const char *URL, enum vbox__Reason const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__Reason(soap, p, "vbox:Reason", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__Reason(struct soap *soap, const char *URL, enum vbox__Reason const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__Reason(soap, p, "vbox:Reason", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__Reason(struct soap *soap, enum vbox__Reason *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__Reason(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__Reason(struct soap *soap, const char *URL, enum vbox__Reason *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__Reason(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__Reason(struct soap *soap, enum vbox__Reason *p)
{
	if (::soap_read_vbox__Reason(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AuthType(struct soap *soap, enum vbox__AuthType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AuthType
	*a = SOAP_DEFAULT_vbox__AuthType;
#else
	*a = (enum vbox__AuthType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AuthType(struct soap *soap, enum vbox__AuthType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AuthType(soap, p, "vbox:AuthType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AuthType(struct soap *soap, const char *URL, enum vbox__AuthType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AuthType(soap, p, "vbox:AuthType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AuthType(struct soap *soap, const char *URL, enum vbox__AuthType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AuthType(soap, p, "vbox:AuthType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AuthType(struct soap *soap, const char *URL, enum vbox__AuthType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AuthType(soap, p, "vbox:AuthType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AuthType(struct soap *soap, enum vbox__AuthType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AuthType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AuthType(struct soap *soap, const char *URL, enum vbox__AuthType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AuthType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AuthType(struct soap *soap, enum vbox__AuthType *p)
{
	if (::soap_read_vbox__AuthType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AudioDeviceState(struct soap *soap, enum vbox__AudioDeviceState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDeviceState
	*a = SOAP_DEFAULT_vbox__AudioDeviceState;
#else
	*a = (enum vbox__AudioDeviceState)0;
#endif
}

/*noinline*/ int soap_write_vbox__AudioDeviceState(struct soap *soap, enum vbox__AudioDeviceState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AudioDeviceState(soap, p, "vbox:AudioDeviceState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AudioDeviceState(struct soap *soap, const char *URL, enum vbox__AudioDeviceState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDeviceState(soap, p, "vbox:AudioDeviceState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AudioDeviceState(struct soap *soap, const char *URL, enum vbox__AudioDeviceState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDeviceState(soap, p, "vbox:AudioDeviceState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AudioDeviceState(struct soap *soap, const char *URL, enum vbox__AudioDeviceState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDeviceState(soap, p, "vbox:AudioDeviceState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AudioDeviceState(struct soap *soap, enum vbox__AudioDeviceState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AudioDeviceState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AudioDeviceState(struct soap *soap, const char *URL, enum vbox__AudioDeviceState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AudioDeviceState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AudioDeviceState(struct soap *soap, enum vbox__AudioDeviceState *p)
{
	if (::soap_read_vbox__AudioDeviceState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AudioDeviceType(struct soap *soap, enum vbox__AudioDeviceType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDeviceType
	*a = SOAP_DEFAULT_vbox__AudioDeviceType;
#else
	*a = (enum vbox__AudioDeviceType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AudioDeviceType(struct soap *soap, enum vbox__AudioDeviceType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AudioDeviceType(soap, p, "vbox:AudioDeviceType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AudioDeviceType(struct soap *soap, const char *URL, enum vbox__AudioDeviceType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDeviceType(soap, p, "vbox:AudioDeviceType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AudioDeviceType(struct soap *soap, const char *URL, enum vbox__AudioDeviceType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDeviceType(soap, p, "vbox:AudioDeviceType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AudioDeviceType(struct soap *soap, const char *URL, enum vbox__AudioDeviceType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDeviceType(soap, p, "vbox:AudioDeviceType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AudioDeviceType(struct soap *soap, enum vbox__AudioDeviceType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AudioDeviceType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AudioDeviceType(struct soap *soap, const char *URL, enum vbox__AudioDeviceType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AudioDeviceType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AudioDeviceType(struct soap *soap, enum vbox__AudioDeviceType *p)
{
	if (::soap_read_vbox__AudioDeviceType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AudioDirection(struct soap *soap, enum vbox__AudioDirection *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDirection
	*a = SOAP_DEFAULT_vbox__AudioDirection;
#else
	*a = (enum vbox__AudioDirection)0;
#endif
}

/*noinline*/ int soap_write_vbox__AudioDirection(struct soap *soap, enum vbox__AudioDirection const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AudioDirection(soap, p, "vbox:AudioDirection", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AudioDirection(struct soap *soap, const char *URL, enum vbox__AudioDirection const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDirection(soap, p, "vbox:AudioDirection", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AudioDirection(struct soap *soap, const char *URL, enum vbox__AudioDirection const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDirection(soap, p, "vbox:AudioDirection", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AudioDirection(struct soap *soap, const char *URL, enum vbox__AudioDirection const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDirection(soap, p, "vbox:AudioDirection", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AudioDirection(struct soap *soap, enum vbox__AudioDirection *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AudioDirection(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AudioDirection(struct soap *soap, const char *URL, enum vbox__AudioDirection *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AudioDirection(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AudioDirection(struct soap *soap, enum vbox__AudioDirection *p)
{
	if (::soap_read_vbox__AudioDirection(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AudioCodecType(struct soap *soap, enum vbox__AudioCodecType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioCodecType
	*a = SOAP_DEFAULT_vbox__AudioCodecType;
#else
	*a = (enum vbox__AudioCodecType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AudioCodecType(struct soap *soap, enum vbox__AudioCodecType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AudioCodecType(soap, p, "vbox:AudioCodecType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AudioCodecType(struct soap *soap, const char *URL, enum vbox__AudioCodecType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioCodecType(soap, p, "vbox:AudioCodecType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AudioCodecType(struct soap *soap, const char *URL, enum vbox__AudioCodecType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioCodecType(soap, p, "vbox:AudioCodecType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AudioCodecType(struct soap *soap, const char *URL, enum vbox__AudioCodecType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioCodecType(soap, p, "vbox:AudioCodecType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AudioCodecType(struct soap *soap, enum vbox__AudioCodecType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AudioCodecType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AudioCodecType(struct soap *soap, const char *URL, enum vbox__AudioCodecType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AudioCodecType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AudioCodecType(struct soap *soap, enum vbox__AudioCodecType *p)
{
	if (::soap_read_vbox__AudioCodecType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioControllerType
	*a = SOAP_DEFAULT_vbox__AudioControllerType;
#else
	*a = (enum vbox__AudioControllerType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AudioControllerType(soap, p, "vbox:AudioControllerType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AudioControllerType(struct soap *soap, const char *URL, enum vbox__AudioControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioControllerType(soap, p, "vbox:AudioControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AudioControllerType(struct soap *soap, const char *URL, enum vbox__AudioControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioControllerType(soap, p, "vbox:AudioControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AudioControllerType(struct soap *soap, const char *URL, enum vbox__AudioControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioControllerType(soap, p, "vbox:AudioControllerType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AudioControllerType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AudioControllerType(struct soap *soap, const char *URL, enum vbox__AudioControllerType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AudioControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AudioControllerType(struct soap *soap, enum vbox__AudioControllerType *p)
{
	if (::soap_read_vbox__AudioControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AudioDriverType
	*a = SOAP_DEFAULT_vbox__AudioDriverType;
#else
	*a = (enum vbox__AudioDriverType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AudioDriverType(soap, p, "vbox:AudioDriverType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AudioDriverType(struct soap *soap, const char *URL, enum vbox__AudioDriverType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDriverType(soap, p, "vbox:AudioDriverType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AudioDriverType(struct soap *soap, const char *URL, enum vbox__AudioDriverType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDriverType(soap, p, "vbox:AudioDriverType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AudioDriverType(struct soap *soap, const char *URL, enum vbox__AudioDriverType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AudioDriverType(soap, p, "vbox:AudioDriverType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AudioDriverType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AudioDriverType(struct soap *soap, const char *URL, enum vbox__AudioDriverType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AudioDriverType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AudioDriverType(struct soap *soap, enum vbox__AudioDriverType *p)
{
	if (::soap_read_vbox__AudioDriverType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceFilterAction
	*a = SOAP_DEFAULT_vbox__USBDeviceFilterAction;
#else
	*a = (enum vbox__USBDeviceFilterAction)0;
#endif
}

/*noinline*/ int soap_write_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__USBDeviceFilterAction(soap, p, "vbox:USBDeviceFilterAction", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__USBDeviceFilterAction(struct soap *soap, const char *URL, enum vbox__USBDeviceFilterAction const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBDeviceFilterAction(soap, p, "vbox:USBDeviceFilterAction", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__USBDeviceFilterAction(struct soap *soap, const char *URL, enum vbox__USBDeviceFilterAction const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBDeviceFilterAction(soap, p, "vbox:USBDeviceFilterAction", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__USBDeviceFilterAction(struct soap *soap, const char *URL, enum vbox__USBDeviceFilterAction const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBDeviceFilterAction(soap, p, "vbox:USBDeviceFilterAction", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__USBDeviceFilterAction(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__USBDeviceFilterAction(struct soap *soap, const char *URL, enum vbox__USBDeviceFilterAction *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__USBDeviceFilterAction(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__USBDeviceFilterAction(struct soap *soap, enum vbox__USBDeviceFilterAction *p)
{
	if (::soap_read_vbox__USBDeviceFilterAction(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBDeviceState
	*a = SOAP_DEFAULT_vbox__USBDeviceState;
#else
	*a = (enum vbox__USBDeviceState)0;
#endif
}

/*noinline*/ int soap_write_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__USBDeviceState(soap, p, "vbox:USBDeviceState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__USBDeviceState(struct soap *soap, const char *URL, enum vbox__USBDeviceState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBDeviceState(soap, p, "vbox:USBDeviceState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__USBDeviceState(struct soap *soap, const char *URL, enum vbox__USBDeviceState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBDeviceState(soap, p, "vbox:USBDeviceState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__USBDeviceState(struct soap *soap, const char *URL, enum vbox__USBDeviceState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBDeviceState(soap, p, "vbox:USBDeviceState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__USBDeviceState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__USBDeviceState(struct soap *soap, const char *URL, enum vbox__USBDeviceState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__USBDeviceState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__USBDeviceState(struct soap *soap, enum vbox__USBDeviceState *p)
{
	if (::soap_read_vbox__USBDeviceState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__USBConnectionSpeed(struct soap *soap, enum vbox__USBConnectionSpeed *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBConnectionSpeed
	*a = SOAP_DEFAULT_vbox__USBConnectionSpeed;
#else
	*a = (enum vbox__USBConnectionSpeed)0;
#endif
}

/*noinline*/ int soap_write_vbox__USBConnectionSpeed(struct soap *soap, enum vbox__USBConnectionSpeed const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__USBConnectionSpeed(soap, p, "vbox:USBConnectionSpeed", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__USBConnectionSpeed(struct soap *soap, const char *URL, enum vbox__USBConnectionSpeed const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBConnectionSpeed(soap, p, "vbox:USBConnectionSpeed", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__USBConnectionSpeed(struct soap *soap, const char *URL, enum vbox__USBConnectionSpeed const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBConnectionSpeed(soap, p, "vbox:USBConnectionSpeed", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__USBConnectionSpeed(struct soap *soap, const char *URL, enum vbox__USBConnectionSpeed const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBConnectionSpeed(soap, p, "vbox:USBConnectionSpeed", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__USBConnectionSpeed(struct soap *soap, enum vbox__USBConnectionSpeed *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__USBConnectionSpeed(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__USBConnectionSpeed(struct soap *soap, const char *URL, enum vbox__USBConnectionSpeed *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__USBConnectionSpeed(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__USBConnectionSpeed(struct soap *soap, enum vbox__USBConnectionSpeed *p)
{
	if (::soap_read_vbox__USBConnectionSpeed(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__USBControllerType(struct soap *soap, enum vbox__USBControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__USBControllerType
	*a = SOAP_DEFAULT_vbox__USBControllerType;
#else
	*a = (enum vbox__USBControllerType)0;
#endif
}

/*noinline*/ int soap_write_vbox__USBControllerType(struct soap *soap, enum vbox__USBControllerType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__USBControllerType(soap, p, "vbox:USBControllerType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__USBControllerType(struct soap *soap, const char *URL, enum vbox__USBControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBControllerType(soap, p, "vbox:USBControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__USBControllerType(struct soap *soap, const char *URL, enum vbox__USBControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBControllerType(soap, p, "vbox:USBControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__USBControllerType(struct soap *soap, const char *URL, enum vbox__USBControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__USBControllerType(soap, p, "vbox:USBControllerType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__USBControllerType(struct soap *soap, enum vbox__USBControllerType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__USBControllerType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__USBControllerType(struct soap *soap, const char *URL, enum vbox__USBControllerType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__USBControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__USBControllerType(struct soap *soap, enum vbox__USBControllerType *p)
{
	if (::soap_read_vbox__USBControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__UartType(struct soap *soap, enum vbox__UartType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__UartType
	*a = SOAP_DEFAULT_vbox__UartType;
#else
	*a = (enum vbox__UartType)0;
#endif
}

/*noinline*/ int soap_write_vbox__UartType(struct soap *soap, enum vbox__UartType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__UartType(soap, p, "vbox:UartType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__UartType(struct soap *soap, const char *URL, enum vbox__UartType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UartType(soap, p, "vbox:UartType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__UartType(struct soap *soap, const char *URL, enum vbox__UartType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UartType(soap, p, "vbox:UartType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__UartType(struct soap *soap, const char *URL, enum vbox__UartType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UartType(soap, p, "vbox:UartType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__UartType(struct soap *soap, enum vbox__UartType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__UartType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__UartType(struct soap *soap, const char *URL, enum vbox__UartType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__UartType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__UartType(struct soap *soap, enum vbox__UartType *p)
{
	if (::soap_read_vbox__UartType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PortMode(struct soap *soap, enum vbox__PortMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PortMode
	*a = SOAP_DEFAULT_vbox__PortMode;
#else
	*a = (enum vbox__PortMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__PortMode(struct soap *soap, enum vbox__PortMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PortMode(soap, p, "vbox:PortMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PortMode(struct soap *soap, const char *URL, enum vbox__PortMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PortMode(soap, p, "vbox:PortMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PortMode(struct soap *soap, const char *URL, enum vbox__PortMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PortMode(soap, p, "vbox:PortMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PortMode(struct soap *soap, const char *URL, enum vbox__PortMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PortMode(soap, p, "vbox:PortMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PortMode(struct soap *soap, enum vbox__PortMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PortMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PortMode(struct soap *soap, const char *URL, enum vbox__PortMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PortMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PortMode(struct soap *soap, enum vbox__PortMode *p)
{
	if (::soap_read_vbox__PortMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAdapterPromiscModePolicy
	*a = SOAP_DEFAULT_vbox__NetworkAdapterPromiscModePolicy;
#else
	*a = (enum vbox__NetworkAdapterPromiscModePolicy)0;
#endif
}

/*noinline*/ int soap_write_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__NetworkAdapterPromiscModePolicy(soap, p, "vbox:NetworkAdapterPromiscModePolicy", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *URL, enum vbox__NetworkAdapterPromiscModePolicy const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAdapterPromiscModePolicy(soap, p, "vbox:NetworkAdapterPromiscModePolicy", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *URL, enum vbox__NetworkAdapterPromiscModePolicy const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAdapterPromiscModePolicy(soap, p, "vbox:NetworkAdapterPromiscModePolicy", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *URL, enum vbox__NetworkAdapterPromiscModePolicy const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAdapterPromiscModePolicy(soap, p, "vbox:NetworkAdapterPromiscModePolicy", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__NetworkAdapterPromiscModePolicy(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, const char *URL, enum vbox__NetworkAdapterPromiscModePolicy *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__NetworkAdapterPromiscModePolicy(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__NetworkAdapterPromiscModePolicy(struct soap *soap, enum vbox__NetworkAdapterPromiscModePolicy *p)
{
	if (::soap_read_vbox__NetworkAdapterPromiscModePolicy(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAdapterType
	*a = SOAP_DEFAULT_vbox__NetworkAdapterType;
#else
	*a = (enum vbox__NetworkAdapterType)0;
#endif
}

/*noinline*/ int soap_write_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__NetworkAdapterType(soap, p, "vbox:NetworkAdapterType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__NetworkAdapterType(struct soap *soap, const char *URL, enum vbox__NetworkAdapterType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAdapterType(soap, p, "vbox:NetworkAdapterType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__NetworkAdapterType(struct soap *soap, const char *URL, enum vbox__NetworkAdapterType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAdapterType(soap, p, "vbox:NetworkAdapterType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__NetworkAdapterType(struct soap *soap, const char *URL, enum vbox__NetworkAdapterType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAdapterType(soap, p, "vbox:NetworkAdapterType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__NetworkAdapterType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__NetworkAdapterType(struct soap *soap, const char *URL, enum vbox__NetworkAdapterType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__NetworkAdapterType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__NetworkAdapterType(struct soap *soap, enum vbox__NetworkAdapterType *p)
{
	if (::soap_read_vbox__NetworkAdapterType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__NetworkAttachmentType
	*a = SOAP_DEFAULT_vbox__NetworkAttachmentType;
#else
	*a = (enum vbox__NetworkAttachmentType)0;
#endif
}

/*noinline*/ int soap_write_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__NetworkAttachmentType(soap, p, "vbox:NetworkAttachmentType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__NetworkAttachmentType(struct soap *soap, const char *URL, enum vbox__NetworkAttachmentType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAttachmentType(soap, p, "vbox:NetworkAttachmentType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__NetworkAttachmentType(struct soap *soap, const char *URL, enum vbox__NetworkAttachmentType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAttachmentType(soap, p, "vbox:NetworkAttachmentType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__NetworkAttachmentType(struct soap *soap, const char *URL, enum vbox__NetworkAttachmentType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__NetworkAttachmentType(soap, p, "vbox:NetworkAttachmentType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__NetworkAttachmentType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__NetworkAttachmentType(struct soap *soap, const char *URL, enum vbox__NetworkAttachmentType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__NetworkAttachmentType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__NetworkAttachmentType(struct soap *soap, enum vbox__NetworkAttachmentType *p)
{
	if (::soap_read_vbox__NetworkAttachmentType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ScreenLayoutMode(struct soap *soap, enum vbox__ScreenLayoutMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ScreenLayoutMode
	*a = SOAP_DEFAULT_vbox__ScreenLayoutMode;
#else
	*a = (enum vbox__ScreenLayoutMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__ScreenLayoutMode(struct soap *soap, enum vbox__ScreenLayoutMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ScreenLayoutMode(soap, p, "vbox:ScreenLayoutMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ScreenLayoutMode(struct soap *soap, const char *URL, enum vbox__ScreenLayoutMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ScreenLayoutMode(soap, p, "vbox:ScreenLayoutMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ScreenLayoutMode(struct soap *soap, const char *URL, enum vbox__ScreenLayoutMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ScreenLayoutMode(soap, p, "vbox:ScreenLayoutMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ScreenLayoutMode(struct soap *soap, const char *URL, enum vbox__ScreenLayoutMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ScreenLayoutMode(soap, p, "vbox:ScreenLayoutMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ScreenLayoutMode(struct soap *soap, enum vbox__ScreenLayoutMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ScreenLayoutMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ScreenLayoutMode(struct soap *soap, const char *URL, enum vbox__ScreenLayoutMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ScreenLayoutMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ScreenLayoutMode(struct soap *soap, enum vbox__ScreenLayoutMode *p)
{
	if (::soap_read_vbox__ScreenLayoutMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestMonitorStatus(struct soap *soap, enum vbox__GuestMonitorStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestMonitorStatus
	*a = SOAP_DEFAULT_vbox__GuestMonitorStatus;
#else
	*a = (enum vbox__GuestMonitorStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestMonitorStatus(struct soap *soap, enum vbox__GuestMonitorStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestMonitorStatus(soap, p, "vbox:GuestMonitorStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestMonitorStatus(struct soap *soap, const char *URL, enum vbox__GuestMonitorStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMonitorStatus(soap, p, "vbox:GuestMonitorStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestMonitorStatus(struct soap *soap, const char *URL, enum vbox__GuestMonitorStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMonitorStatus(soap, p, "vbox:GuestMonitorStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestMonitorStatus(struct soap *soap, const char *URL, enum vbox__GuestMonitorStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestMonitorStatus(soap, p, "vbox:GuestMonitorStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestMonitorStatus(struct soap *soap, enum vbox__GuestMonitorStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestMonitorStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestMonitorStatus(struct soap *soap, const char *URL, enum vbox__GuestMonitorStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestMonitorStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestMonitorStatus(struct soap *soap, enum vbox__GuestMonitorStatus *p)
{
	if (::soap_read_vbox__GuestMonitorStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FramebufferCapabilities(struct soap *soap, enum vbox__FramebufferCapabilities *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FramebufferCapabilities
	*a = SOAP_DEFAULT_vbox__FramebufferCapabilities;
#else
	*a = (enum vbox__FramebufferCapabilities)0;
#endif
}

/*noinline*/ int soap_write_vbox__FramebufferCapabilities(struct soap *soap, enum vbox__FramebufferCapabilities const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FramebufferCapabilities(soap, p, "vbox:FramebufferCapabilities", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FramebufferCapabilities(struct soap *soap, const char *URL, enum vbox__FramebufferCapabilities const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FramebufferCapabilities(soap, p, "vbox:FramebufferCapabilities", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FramebufferCapabilities(struct soap *soap, const char *URL, enum vbox__FramebufferCapabilities const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FramebufferCapabilities(soap, p, "vbox:FramebufferCapabilities", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FramebufferCapabilities(struct soap *soap, const char *URL, enum vbox__FramebufferCapabilities const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FramebufferCapabilities(soap, p, "vbox:FramebufferCapabilities", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FramebufferCapabilities(struct soap *soap, enum vbox__FramebufferCapabilities *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FramebufferCapabilities(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FramebufferCapabilities(struct soap *soap, const char *URL, enum vbox__FramebufferCapabilities *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FramebufferCapabilities(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FramebufferCapabilities(struct soap *soap, enum vbox__FramebufferCapabilities *p)
{
	if (::soap_read_vbox__FramebufferCapabilities(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__TouchContactState(struct soap *soap, enum vbox__TouchContactState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__TouchContactState
	*a = SOAP_DEFAULT_vbox__TouchContactState;
#else
	*a = (enum vbox__TouchContactState)0;
#endif
}

/*noinline*/ int soap_write_vbox__TouchContactState(struct soap *soap, enum vbox__TouchContactState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__TouchContactState(soap, p, "vbox:TouchContactState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__TouchContactState(struct soap *soap, const char *URL, enum vbox__TouchContactState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__TouchContactState(soap, p, "vbox:TouchContactState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__TouchContactState(struct soap *soap, const char *URL, enum vbox__TouchContactState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__TouchContactState(soap, p, "vbox:TouchContactState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__TouchContactState(struct soap *soap, const char *URL, enum vbox__TouchContactState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__TouchContactState(soap, p, "vbox:TouchContactState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__TouchContactState(struct soap *soap, enum vbox__TouchContactState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__TouchContactState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__TouchContactState(struct soap *soap, const char *URL, enum vbox__TouchContactState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__TouchContactState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__TouchContactState(struct soap *soap, enum vbox__TouchContactState *p)
{
	if (::soap_read_vbox__TouchContactState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MouseButtonState
	*a = SOAP_DEFAULT_vbox__MouseButtonState;
#else
	*a = (enum vbox__MouseButtonState)0;
#endif
}

/*noinline*/ int soap_write_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MouseButtonState(soap, p, "vbox:MouseButtonState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MouseButtonState(struct soap *soap, const char *URL, enum vbox__MouseButtonState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MouseButtonState(soap, p, "vbox:MouseButtonState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MouseButtonState(struct soap *soap, const char *URL, enum vbox__MouseButtonState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MouseButtonState(soap, p, "vbox:MouseButtonState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MouseButtonState(struct soap *soap, const char *URL, enum vbox__MouseButtonState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MouseButtonState(soap, p, "vbox:MouseButtonState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MouseButtonState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MouseButtonState(struct soap *soap, const char *URL, enum vbox__MouseButtonState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MouseButtonState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MouseButtonState(struct soap *soap, enum vbox__MouseButtonState *p)
{
	if (::soap_read_vbox__MouseButtonState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__KeyboardLED(struct soap *soap, enum vbox__KeyboardLED *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__KeyboardLED
	*a = SOAP_DEFAULT_vbox__KeyboardLED;
#else
	*a = (enum vbox__KeyboardLED)0;
#endif
}

/*noinline*/ int soap_write_vbox__KeyboardLED(struct soap *soap, enum vbox__KeyboardLED const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__KeyboardLED(soap, p, "vbox:KeyboardLED", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__KeyboardLED(struct soap *soap, const char *URL, enum vbox__KeyboardLED const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__KeyboardLED(soap, p, "vbox:KeyboardLED", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__KeyboardLED(struct soap *soap, const char *URL, enum vbox__KeyboardLED const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__KeyboardLED(soap, p, "vbox:KeyboardLED", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__KeyboardLED(struct soap *soap, const char *URL, enum vbox__KeyboardLED const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__KeyboardLED(soap, p, "vbox:KeyboardLED", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__KeyboardLED(struct soap *soap, enum vbox__KeyboardLED *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__KeyboardLED(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__KeyboardLED(struct soap *soap, const char *URL, enum vbox__KeyboardLED *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__KeyboardLED(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__KeyboardLED(struct soap *soap, enum vbox__KeyboardLED *p)
{
	if (::soap_read_vbox__KeyboardLED(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PartitionTableType(struct soap *soap, enum vbox__PartitionTableType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PartitionTableType
	*a = SOAP_DEFAULT_vbox__PartitionTableType;
#else
	*a = (enum vbox__PartitionTableType)0;
#endif
}

/*noinline*/ int soap_write_vbox__PartitionTableType(struct soap *soap, enum vbox__PartitionTableType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PartitionTableType(soap, p, "vbox:PartitionTableType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PartitionTableType(struct soap *soap, const char *URL, enum vbox__PartitionTableType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitionTableType(soap, p, "vbox:PartitionTableType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PartitionTableType(struct soap *soap, const char *URL, enum vbox__PartitionTableType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitionTableType(soap, p, "vbox:PartitionTableType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PartitionTableType(struct soap *soap, const char *URL, enum vbox__PartitionTableType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitionTableType(soap, p, "vbox:PartitionTableType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PartitionTableType(struct soap *soap, enum vbox__PartitionTableType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PartitionTableType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PartitionTableType(struct soap *soap, const char *URL, enum vbox__PartitionTableType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PartitionTableType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PartitionTableType(struct soap *soap, enum vbox__PartitionTableType *p)
{
	if (::soap_read_vbox__PartitionTableType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumFormatCapabilities
	*a = SOAP_DEFAULT_vbox__MediumFormatCapabilities;
#else
	*a = (enum vbox__MediumFormatCapabilities)0;
#endif
}

/*noinline*/ int soap_write_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MediumFormatCapabilities(soap, p, "vbox:MediumFormatCapabilities", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MediumFormatCapabilities(struct soap *soap, const char *URL, enum vbox__MediumFormatCapabilities const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumFormatCapabilities(soap, p, "vbox:MediumFormatCapabilities", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MediumFormatCapabilities(struct soap *soap, const char *URL, enum vbox__MediumFormatCapabilities const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumFormatCapabilities(soap, p, "vbox:MediumFormatCapabilities", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MediumFormatCapabilities(struct soap *soap, const char *URL, enum vbox__MediumFormatCapabilities const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumFormatCapabilities(soap, p, "vbox:MediumFormatCapabilities", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MediumFormatCapabilities(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MediumFormatCapabilities(struct soap *soap, const char *URL, enum vbox__MediumFormatCapabilities *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MediumFormatCapabilities(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MediumFormatCapabilities(struct soap *soap, enum vbox__MediumFormatCapabilities *p)
{
	if (::soap_read_vbox__MediumFormatCapabilities(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataFlags
	*a = SOAP_DEFAULT_vbox__DataFlags;
#else
	*a = (enum vbox__DataFlags)0;
#endif
}

/*noinline*/ int soap_write_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DataFlags(soap, p, "vbox:DataFlags", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DataFlags(struct soap *soap, const char *URL, enum vbox__DataFlags const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DataFlags(soap, p, "vbox:DataFlags", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DataFlags(struct soap *soap, const char *URL, enum vbox__DataFlags const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DataFlags(soap, p, "vbox:DataFlags", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DataFlags(struct soap *soap, const char *URL, enum vbox__DataFlags const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DataFlags(soap, p, "vbox:DataFlags", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DataFlags(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DataFlags(struct soap *soap, const char *URL, enum vbox__DataFlags *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DataFlags(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DataFlags(struct soap *soap, enum vbox__DataFlags *p)
{
	if (::soap_read_vbox__DataFlags(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DataType(struct soap *soap, enum vbox__DataType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DataType
	*a = SOAP_DEFAULT_vbox__DataType;
#else
	*a = (enum vbox__DataType)0;
#endif
}

/*noinline*/ int soap_write_vbox__DataType(struct soap *soap, enum vbox__DataType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DataType(soap, p, "vbox:DataType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DataType(struct soap *soap, const char *URL, enum vbox__DataType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DataType(soap, p, "vbox:DataType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DataType(struct soap *soap, const char *URL, enum vbox__DataType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DataType(soap, p, "vbox:DataType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DataType(struct soap *soap, const char *URL, enum vbox__DataType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DataType(soap, p, "vbox:DataType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DataType(struct soap *soap, enum vbox__DataType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DataType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DataType(struct soap *soap, const char *URL, enum vbox__DataType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DataType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DataType(struct soap *soap, enum vbox__DataType *p)
{
	if (::soap_read_vbox__DataType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumVariant
	*a = SOAP_DEFAULT_vbox__MediumVariant;
#else
	*a = (enum vbox__MediumVariant)0;
#endif
}

/*noinline*/ int soap_write_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MediumVariant(soap, p, "vbox:MediumVariant", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MediumVariant(struct soap *soap, const char *URL, enum vbox__MediumVariant const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumVariant(soap, p, "vbox:MediumVariant", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MediumVariant(struct soap *soap, const char *URL, enum vbox__MediumVariant const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumVariant(soap, p, "vbox:MediumVariant", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MediumVariant(struct soap *soap, const char *URL, enum vbox__MediumVariant const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumVariant(soap, p, "vbox:MediumVariant", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MediumVariant(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MediumVariant(struct soap *soap, const char *URL, enum vbox__MediumVariant *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MediumVariant(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MediumVariant(struct soap *soap, enum vbox__MediumVariant *p)
{
	if (::soap_read_vbox__MediumVariant(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MediumType(struct soap *soap, enum vbox__MediumType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumType
	*a = SOAP_DEFAULT_vbox__MediumType;
#else
	*a = (enum vbox__MediumType)0;
#endif
}

/*noinline*/ int soap_write_vbox__MediumType(struct soap *soap, enum vbox__MediumType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MediumType(soap, p, "vbox:MediumType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MediumType(struct soap *soap, const char *URL, enum vbox__MediumType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumType(soap, p, "vbox:MediumType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MediumType(struct soap *soap, const char *URL, enum vbox__MediumType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumType(soap, p, "vbox:MediumType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MediumType(struct soap *soap, const char *URL, enum vbox__MediumType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumType(soap, p, "vbox:MediumType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MediumType(struct soap *soap, enum vbox__MediumType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MediumType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MediumType(struct soap *soap, const char *URL, enum vbox__MediumType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MediumType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MediumType(struct soap *soap, enum vbox__MediumType *p)
{
	if (::soap_read_vbox__MediumType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MediumState(struct soap *soap, enum vbox__MediumState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MediumState
	*a = SOAP_DEFAULT_vbox__MediumState;
#else
	*a = (enum vbox__MediumState)0;
#endif
}

/*noinline*/ int soap_write_vbox__MediumState(struct soap *soap, enum vbox__MediumState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MediumState(soap, p, "vbox:MediumState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MediumState(struct soap *soap, const char *URL, enum vbox__MediumState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumState(soap, p, "vbox:MediumState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MediumState(struct soap *soap, const char *URL, enum vbox__MediumState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumState(soap, p, "vbox:MediumState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MediumState(struct soap *soap, const char *URL, enum vbox__MediumState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MediumState(soap, p, "vbox:MediumState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MediumState(struct soap *soap, enum vbox__MediumState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MediumState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MediumState(struct soap *soap, const char *URL, enum vbox__MediumState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MediumState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MediumState(struct soap *soap, enum vbox__MediumState *p)
{
	if (::soap_read_vbox__MediumState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DirectoryOpenFlag(struct soap *soap, enum vbox__DirectoryOpenFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryOpenFlag
	*a = SOAP_DEFAULT_vbox__DirectoryOpenFlag;
#else
	*a = (enum vbox__DirectoryOpenFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__DirectoryOpenFlag(struct soap *soap, enum vbox__DirectoryOpenFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DirectoryOpenFlag(soap, p, "vbox:DirectoryOpenFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DirectoryOpenFlag(struct soap *soap, const char *URL, enum vbox__DirectoryOpenFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryOpenFlag(soap, p, "vbox:DirectoryOpenFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DirectoryOpenFlag(struct soap *soap, const char *URL, enum vbox__DirectoryOpenFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryOpenFlag(soap, p, "vbox:DirectoryOpenFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DirectoryOpenFlag(struct soap *soap, const char *URL, enum vbox__DirectoryOpenFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryOpenFlag(soap, p, "vbox:DirectoryOpenFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DirectoryOpenFlag(struct soap *soap, enum vbox__DirectoryOpenFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DirectoryOpenFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DirectoryOpenFlag(struct soap *soap, const char *URL, enum vbox__DirectoryOpenFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DirectoryOpenFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DirectoryOpenFlag(struct soap *soap, enum vbox__DirectoryOpenFlag *p)
{
	if (::soap_read_vbox__DirectoryOpenFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DnDAction(struct soap *soap, enum vbox__DnDAction *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DnDAction
	*a = SOAP_DEFAULT_vbox__DnDAction;
#else
	*a = (enum vbox__DnDAction)0;
#endif
}

/*noinline*/ int soap_write_vbox__DnDAction(struct soap *soap, enum vbox__DnDAction const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DnDAction(soap, p, "vbox:DnDAction", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DnDAction(struct soap *soap, const char *URL, enum vbox__DnDAction const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DnDAction(soap, p, "vbox:DnDAction", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DnDAction(struct soap *soap, const char *URL, enum vbox__DnDAction const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DnDAction(soap, p, "vbox:DnDAction", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DnDAction(struct soap *soap, const char *URL, enum vbox__DnDAction const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DnDAction(soap, p, "vbox:DnDAction", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DnDAction(struct soap *soap, enum vbox__DnDAction *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DnDAction(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DnDAction(struct soap *soap, const char *URL, enum vbox__DnDAction *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DnDAction(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DnDAction(struct soap *soap, enum vbox__DnDAction *p)
{
	if (::soap_read_vbox__DnDAction(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FsObjType(struct soap *soap, enum vbox__FsObjType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FsObjType
	*a = SOAP_DEFAULT_vbox__FsObjType;
#else
	*a = (enum vbox__FsObjType)0;
#endif
}

/*noinline*/ int soap_write_vbox__FsObjType(struct soap *soap, enum vbox__FsObjType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FsObjType(soap, p, "vbox:FsObjType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FsObjType(struct soap *soap, const char *URL, enum vbox__FsObjType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjType(soap, p, "vbox:FsObjType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FsObjType(struct soap *soap, const char *URL, enum vbox__FsObjType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjType(soap, p, "vbox:FsObjType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FsObjType(struct soap *soap, const char *URL, enum vbox__FsObjType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjType(soap, p, "vbox:FsObjType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FsObjType(struct soap *soap, enum vbox__FsObjType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FsObjType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FsObjType(struct soap *soap, const char *URL, enum vbox__FsObjType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FsObjType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FsObjType(struct soap *soap, enum vbox__FsObjType *p)
{
	if (::soap_read_vbox__FsObjType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileStatus(struct soap *soap, enum vbox__FileStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileStatus
	*a = SOAP_DEFAULT_vbox__FileStatus;
#else
	*a = (enum vbox__FileStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileStatus(struct soap *soap, enum vbox__FileStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileStatus(soap, p, "vbox:FileStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileStatus(struct soap *soap, const char *URL, enum vbox__FileStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileStatus(soap, p, "vbox:FileStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileStatus(struct soap *soap, const char *URL, enum vbox__FileStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileStatus(soap, p, "vbox:FileStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileStatus(struct soap *soap, const char *URL, enum vbox__FileStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileStatus(soap, p, "vbox:FileStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileStatus(struct soap *soap, enum vbox__FileStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileStatus(struct soap *soap, const char *URL, enum vbox__FileStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileStatus(struct soap *soap, enum vbox__FileStatus *p)
{
	if (::soap_read_vbox__FileStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileOpenExFlag(struct soap *soap, enum vbox__FileOpenExFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileOpenExFlag
	*a = SOAP_DEFAULT_vbox__FileOpenExFlag;
#else
	*a = (enum vbox__FileOpenExFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileOpenExFlag(struct soap *soap, enum vbox__FileOpenExFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileOpenExFlag(soap, p, "vbox:FileOpenExFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileOpenExFlag(struct soap *soap, const char *URL, enum vbox__FileOpenExFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileOpenExFlag(soap, p, "vbox:FileOpenExFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileOpenExFlag(struct soap *soap, const char *URL, enum vbox__FileOpenExFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileOpenExFlag(soap, p, "vbox:FileOpenExFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileOpenExFlag(struct soap *soap, const char *URL, enum vbox__FileOpenExFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileOpenExFlag(soap, p, "vbox:FileOpenExFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileOpenExFlag(struct soap *soap, enum vbox__FileOpenExFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileOpenExFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileOpenExFlag(struct soap *soap, const char *URL, enum vbox__FileOpenExFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileOpenExFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileOpenExFlag(struct soap *soap, enum vbox__FileOpenExFlag *p)
{
	if (::soap_read_vbox__FileOpenExFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileSharingMode(struct soap *soap, enum vbox__FileSharingMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileSharingMode
	*a = SOAP_DEFAULT_vbox__FileSharingMode;
#else
	*a = (enum vbox__FileSharingMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileSharingMode(struct soap *soap, enum vbox__FileSharingMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileSharingMode(soap, p, "vbox:FileSharingMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileSharingMode(struct soap *soap, const char *URL, enum vbox__FileSharingMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileSharingMode(soap, p, "vbox:FileSharingMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileSharingMode(struct soap *soap, const char *URL, enum vbox__FileSharingMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileSharingMode(soap, p, "vbox:FileSharingMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileSharingMode(struct soap *soap, const char *URL, enum vbox__FileSharingMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileSharingMode(soap, p, "vbox:FileSharingMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileSharingMode(struct soap *soap, enum vbox__FileSharingMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileSharingMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileSharingMode(struct soap *soap, const char *URL, enum vbox__FileSharingMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileSharingMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileSharingMode(struct soap *soap, enum vbox__FileSharingMode *p)
{
	if (::soap_read_vbox__FileSharingMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileOpenAction(struct soap *soap, enum vbox__FileOpenAction *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileOpenAction
	*a = SOAP_DEFAULT_vbox__FileOpenAction;
#else
	*a = (enum vbox__FileOpenAction)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileOpenAction(struct soap *soap, enum vbox__FileOpenAction const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileOpenAction(soap, p, "vbox:FileOpenAction", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileOpenAction(struct soap *soap, const char *URL, enum vbox__FileOpenAction const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileOpenAction(soap, p, "vbox:FileOpenAction", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileOpenAction(struct soap *soap, const char *URL, enum vbox__FileOpenAction const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileOpenAction(soap, p, "vbox:FileOpenAction", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileOpenAction(struct soap *soap, const char *URL, enum vbox__FileOpenAction const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileOpenAction(soap, p, "vbox:FileOpenAction", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileOpenAction(struct soap *soap, enum vbox__FileOpenAction *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileOpenAction(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileOpenAction(struct soap *soap, const char *URL, enum vbox__FileOpenAction *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileOpenAction(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileOpenAction(struct soap *soap, enum vbox__FileOpenAction *p)
{
	if (::soap_read_vbox__FileOpenAction(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileAccessMode(struct soap *soap, enum vbox__FileAccessMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileAccessMode
	*a = SOAP_DEFAULT_vbox__FileAccessMode;
#else
	*a = (enum vbox__FileAccessMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileAccessMode(struct soap *soap, enum vbox__FileAccessMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileAccessMode(soap, p, "vbox:FileAccessMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileAccessMode(struct soap *soap, const char *URL, enum vbox__FileAccessMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileAccessMode(soap, p, "vbox:FileAccessMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileAccessMode(struct soap *soap, const char *URL, enum vbox__FileAccessMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileAccessMode(soap, p, "vbox:FileAccessMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileAccessMode(struct soap *soap, const char *URL, enum vbox__FileAccessMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileAccessMode(soap, p, "vbox:FileAccessMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileAccessMode(struct soap *soap, enum vbox__FileAccessMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileAccessMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileAccessMode(struct soap *soap, const char *URL, enum vbox__FileAccessMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileAccessMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileAccessMode(struct soap *soap, enum vbox__FileAccessMode *p)
{
	if (::soap_read_vbox__FileAccessMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DirectoryStatus(struct soap *soap, enum vbox__DirectoryStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryStatus
	*a = SOAP_DEFAULT_vbox__DirectoryStatus;
#else
	*a = (enum vbox__DirectoryStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__DirectoryStatus(struct soap *soap, enum vbox__DirectoryStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DirectoryStatus(soap, p, "vbox:DirectoryStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DirectoryStatus(struct soap *soap, const char *URL, enum vbox__DirectoryStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryStatus(soap, p, "vbox:DirectoryStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DirectoryStatus(struct soap *soap, const char *URL, enum vbox__DirectoryStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryStatus(soap, p, "vbox:DirectoryStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DirectoryStatus(struct soap *soap, const char *URL, enum vbox__DirectoryStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryStatus(soap, p, "vbox:DirectoryStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DirectoryStatus(struct soap *soap, enum vbox__DirectoryStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DirectoryStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DirectoryStatus(struct soap *soap, const char *URL, enum vbox__DirectoryStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DirectoryStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DirectoryStatus(struct soap *soap, enum vbox__DirectoryStatus *p)
{
	if (::soap_read_vbox__DirectoryStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PathStyle(struct soap *soap, enum vbox__PathStyle *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PathStyle
	*a = SOAP_DEFAULT_vbox__PathStyle;
#else
	*a = (enum vbox__PathStyle)0;
#endif
}

/*noinline*/ int soap_write_vbox__PathStyle(struct soap *soap, enum vbox__PathStyle const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PathStyle(soap, p, "vbox:PathStyle", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PathStyle(struct soap *soap, const char *URL, enum vbox__PathStyle const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PathStyle(soap, p, "vbox:PathStyle", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PathStyle(struct soap *soap, const char *URL, enum vbox__PathStyle const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PathStyle(soap, p, "vbox:PathStyle", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PathStyle(struct soap *soap, const char *URL, enum vbox__PathStyle const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PathStyle(soap, p, "vbox:PathStyle", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PathStyle(struct soap *soap, enum vbox__PathStyle *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PathStyle(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PathStyle(struct soap *soap, const char *URL, enum vbox__PathStyle *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PathStyle(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PathStyle(struct soap *soap, enum vbox__PathStyle *p)
{
	if (::soap_read_vbox__PathStyle(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessInputStatus(struct soap *soap, enum vbox__ProcessInputStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessInputStatus
	*a = SOAP_DEFAULT_vbox__ProcessInputStatus;
#else
	*a = (enum vbox__ProcessInputStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessInputStatus(struct soap *soap, enum vbox__ProcessInputStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessInputStatus(soap, p, "vbox:ProcessInputStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessInputStatus(struct soap *soap, const char *URL, enum vbox__ProcessInputStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessInputStatus(soap, p, "vbox:ProcessInputStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessInputStatus(struct soap *soap, const char *URL, enum vbox__ProcessInputStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessInputStatus(soap, p, "vbox:ProcessInputStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessInputStatus(struct soap *soap, const char *URL, enum vbox__ProcessInputStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessInputStatus(soap, p, "vbox:ProcessInputStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessInputStatus(struct soap *soap, enum vbox__ProcessInputStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessInputStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessInputStatus(struct soap *soap, const char *URL, enum vbox__ProcessInputStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessInputStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessInputStatus(struct soap *soap, enum vbox__ProcessInputStatus *p)
{
	if (::soap_read_vbox__ProcessInputStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessStatus(struct soap *soap, enum vbox__ProcessStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessStatus
	*a = SOAP_DEFAULT_vbox__ProcessStatus;
#else
	*a = (enum vbox__ProcessStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessStatus(struct soap *soap, enum vbox__ProcessStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessStatus(soap, p, "vbox:ProcessStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessStatus(struct soap *soap, const char *URL, enum vbox__ProcessStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessStatus(soap, p, "vbox:ProcessStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessStatus(struct soap *soap, const char *URL, enum vbox__ProcessStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessStatus(soap, p, "vbox:ProcessStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessStatus(struct soap *soap, const char *URL, enum vbox__ProcessStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessStatus(soap, p, "vbox:ProcessStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessStatus(struct soap *soap, enum vbox__ProcessStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessStatus(struct soap *soap, const char *URL, enum vbox__ProcessStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessStatus(struct soap *soap, enum vbox__ProcessStatus *p)
{
	if (::soap_read_vbox__ProcessStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SymlinkReadFlag(struct soap *soap, enum vbox__SymlinkReadFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SymlinkReadFlag
	*a = SOAP_DEFAULT_vbox__SymlinkReadFlag;
#else
	*a = (enum vbox__SymlinkReadFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__SymlinkReadFlag(struct soap *soap, enum vbox__SymlinkReadFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SymlinkReadFlag(soap, p, "vbox:SymlinkReadFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SymlinkReadFlag(struct soap *soap, const char *URL, enum vbox__SymlinkReadFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkReadFlag(soap, p, "vbox:SymlinkReadFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SymlinkReadFlag(struct soap *soap, const char *URL, enum vbox__SymlinkReadFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkReadFlag(soap, p, "vbox:SymlinkReadFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SymlinkReadFlag(struct soap *soap, const char *URL, enum vbox__SymlinkReadFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkReadFlag(soap, p, "vbox:SymlinkReadFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SymlinkReadFlag(struct soap *soap, enum vbox__SymlinkReadFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SymlinkReadFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SymlinkReadFlag(struct soap *soap, const char *URL, enum vbox__SymlinkReadFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SymlinkReadFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SymlinkReadFlag(struct soap *soap, enum vbox__SymlinkReadFlag *p)
{
	if (::soap_read_vbox__SymlinkReadFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SymlinkType(struct soap *soap, enum vbox__SymlinkType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SymlinkType
	*a = SOAP_DEFAULT_vbox__SymlinkType;
#else
	*a = (enum vbox__SymlinkType)0;
#endif
}

/*noinline*/ int soap_write_vbox__SymlinkType(struct soap *soap, enum vbox__SymlinkType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SymlinkType(soap, p, "vbox:SymlinkType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SymlinkType(struct soap *soap, const char *URL, enum vbox__SymlinkType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkType(soap, p, "vbox:SymlinkType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SymlinkType(struct soap *soap, const char *URL, enum vbox__SymlinkType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkType(soap, p, "vbox:SymlinkType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SymlinkType(struct soap *soap, const char *URL, enum vbox__SymlinkType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SymlinkType(soap, p, "vbox:SymlinkType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SymlinkType(struct soap *soap, enum vbox__SymlinkType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SymlinkType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SymlinkType(struct soap *soap, const char *URL, enum vbox__SymlinkType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SymlinkType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SymlinkType(struct soap *soap, enum vbox__SymlinkType *p)
{
	if (::soap_read_vbox__SymlinkType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessPriority(struct soap *soap, enum vbox__ProcessPriority *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessPriority
	*a = SOAP_DEFAULT_vbox__ProcessPriority;
#else
	*a = (enum vbox__ProcessPriority)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessPriority(struct soap *soap, enum vbox__ProcessPriority const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessPriority(soap, p, "vbox:ProcessPriority", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessPriority(struct soap *soap, const char *URL, enum vbox__ProcessPriority const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessPriority(soap, p, "vbox:ProcessPriority", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessPriority(struct soap *soap, const char *URL, enum vbox__ProcessPriority const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessPriority(soap, p, "vbox:ProcessPriority", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessPriority(struct soap *soap, const char *URL, enum vbox__ProcessPriority const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessPriority(soap, p, "vbox:ProcessPriority", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessPriority(struct soap *soap, enum vbox__ProcessPriority *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessPriority(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessPriority(struct soap *soap, const char *URL, enum vbox__ProcessPriority *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessPriority(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessPriority(struct soap *soap, enum vbox__ProcessPriority *p)
{
	if (::soap_read_vbox__ProcessPriority(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessCreateFlag(struct soap *soap, enum vbox__ProcessCreateFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessCreateFlag
	*a = SOAP_DEFAULT_vbox__ProcessCreateFlag;
#else
	*a = (enum vbox__ProcessCreateFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessCreateFlag(struct soap *soap, enum vbox__ProcessCreateFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessCreateFlag(soap, p, "vbox:ProcessCreateFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessCreateFlag(struct soap *soap, const char *URL, enum vbox__ProcessCreateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessCreateFlag(soap, p, "vbox:ProcessCreateFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessCreateFlag(struct soap *soap, const char *URL, enum vbox__ProcessCreateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessCreateFlag(soap, p, "vbox:ProcessCreateFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessCreateFlag(struct soap *soap, const char *URL, enum vbox__ProcessCreateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessCreateFlag(soap, p, "vbox:ProcessCreateFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessCreateFlag(struct soap *soap, enum vbox__ProcessCreateFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessCreateFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessCreateFlag(struct soap *soap, const char *URL, enum vbox__ProcessCreateFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessCreateFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessCreateFlag(struct soap *soap, enum vbox__ProcessCreateFlag *p)
{
	if (::soap_read_vbox__ProcessCreateFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FsObjRenameFlag(struct soap *soap, enum vbox__FsObjRenameFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FsObjRenameFlag
	*a = SOAP_DEFAULT_vbox__FsObjRenameFlag;
#else
	*a = (enum vbox__FsObjRenameFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__FsObjRenameFlag(struct soap *soap, enum vbox__FsObjRenameFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FsObjRenameFlag(soap, p, "vbox:FsObjRenameFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FsObjRenameFlag(struct soap *soap, const char *URL, enum vbox__FsObjRenameFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjRenameFlag(soap, p, "vbox:FsObjRenameFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FsObjRenameFlag(struct soap *soap, const char *URL, enum vbox__FsObjRenameFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjRenameFlag(soap, p, "vbox:FsObjRenameFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FsObjRenameFlag(struct soap *soap, const char *URL, enum vbox__FsObjRenameFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjRenameFlag(soap, p, "vbox:FsObjRenameFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FsObjRenameFlag(struct soap *soap, enum vbox__FsObjRenameFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FsObjRenameFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FsObjRenameFlag(struct soap *soap, const char *URL, enum vbox__FsObjRenameFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FsObjRenameFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FsObjRenameFlag(struct soap *soap, enum vbox__FsObjRenameFlag *p)
{
	if (::soap_read_vbox__FsObjRenameFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DirectoryRemoveRecFlag(struct soap *soap, enum vbox__DirectoryRemoveRecFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryRemoveRecFlag
	*a = SOAP_DEFAULT_vbox__DirectoryRemoveRecFlag;
#else
	*a = (enum vbox__DirectoryRemoveRecFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__DirectoryRemoveRecFlag(struct soap *soap, enum vbox__DirectoryRemoveRecFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DirectoryRemoveRecFlag(soap, p, "vbox:DirectoryRemoveRecFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *URL, enum vbox__DirectoryRemoveRecFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryRemoveRecFlag(soap, p, "vbox:DirectoryRemoveRecFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *URL, enum vbox__DirectoryRemoveRecFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryRemoveRecFlag(soap, p, "vbox:DirectoryRemoveRecFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *URL, enum vbox__DirectoryRemoveRecFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryRemoveRecFlag(soap, p, "vbox:DirectoryRemoveRecFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DirectoryRemoveRecFlag(struct soap *soap, enum vbox__DirectoryRemoveRecFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DirectoryRemoveRecFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DirectoryRemoveRecFlag(struct soap *soap, const char *URL, enum vbox__DirectoryRemoveRecFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DirectoryRemoveRecFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DirectoryRemoveRecFlag(struct soap *soap, enum vbox__DirectoryRemoveRecFlag *p)
{
	if (::soap_read_vbox__DirectoryRemoveRecFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DirectoryCopyFlag(struct soap *soap, enum vbox__DirectoryCopyFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryCopyFlag
	*a = SOAP_DEFAULT_vbox__DirectoryCopyFlag;
#else
	*a = (enum vbox__DirectoryCopyFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__DirectoryCopyFlag(struct soap *soap, enum vbox__DirectoryCopyFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DirectoryCopyFlag(soap, p, "vbox:DirectoryCopyFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DirectoryCopyFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCopyFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryCopyFlag(soap, p, "vbox:DirectoryCopyFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DirectoryCopyFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCopyFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryCopyFlag(soap, p, "vbox:DirectoryCopyFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DirectoryCopyFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCopyFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryCopyFlag(soap, p, "vbox:DirectoryCopyFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DirectoryCopyFlag(struct soap *soap, enum vbox__DirectoryCopyFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DirectoryCopyFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DirectoryCopyFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCopyFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DirectoryCopyFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DirectoryCopyFlag(struct soap *soap, enum vbox__DirectoryCopyFlag *p)
{
	if (::soap_read_vbox__DirectoryCopyFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DirectoryCreateFlag(struct soap *soap, enum vbox__DirectoryCreateFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DirectoryCreateFlag
	*a = SOAP_DEFAULT_vbox__DirectoryCreateFlag;
#else
	*a = (enum vbox__DirectoryCreateFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__DirectoryCreateFlag(struct soap *soap, enum vbox__DirectoryCreateFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DirectoryCreateFlag(soap, p, "vbox:DirectoryCreateFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DirectoryCreateFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCreateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryCreateFlag(soap, p, "vbox:DirectoryCreateFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DirectoryCreateFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCreateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryCreateFlag(soap, p, "vbox:DirectoryCreateFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DirectoryCreateFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCreateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DirectoryCreateFlag(soap, p, "vbox:DirectoryCreateFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DirectoryCreateFlag(struct soap *soap, enum vbox__DirectoryCreateFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DirectoryCreateFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DirectoryCreateFlag(struct soap *soap, const char *URL, enum vbox__DirectoryCreateFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DirectoryCreateFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DirectoryCreateFlag(struct soap *soap, enum vbox__DirectoryCreateFlag *p)
{
	if (::soap_read_vbox__DirectoryCreateFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FsObjMoveFlag(struct soap *soap, enum vbox__FsObjMoveFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FsObjMoveFlag
	*a = SOAP_DEFAULT_vbox__FsObjMoveFlag;
#else
	*a = (enum vbox__FsObjMoveFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__FsObjMoveFlag(struct soap *soap, enum vbox__FsObjMoveFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FsObjMoveFlag(soap, p, "vbox:FsObjMoveFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FsObjMoveFlag(struct soap *soap, const char *URL, enum vbox__FsObjMoveFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjMoveFlag(soap, p, "vbox:FsObjMoveFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FsObjMoveFlag(struct soap *soap, const char *URL, enum vbox__FsObjMoveFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjMoveFlag(soap, p, "vbox:FsObjMoveFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FsObjMoveFlag(struct soap *soap, const char *URL, enum vbox__FsObjMoveFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FsObjMoveFlag(soap, p, "vbox:FsObjMoveFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FsObjMoveFlag(struct soap *soap, enum vbox__FsObjMoveFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FsObjMoveFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FsObjMoveFlag(struct soap *soap, const char *URL, enum vbox__FsObjMoveFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FsObjMoveFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FsObjMoveFlag(struct soap *soap, enum vbox__FsObjMoveFlag *p)
{
	if (::soap_read_vbox__FsObjMoveFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileCopyFlag(struct soap *soap, enum vbox__FileCopyFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileCopyFlag
	*a = SOAP_DEFAULT_vbox__FileCopyFlag;
#else
	*a = (enum vbox__FileCopyFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileCopyFlag(struct soap *soap, enum vbox__FileCopyFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileCopyFlag(soap, p, "vbox:FileCopyFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileCopyFlag(struct soap *soap, const char *URL, enum vbox__FileCopyFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileCopyFlag(soap, p, "vbox:FileCopyFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileCopyFlag(struct soap *soap, const char *URL, enum vbox__FileCopyFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileCopyFlag(soap, p, "vbox:FileCopyFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileCopyFlag(struct soap *soap, const char *URL, enum vbox__FileCopyFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileCopyFlag(soap, p, "vbox:FileCopyFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileCopyFlag(struct soap *soap, enum vbox__FileCopyFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileCopyFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileCopyFlag(struct soap *soap, const char *URL, enum vbox__FileCopyFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileCopyFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileCopyFlag(struct soap *soap, enum vbox__FileCopyFlag *p)
{
	if (::soap_read_vbox__FileCopyFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessWaitResult(struct soap *soap, enum vbox__ProcessWaitResult *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessWaitResult
	*a = SOAP_DEFAULT_vbox__ProcessWaitResult;
#else
	*a = (enum vbox__ProcessWaitResult)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessWaitResult(struct soap *soap, enum vbox__ProcessWaitResult const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessWaitResult(soap, p, "vbox:ProcessWaitResult", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessWaitResult(struct soap *soap, const char *URL, enum vbox__ProcessWaitResult const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessWaitResult(soap, p, "vbox:ProcessWaitResult", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessWaitResult(struct soap *soap, const char *URL, enum vbox__ProcessWaitResult const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessWaitResult(soap, p, "vbox:ProcessWaitResult", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessWaitResult(struct soap *soap, const char *URL, enum vbox__ProcessWaitResult const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessWaitResult(soap, p, "vbox:ProcessWaitResult", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessWaitResult(struct soap *soap, enum vbox__ProcessWaitResult *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessWaitResult(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessWaitResult(struct soap *soap, const char *URL, enum vbox__ProcessWaitResult *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessWaitResult(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessWaitResult(struct soap *soap, enum vbox__ProcessWaitResult *p)
{
	if (::soap_read_vbox__ProcessWaitResult(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessWaitForFlag(struct soap *soap, enum vbox__ProcessWaitForFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessWaitForFlag
	*a = SOAP_DEFAULT_vbox__ProcessWaitForFlag;
#else
	*a = (enum vbox__ProcessWaitForFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessWaitForFlag(struct soap *soap, enum vbox__ProcessWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessWaitForFlag(soap, p, "vbox:ProcessWaitForFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessWaitForFlag(struct soap *soap, const char *URL, enum vbox__ProcessWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessWaitForFlag(soap, p, "vbox:ProcessWaitForFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessWaitForFlag(struct soap *soap, const char *URL, enum vbox__ProcessWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessWaitForFlag(soap, p, "vbox:ProcessWaitForFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessWaitForFlag(struct soap *soap, const char *URL, enum vbox__ProcessWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessWaitForFlag(soap, p, "vbox:ProcessWaitForFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessWaitForFlag(struct soap *soap, enum vbox__ProcessWaitForFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessWaitForFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessWaitForFlag(struct soap *soap, const char *URL, enum vbox__ProcessWaitForFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessWaitForFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessWaitForFlag(struct soap *soap, enum vbox__ProcessWaitForFlag *p)
{
	if (::soap_read_vbox__ProcessWaitForFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessOutputFlag(struct soap *soap, enum vbox__ProcessOutputFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessOutputFlag
	*a = SOAP_DEFAULT_vbox__ProcessOutputFlag;
#else
	*a = (enum vbox__ProcessOutputFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessOutputFlag(struct soap *soap, enum vbox__ProcessOutputFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessOutputFlag(soap, p, "vbox:ProcessOutputFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessOutputFlag(struct soap *soap, const char *URL, enum vbox__ProcessOutputFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessOutputFlag(soap, p, "vbox:ProcessOutputFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessOutputFlag(struct soap *soap, const char *URL, enum vbox__ProcessOutputFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessOutputFlag(soap, p, "vbox:ProcessOutputFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessOutputFlag(struct soap *soap, const char *URL, enum vbox__ProcessOutputFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessOutputFlag(soap, p, "vbox:ProcessOutputFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessOutputFlag(struct soap *soap, enum vbox__ProcessOutputFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessOutputFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessOutputFlag(struct soap *soap, const char *URL, enum vbox__ProcessOutputFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessOutputFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessOutputFlag(struct soap *soap, enum vbox__ProcessOutputFlag *p)
{
	if (::soap_read_vbox__ProcessOutputFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessInputFlag(struct soap *soap, enum vbox__ProcessInputFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessInputFlag
	*a = SOAP_DEFAULT_vbox__ProcessInputFlag;
#else
	*a = (enum vbox__ProcessInputFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessInputFlag(struct soap *soap, enum vbox__ProcessInputFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessInputFlag(soap, p, "vbox:ProcessInputFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessInputFlag(struct soap *soap, const char *URL, enum vbox__ProcessInputFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessInputFlag(soap, p, "vbox:ProcessInputFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessInputFlag(struct soap *soap, const char *URL, enum vbox__ProcessInputFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessInputFlag(soap, p, "vbox:ProcessInputFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessInputFlag(struct soap *soap, const char *URL, enum vbox__ProcessInputFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessInputFlag(soap, p, "vbox:ProcessInputFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessInputFlag(struct soap *soap, enum vbox__ProcessInputFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessInputFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessInputFlag(struct soap *soap, const char *URL, enum vbox__ProcessInputFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessInputFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessInputFlag(struct soap *soap, enum vbox__ProcessInputFlag *p)
{
	if (::soap_read_vbox__ProcessInputFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FileSeekOrigin(struct soap *soap, enum vbox__FileSeekOrigin *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FileSeekOrigin
	*a = SOAP_DEFAULT_vbox__FileSeekOrigin;
#else
	*a = (enum vbox__FileSeekOrigin)0;
#endif
}

/*noinline*/ int soap_write_vbox__FileSeekOrigin(struct soap *soap, enum vbox__FileSeekOrigin const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FileSeekOrigin(soap, p, "vbox:FileSeekOrigin", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FileSeekOrigin(struct soap *soap, const char *URL, enum vbox__FileSeekOrigin const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileSeekOrigin(soap, p, "vbox:FileSeekOrigin", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FileSeekOrigin(struct soap *soap, const char *URL, enum vbox__FileSeekOrigin const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileSeekOrigin(soap, p, "vbox:FileSeekOrigin", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FileSeekOrigin(struct soap *soap, const char *URL, enum vbox__FileSeekOrigin const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FileSeekOrigin(soap, p, "vbox:FileSeekOrigin", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FileSeekOrigin(struct soap *soap, enum vbox__FileSeekOrigin *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FileSeekOrigin(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FileSeekOrigin(struct soap *soap, const char *URL, enum vbox__FileSeekOrigin *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FileSeekOrigin(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FileSeekOrigin(struct soap *soap, enum vbox__FileSeekOrigin *p)
{
	if (::soap_read_vbox__FileSeekOrigin(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestUserState(struct soap *soap, enum vbox__GuestUserState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestUserState
	*a = SOAP_DEFAULT_vbox__GuestUserState;
#else
	*a = (enum vbox__GuestUserState)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestUserState(struct soap *soap, enum vbox__GuestUserState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestUserState(soap, p, "vbox:GuestUserState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestUserState(struct soap *soap, const char *URL, enum vbox__GuestUserState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestUserState(soap, p, "vbox:GuestUserState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestUserState(struct soap *soap, const char *URL, enum vbox__GuestUserState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestUserState(soap, p, "vbox:GuestUserState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestUserState(struct soap *soap, const char *URL, enum vbox__GuestUserState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestUserState(soap, p, "vbox:GuestUserState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestUserState(struct soap *soap, enum vbox__GuestUserState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestUserState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestUserState(struct soap *soap, const char *URL, enum vbox__GuestUserState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestUserState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestUserState(struct soap *soap, enum vbox__GuestUserState *p)
{
	if (::soap_read_vbox__GuestUserState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestSessionWaitResult(struct soap *soap, enum vbox__GuestSessionWaitResult *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestSessionWaitResult
	*a = SOAP_DEFAULT_vbox__GuestSessionWaitResult;
#else
	*a = (enum vbox__GuestSessionWaitResult)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestSessionWaitResult(struct soap *soap, enum vbox__GuestSessionWaitResult const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestSessionWaitResult(soap, p, "vbox:GuestSessionWaitResult", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestSessionWaitResult(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitResult const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionWaitResult(soap, p, "vbox:GuestSessionWaitResult", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestSessionWaitResult(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitResult const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionWaitResult(soap, p, "vbox:GuestSessionWaitResult", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestSessionWaitResult(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitResult const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionWaitResult(soap, p, "vbox:GuestSessionWaitResult", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestSessionWaitResult(struct soap *soap, enum vbox__GuestSessionWaitResult *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestSessionWaitResult(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestSessionWaitResult(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitResult *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestSessionWaitResult(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestSessionWaitResult(struct soap *soap, enum vbox__GuestSessionWaitResult *p)
{
	if (::soap_read_vbox__GuestSessionWaitResult(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestSessionWaitForFlag(struct soap *soap, enum vbox__GuestSessionWaitForFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestSessionWaitForFlag
	*a = SOAP_DEFAULT_vbox__GuestSessionWaitForFlag;
#else
	*a = (enum vbox__GuestSessionWaitForFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestSessionWaitForFlag(struct soap *soap, enum vbox__GuestSessionWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestSessionWaitForFlag(soap, p, "vbox:GuestSessionWaitForFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestSessionWaitForFlag(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionWaitForFlag(soap, p, "vbox:GuestSessionWaitForFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestSessionWaitForFlag(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionWaitForFlag(soap, p, "vbox:GuestSessionWaitForFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestSessionWaitForFlag(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitForFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionWaitForFlag(soap, p, "vbox:GuestSessionWaitForFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestSessionWaitForFlag(struct soap *soap, enum vbox__GuestSessionWaitForFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestSessionWaitForFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestSessionWaitForFlag(struct soap *soap, const char *URL, enum vbox__GuestSessionWaitForFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestSessionWaitForFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestSessionWaitForFlag(struct soap *soap, enum vbox__GuestSessionWaitForFlag *p)
{
	if (::soap_read_vbox__GuestSessionWaitForFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestSessionStatus(struct soap *soap, enum vbox__GuestSessionStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestSessionStatus
	*a = SOAP_DEFAULT_vbox__GuestSessionStatus;
#else
	*a = (enum vbox__GuestSessionStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestSessionStatus(struct soap *soap, enum vbox__GuestSessionStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestSessionStatus(soap, p, "vbox:GuestSessionStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestSessionStatus(struct soap *soap, const char *URL, enum vbox__GuestSessionStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionStatus(soap, p, "vbox:GuestSessionStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestSessionStatus(struct soap *soap, const char *URL, enum vbox__GuestSessionStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionStatus(soap, p, "vbox:GuestSessionStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestSessionStatus(struct soap *soap, const char *URL, enum vbox__GuestSessionStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestSessionStatus(soap, p, "vbox:GuestSessionStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestSessionStatus(struct soap *soap, enum vbox__GuestSessionStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestSessionStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestSessionStatus(struct soap *soap, const char *URL, enum vbox__GuestSessionStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestSessionStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestSessionStatus(struct soap *soap, enum vbox__GuestSessionStatus *p)
{
	if (::soap_read_vbox__GuestSessionStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GuestShutdownFlag(struct soap *soap, enum vbox__GuestShutdownFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GuestShutdownFlag
	*a = SOAP_DEFAULT_vbox__GuestShutdownFlag;
#else
	*a = (enum vbox__GuestShutdownFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__GuestShutdownFlag(struct soap *soap, enum vbox__GuestShutdownFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GuestShutdownFlag(soap, p, "vbox:GuestShutdownFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GuestShutdownFlag(struct soap *soap, const char *URL, enum vbox__GuestShutdownFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestShutdownFlag(soap, p, "vbox:GuestShutdownFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GuestShutdownFlag(struct soap *soap, const char *URL, enum vbox__GuestShutdownFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestShutdownFlag(soap, p, "vbox:GuestShutdownFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GuestShutdownFlag(struct soap *soap, const char *URL, enum vbox__GuestShutdownFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GuestShutdownFlag(soap, p, "vbox:GuestShutdownFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GuestShutdownFlag(struct soap *soap, enum vbox__GuestShutdownFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GuestShutdownFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GuestShutdownFlag(struct soap *soap, const char *URL, enum vbox__GuestShutdownFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GuestShutdownFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GuestShutdownFlag(struct soap *soap, enum vbox__GuestShutdownFlag *p)
{
	if (::soap_read_vbox__GuestShutdownFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AdditionsUpdateFlag(struct soap *soap, enum vbox__AdditionsUpdateFlag *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsUpdateFlag
	*a = SOAP_DEFAULT_vbox__AdditionsUpdateFlag;
#else
	*a = (enum vbox__AdditionsUpdateFlag)0;
#endif
}

/*noinline*/ int soap_write_vbox__AdditionsUpdateFlag(struct soap *soap, enum vbox__AdditionsUpdateFlag const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AdditionsUpdateFlag(soap, p, "vbox:AdditionsUpdateFlag", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AdditionsUpdateFlag(struct soap *soap, const char *URL, enum vbox__AdditionsUpdateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsUpdateFlag(soap, p, "vbox:AdditionsUpdateFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AdditionsUpdateFlag(struct soap *soap, const char *URL, enum vbox__AdditionsUpdateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsUpdateFlag(soap, p, "vbox:AdditionsUpdateFlag", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AdditionsUpdateFlag(struct soap *soap, const char *URL, enum vbox__AdditionsUpdateFlag const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsUpdateFlag(soap, p, "vbox:AdditionsUpdateFlag", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AdditionsUpdateFlag(struct soap *soap, enum vbox__AdditionsUpdateFlag *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AdditionsUpdateFlag(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AdditionsUpdateFlag(struct soap *soap, const char *URL, enum vbox__AdditionsUpdateFlag *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AdditionsUpdateFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AdditionsUpdateFlag(struct soap *soap, enum vbox__AdditionsUpdateFlag *p)
{
	if (::soap_read_vbox__AdditionsUpdateFlag(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AdditionsRunLevelType(struct soap *soap, enum vbox__AdditionsRunLevelType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsRunLevelType
	*a = SOAP_DEFAULT_vbox__AdditionsRunLevelType;
#else
	*a = (enum vbox__AdditionsRunLevelType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AdditionsRunLevelType(struct soap *soap, enum vbox__AdditionsRunLevelType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AdditionsRunLevelType(soap, p, "vbox:AdditionsRunLevelType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AdditionsRunLevelType(struct soap *soap, const char *URL, enum vbox__AdditionsRunLevelType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsRunLevelType(soap, p, "vbox:AdditionsRunLevelType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AdditionsRunLevelType(struct soap *soap, const char *URL, enum vbox__AdditionsRunLevelType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsRunLevelType(soap, p, "vbox:AdditionsRunLevelType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AdditionsRunLevelType(struct soap *soap, const char *URL, enum vbox__AdditionsRunLevelType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsRunLevelType(soap, p, "vbox:AdditionsRunLevelType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AdditionsRunLevelType(struct soap *soap, enum vbox__AdditionsRunLevelType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AdditionsRunLevelType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AdditionsRunLevelType(struct soap *soap, const char *URL, enum vbox__AdditionsRunLevelType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AdditionsRunLevelType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AdditionsRunLevelType(struct soap *soap, enum vbox__AdditionsRunLevelType *p)
{
	if (::soap_read_vbox__AdditionsRunLevelType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AdditionsFacilityStatus(struct soap *soap, enum vbox__AdditionsFacilityStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsFacilityStatus
	*a = SOAP_DEFAULT_vbox__AdditionsFacilityStatus;
#else
	*a = (enum vbox__AdditionsFacilityStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__AdditionsFacilityStatus(struct soap *soap, enum vbox__AdditionsFacilityStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AdditionsFacilityStatus(soap, p, "vbox:AdditionsFacilityStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AdditionsFacilityStatus(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityStatus(soap, p, "vbox:AdditionsFacilityStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AdditionsFacilityStatus(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityStatus(soap, p, "vbox:AdditionsFacilityStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AdditionsFacilityStatus(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityStatus(soap, p, "vbox:AdditionsFacilityStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AdditionsFacilityStatus(struct soap *soap, enum vbox__AdditionsFacilityStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AdditionsFacilityStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AdditionsFacilityStatus(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AdditionsFacilityStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AdditionsFacilityStatus(struct soap *soap, enum vbox__AdditionsFacilityStatus *p)
{
	if (::soap_read_vbox__AdditionsFacilityStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AdditionsFacilityClass(struct soap *soap, enum vbox__AdditionsFacilityClass *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsFacilityClass
	*a = SOAP_DEFAULT_vbox__AdditionsFacilityClass;
#else
	*a = (enum vbox__AdditionsFacilityClass)0;
#endif
}

/*noinline*/ int soap_write_vbox__AdditionsFacilityClass(struct soap *soap, enum vbox__AdditionsFacilityClass const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AdditionsFacilityClass(soap, p, "vbox:AdditionsFacilityClass", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AdditionsFacilityClass(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityClass const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityClass(soap, p, "vbox:AdditionsFacilityClass", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AdditionsFacilityClass(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityClass const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityClass(soap, p, "vbox:AdditionsFacilityClass", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AdditionsFacilityClass(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityClass const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityClass(soap, p, "vbox:AdditionsFacilityClass", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AdditionsFacilityClass(struct soap *soap, enum vbox__AdditionsFacilityClass *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AdditionsFacilityClass(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AdditionsFacilityClass(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityClass *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AdditionsFacilityClass(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AdditionsFacilityClass(struct soap *soap, enum vbox__AdditionsFacilityClass *p)
{
	if (::soap_read_vbox__AdditionsFacilityClass(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AdditionsFacilityType(struct soap *soap, enum vbox__AdditionsFacilityType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AdditionsFacilityType
	*a = SOAP_DEFAULT_vbox__AdditionsFacilityType;
#else
	*a = (enum vbox__AdditionsFacilityType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AdditionsFacilityType(struct soap *soap, enum vbox__AdditionsFacilityType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AdditionsFacilityType(soap, p, "vbox:AdditionsFacilityType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AdditionsFacilityType(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityType(soap, p, "vbox:AdditionsFacilityType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AdditionsFacilityType(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityType(soap, p, "vbox:AdditionsFacilityType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AdditionsFacilityType(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AdditionsFacilityType(soap, p, "vbox:AdditionsFacilityType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AdditionsFacilityType(struct soap *soap, enum vbox__AdditionsFacilityType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AdditionsFacilityType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AdditionsFacilityType(struct soap *soap, const char *URL, enum vbox__AdditionsFacilityType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AdditionsFacilityType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AdditionsFacilityType(struct soap *soap, enum vbox__AdditionsFacilityType *p)
{
	if (::soap_read_vbox__AdditionsFacilityType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProxyMode(struct soap *soap, enum vbox__ProxyMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProxyMode
	*a = SOAP_DEFAULT_vbox__ProxyMode;
#else
	*a = (enum vbox__ProxyMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProxyMode(struct soap *soap, enum vbox__ProxyMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProxyMode(soap, p, "vbox:ProxyMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProxyMode(struct soap *soap, const char *URL, enum vbox__ProxyMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProxyMode(soap, p, "vbox:ProxyMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProxyMode(struct soap *soap, const char *URL, enum vbox__ProxyMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProxyMode(soap, p, "vbox:ProxyMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProxyMode(struct soap *soap, const char *URL, enum vbox__ProxyMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProxyMode(soap, p, "vbox:ProxyMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProxyMode(struct soap *soap, enum vbox__ProxyMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProxyMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProxyMode(struct soap *soap, const char *URL, enum vbox__ProxyMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProxyMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProxyMode(struct soap *soap, enum vbox__ProxyMode *p)
{
	if (::soap_read_vbox__ProxyMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__UpdateState(struct soap *soap, enum vbox__UpdateState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__UpdateState
	*a = SOAP_DEFAULT_vbox__UpdateState;
#else
	*a = (enum vbox__UpdateState)0;
#endif
}

/*noinline*/ int soap_write_vbox__UpdateState(struct soap *soap, enum vbox__UpdateState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__UpdateState(soap, p, "vbox:UpdateState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__UpdateState(struct soap *soap, const char *URL, enum vbox__UpdateState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateState(soap, p, "vbox:UpdateState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__UpdateState(struct soap *soap, const char *URL, enum vbox__UpdateState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateState(soap, p, "vbox:UpdateState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__UpdateState(struct soap *soap, const char *URL, enum vbox__UpdateState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateState(soap, p, "vbox:UpdateState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__UpdateState(struct soap *soap, enum vbox__UpdateState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__UpdateState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__UpdateState(struct soap *soap, const char *URL, enum vbox__UpdateState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__UpdateState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__UpdateState(struct soap *soap, enum vbox__UpdateState *p)
{
	if (::soap_read_vbox__UpdateState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__UpdateSeverity(struct soap *soap, enum vbox__UpdateSeverity *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__UpdateSeverity
	*a = SOAP_DEFAULT_vbox__UpdateSeverity;
#else
	*a = (enum vbox__UpdateSeverity)0;
#endif
}

/*noinline*/ int soap_write_vbox__UpdateSeverity(struct soap *soap, enum vbox__UpdateSeverity const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__UpdateSeverity(soap, p, "vbox:UpdateSeverity", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__UpdateSeverity(struct soap *soap, const char *URL, enum vbox__UpdateSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateSeverity(soap, p, "vbox:UpdateSeverity", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__UpdateSeverity(struct soap *soap, const char *URL, enum vbox__UpdateSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateSeverity(soap, p, "vbox:UpdateSeverity", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__UpdateSeverity(struct soap *soap, const char *URL, enum vbox__UpdateSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateSeverity(soap, p, "vbox:UpdateSeverity", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__UpdateSeverity(struct soap *soap, enum vbox__UpdateSeverity *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__UpdateSeverity(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__UpdateSeverity(struct soap *soap, const char *URL, enum vbox__UpdateSeverity *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__UpdateSeverity(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__UpdateSeverity(struct soap *soap, enum vbox__UpdateSeverity *p)
{
	if (::soap_read_vbox__UpdateSeverity(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__UpdateChannel(struct soap *soap, enum vbox__UpdateChannel *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__UpdateChannel
	*a = SOAP_DEFAULT_vbox__UpdateChannel;
#else
	*a = (enum vbox__UpdateChannel)0;
#endif
}

/*noinline*/ int soap_write_vbox__UpdateChannel(struct soap *soap, enum vbox__UpdateChannel const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__UpdateChannel(soap, p, "vbox:UpdateChannel", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__UpdateChannel(struct soap *soap, const char *URL, enum vbox__UpdateChannel const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateChannel(soap, p, "vbox:UpdateChannel", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__UpdateChannel(struct soap *soap, const char *URL, enum vbox__UpdateChannel const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateChannel(soap, p, "vbox:UpdateChannel", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__UpdateChannel(struct soap *soap, const char *URL, enum vbox__UpdateChannel const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UpdateChannel(soap, p, "vbox:UpdateChannel", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__UpdateChannel(struct soap *soap, enum vbox__UpdateChannel *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__UpdateChannel(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__UpdateChannel(struct soap *soap, const char *URL, enum vbox__UpdateChannel *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__UpdateChannel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__UpdateChannel(struct soap *soap, enum vbox__UpdateChannel *p)
{
	if (::soap_read_vbox__UpdateChannel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceType;
#else
	*a = (enum vbox__HostNetworkInterfaceType)0;
#endif
}

/*noinline*/ int soap_write_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__HostNetworkInterfaceType(soap, p, "vbox:HostNetworkInterfaceType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__HostNetworkInterfaceType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceType(soap, p, "vbox:HostNetworkInterfaceType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__HostNetworkInterfaceType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceType(soap, p, "vbox:HostNetworkInterfaceType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__HostNetworkInterfaceType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceType(soap, p, "vbox:HostNetworkInterfaceType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__HostNetworkInterfaceType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__HostNetworkInterfaceType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__HostNetworkInterfaceType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__HostNetworkInterfaceType(struct soap *soap, enum vbox__HostNetworkInterfaceType *p)
{
	if (::soap_read_vbox__HostNetworkInterfaceType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceStatus;
#else
	*a = (enum vbox__HostNetworkInterfaceStatus)0;
#endif
}

/*noinline*/ int soap_write_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__HostNetworkInterfaceStatus(soap, p, "vbox:HostNetworkInterfaceStatus", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceStatus(soap, p, "vbox:HostNetworkInterfaceStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceStatus(soap, p, "vbox:HostNetworkInterfaceStatus", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceStatus(soap, p, "vbox:HostNetworkInterfaceStatus", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__HostNetworkInterfaceStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__HostNetworkInterfaceStatus(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__HostNetworkInterfaceStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__HostNetworkInterfaceStatus(struct soap *soap, enum vbox__HostNetworkInterfaceStatus *p)
{
	if (::soap_read_vbox__HostNetworkInterfaceStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType
	*a = SOAP_DEFAULT_vbox__HostNetworkInterfaceMediumType;
#else
	*a = (enum vbox__HostNetworkInterfaceMediumType)0;
#endif
}

/*noinline*/ int soap_write_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__HostNetworkInterfaceMediumType(soap, p, "vbox:HostNetworkInterfaceMediumType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceMediumType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceMediumType(soap, p, "vbox:HostNetworkInterfaceMediumType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceMediumType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceMediumType(soap, p, "vbox:HostNetworkInterfaceMediumType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceMediumType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HostNetworkInterfaceMediumType(soap, p, "vbox:HostNetworkInterfaceMediumType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__HostNetworkInterfaceMediumType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__HostNetworkInterfaceMediumType(struct soap *soap, const char *URL, enum vbox__HostNetworkInterfaceMediumType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__HostNetworkInterfaceMediumType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__HostNetworkInterfaceMediumType(struct soap *soap, enum vbox__HostNetworkInterfaceMediumType *p)
{
	if (::soap_read_vbox__HostNetworkInterfaceMediumType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__VMExecutionEngine(struct soap *soap, enum vbox__VMExecutionEngine *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VMExecutionEngine
	*a = SOAP_DEFAULT_vbox__VMExecutionEngine;
#else
	*a = (enum vbox__VMExecutionEngine)0;
#endif
}

/*noinline*/ int soap_write_vbox__VMExecutionEngine(struct soap *soap, enum vbox__VMExecutionEngine const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__VMExecutionEngine(soap, p, "vbox:VMExecutionEngine", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__VMExecutionEngine(struct soap *soap, const char *URL, enum vbox__VMExecutionEngine const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VMExecutionEngine(soap, p, "vbox:VMExecutionEngine", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__VMExecutionEngine(struct soap *soap, const char *URL, enum vbox__VMExecutionEngine const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VMExecutionEngine(soap, p, "vbox:VMExecutionEngine", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__VMExecutionEngine(struct soap *soap, const char *URL, enum vbox__VMExecutionEngine const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VMExecutionEngine(soap, p, "vbox:VMExecutionEngine", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__VMExecutionEngine(struct soap *soap, enum vbox__VMExecutionEngine *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__VMExecutionEngine(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__VMExecutionEngine(struct soap *soap, const char *URL, enum vbox__VMExecutionEngine *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__VMExecutionEngine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__VMExecutionEngine(struct soap *soap, enum vbox__VMExecutionEngine *p)
{
	if (::soap_read_vbox__VMExecutionEngine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__IommuType(struct soap *soap, enum vbox__IommuType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__IommuType
	*a = SOAP_DEFAULT_vbox__IommuType;
#else
	*a = (enum vbox__IommuType)0;
#endif
}

/*noinline*/ int soap_write_vbox__IommuType(struct soap *soap, enum vbox__IommuType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__IommuType(soap, p, "vbox:IommuType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__IommuType(struct soap *soap, const char *URL, enum vbox__IommuType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__IommuType(soap, p, "vbox:IommuType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__IommuType(struct soap *soap, const char *URL, enum vbox__IommuType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__IommuType(soap, p, "vbox:IommuType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__IommuType(struct soap *soap, const char *URL, enum vbox__IommuType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__IommuType(soap, p, "vbox:IommuType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__IommuType(struct soap *soap, enum vbox__IommuType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__IommuType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__IommuType(struct soap *soap, const char *URL, enum vbox__IommuType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__IommuType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__IommuType(struct soap *soap, enum vbox__IommuType *p)
{
	if (::soap_read_vbox__IommuType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__VMProcPriority(struct soap *soap, enum vbox__VMProcPriority *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VMProcPriority
	*a = SOAP_DEFAULT_vbox__VMProcPriority;
#else
	*a = (enum vbox__VMProcPriority)0;
#endif
}

/*noinline*/ int soap_write_vbox__VMProcPriority(struct soap *soap, enum vbox__VMProcPriority const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__VMProcPriority(soap, p, "vbox:VMProcPriority", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__VMProcPriority(struct soap *soap, const char *URL, enum vbox__VMProcPriority const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VMProcPriority(soap, p, "vbox:VMProcPriority", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__VMProcPriority(struct soap *soap, const char *URL, enum vbox__VMProcPriority const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VMProcPriority(soap, p, "vbox:VMProcPriority", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__VMProcPriority(struct soap *soap, const char *URL, enum vbox__VMProcPriority const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VMProcPriority(soap, p, "vbox:VMProcPriority", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__VMProcPriority(struct soap *soap, enum vbox__VMProcPriority *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__VMProcPriority(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__VMProcPriority(struct soap *soap, const char *URL, enum vbox__VMProcPriority *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__VMProcPriority(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__VMProcPriority(struct soap *soap, enum vbox__VMProcPriority *p)
{
	if (::soap_read_vbox__VMProcPriority(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AutostopType(struct soap *soap, enum vbox__AutostopType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AutostopType
	*a = SOAP_DEFAULT_vbox__AutostopType;
#else
	*a = (enum vbox__AutostopType)0;
#endif
}

/*noinline*/ int soap_write_vbox__AutostopType(struct soap *soap, enum vbox__AutostopType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AutostopType(soap, p, "vbox:AutostopType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AutostopType(struct soap *soap, const char *URL, enum vbox__AutostopType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AutostopType(soap, p, "vbox:AutostopType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AutostopType(struct soap *soap, const char *URL, enum vbox__AutostopType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AutostopType(soap, p, "vbox:AutostopType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AutostopType(struct soap *soap, const char *URL, enum vbox__AutostopType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AutostopType(soap, p, "vbox:AutostopType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AutostopType(struct soap *soap, enum vbox__AutostopType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AutostopType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AutostopType(struct soap *soap, const char *URL, enum vbox__AutostopType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AutostopType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AutostopType(struct soap *soap, enum vbox__AutostopType *p)
{
	if (::soap_read_vbox__AutostopType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CloneOptions(struct soap *soap, enum vbox__CloneOptions *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CloneOptions
	*a = SOAP_DEFAULT_vbox__CloneOptions;
#else
	*a = (enum vbox__CloneOptions)0;
#endif
}

/*noinline*/ int soap_write_vbox__CloneOptions(struct soap *soap, enum vbox__CloneOptions const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CloneOptions(soap, p, "vbox:CloneOptions", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CloneOptions(struct soap *soap, const char *URL, enum vbox__CloneOptions const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloneOptions(soap, p, "vbox:CloneOptions", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CloneOptions(struct soap *soap, const char *URL, enum vbox__CloneOptions const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloneOptions(soap, p, "vbox:CloneOptions", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CloneOptions(struct soap *soap, const char *URL, enum vbox__CloneOptions const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloneOptions(soap, p, "vbox:CloneOptions", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CloneOptions(struct soap *soap, enum vbox__CloneOptions *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CloneOptions(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CloneOptions(struct soap *soap, const char *URL, enum vbox__CloneOptions *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CloneOptions(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CloneOptions(struct soap *soap, enum vbox__CloneOptions *p)
{
	if (::soap_read_vbox__CloneOptions(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CloneMode(struct soap *soap, enum vbox__CloneMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CloneMode
	*a = SOAP_DEFAULT_vbox__CloneMode;
#else
	*a = (enum vbox__CloneMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__CloneMode(struct soap *soap, enum vbox__CloneMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CloneMode(soap, p, "vbox:CloneMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CloneMode(struct soap *soap, const char *URL, enum vbox__CloneMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloneMode(soap, p, "vbox:CloneMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CloneMode(struct soap *soap, const char *URL, enum vbox__CloneMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloneMode(soap, p, "vbox:CloneMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CloneMode(struct soap *soap, const char *URL, enum vbox__CloneMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CloneMode(soap, p, "vbox:CloneMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CloneMode(struct soap *soap, enum vbox__CloneMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CloneMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CloneMode(struct soap *soap, const char *URL, enum vbox__CloneMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CloneMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CloneMode(struct soap *soap, enum vbox__CloneMode *p)
{
	if (::soap_read_vbox__CloneMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CleanupMode(struct soap *soap, enum vbox__CleanupMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CleanupMode
	*a = SOAP_DEFAULT_vbox__CleanupMode;
#else
	*a = (enum vbox__CleanupMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__CleanupMode(struct soap *soap, enum vbox__CleanupMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CleanupMode(soap, p, "vbox:CleanupMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CleanupMode(struct soap *soap, const char *URL, enum vbox__CleanupMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CleanupMode(soap, p, "vbox:CleanupMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CleanupMode(struct soap *soap, const char *URL, enum vbox__CleanupMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CleanupMode(soap, p, "vbox:CleanupMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CleanupMode(struct soap *soap, const char *URL, enum vbox__CleanupMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CleanupMode(soap, p, "vbox:CleanupMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CleanupMode(struct soap *soap, enum vbox__CleanupMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CleanupMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CleanupMode(struct soap *soap, const char *URL, enum vbox__CleanupMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CleanupMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CleanupMode(struct soap *soap, enum vbox__CleanupMode *p)
{
	if (::soap_read_vbox__CleanupMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GraphicsFeature(struct soap *soap, enum vbox__GraphicsFeature *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GraphicsFeature
	*a = SOAP_DEFAULT_vbox__GraphicsFeature;
#else
	*a = (enum vbox__GraphicsFeature)0;
#endif
}

/*noinline*/ int soap_write_vbox__GraphicsFeature(struct soap *soap, enum vbox__GraphicsFeature const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GraphicsFeature(soap, p, "vbox:GraphicsFeature", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GraphicsFeature(struct soap *soap, const char *URL, enum vbox__GraphicsFeature const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GraphicsFeature(soap, p, "vbox:GraphicsFeature", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GraphicsFeature(struct soap *soap, const char *URL, enum vbox__GraphicsFeature const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GraphicsFeature(soap, p, "vbox:GraphicsFeature", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GraphicsFeature(struct soap *soap, const char *URL, enum vbox__GraphicsFeature const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GraphicsFeature(soap, p, "vbox:GraphicsFeature", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GraphicsFeature(struct soap *soap, enum vbox__GraphicsFeature *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GraphicsFeature(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GraphicsFeature(struct soap *soap, const char *URL, enum vbox__GraphicsFeature *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GraphicsFeature(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GraphicsFeature(struct soap *soap, enum vbox__GraphicsFeature *p)
{
	if (::soap_read_vbox__GraphicsFeature(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__GraphicsControllerType(struct soap *soap, enum vbox__GraphicsControllerType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__GraphicsControllerType
	*a = SOAP_DEFAULT_vbox__GraphicsControllerType;
#else
	*a = (enum vbox__GraphicsControllerType)0;
#endif
}

/*noinline*/ int soap_write_vbox__GraphicsControllerType(struct soap *soap, enum vbox__GraphicsControllerType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__GraphicsControllerType(soap, p, "vbox:GraphicsControllerType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__GraphicsControllerType(struct soap *soap, const char *URL, enum vbox__GraphicsControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GraphicsControllerType(soap, p, "vbox:GraphicsControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__GraphicsControllerType(struct soap *soap, const char *URL, enum vbox__GraphicsControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GraphicsControllerType(soap, p, "vbox:GraphicsControllerType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__GraphicsControllerType(struct soap *soap, const char *URL, enum vbox__GraphicsControllerType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__GraphicsControllerType(soap, p, "vbox:GraphicsControllerType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__GraphicsControllerType(struct soap *soap, enum vbox__GraphicsControllerType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__GraphicsControllerType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__GraphicsControllerType(struct soap *soap, const char *URL, enum vbox__GraphicsControllerType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__GraphicsControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__GraphicsControllerType(struct soap *soap, enum vbox__GraphicsControllerType *p)
{
	if (::soap_read_vbox__GraphicsControllerType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__UefiVariableAttributes(struct soap *soap, enum vbox__UefiVariableAttributes *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__UefiVariableAttributes
	*a = SOAP_DEFAULT_vbox__UefiVariableAttributes;
#else
	*a = (enum vbox__UefiVariableAttributes)0;
#endif
}

/*noinline*/ int soap_write_vbox__UefiVariableAttributes(struct soap *soap, enum vbox__UefiVariableAttributes const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__UefiVariableAttributes(soap, p, "vbox:UefiVariableAttributes", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__UefiVariableAttributes(struct soap *soap, const char *URL, enum vbox__UefiVariableAttributes const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UefiVariableAttributes(soap, p, "vbox:UefiVariableAttributes", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__UefiVariableAttributes(struct soap *soap, const char *URL, enum vbox__UefiVariableAttributes const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UefiVariableAttributes(soap, p, "vbox:UefiVariableAttributes", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__UefiVariableAttributes(struct soap *soap, const char *URL, enum vbox__UefiVariableAttributes const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__UefiVariableAttributes(soap, p, "vbox:UefiVariableAttributes", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__UefiVariableAttributes(struct soap *soap, enum vbox__UefiVariableAttributes *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__UefiVariableAttributes(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__UefiVariableAttributes(struct soap *soap, const char *URL, enum vbox__UefiVariableAttributes *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__UefiVariableAttributes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__UefiVariableAttributes(struct soap *soap, enum vbox__UefiVariableAttributes *p)
{
	if (::soap_read_vbox__UefiVariableAttributes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SignatureType(struct soap *soap, enum vbox__SignatureType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SignatureType
	*a = SOAP_DEFAULT_vbox__SignatureType;
#else
	*a = (enum vbox__SignatureType)0;
#endif
}

/*noinline*/ int soap_write_vbox__SignatureType(struct soap *soap, enum vbox__SignatureType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SignatureType(soap, p, "vbox:SignatureType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SignatureType(struct soap *soap, const char *URL, enum vbox__SignatureType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SignatureType(soap, p, "vbox:SignatureType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SignatureType(struct soap *soap, const char *URL, enum vbox__SignatureType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SignatureType(soap, p, "vbox:SignatureType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SignatureType(struct soap *soap, const char *URL, enum vbox__SignatureType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SignatureType(soap, p, "vbox:SignatureType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SignatureType(struct soap *soap, enum vbox__SignatureType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SignatureType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SignatureType(struct soap *soap, const char *URL, enum vbox__SignatureType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SignatureType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SignatureType(struct soap *soap, enum vbox__SignatureType *p)
{
	if (::soap_read_vbox__SignatureType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingRateControlMode(struct soap *soap, enum vbox__RecordingRateControlMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingRateControlMode
	*a = SOAP_DEFAULT_vbox__RecordingRateControlMode;
#else
	*a = (enum vbox__RecordingRateControlMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingRateControlMode(struct soap *soap, enum vbox__RecordingRateControlMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingRateControlMode(soap, p, "vbox:RecordingRateControlMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingRateControlMode(struct soap *soap, const char *URL, enum vbox__RecordingRateControlMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingRateControlMode(soap, p, "vbox:RecordingRateControlMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingRateControlMode(struct soap *soap, const char *URL, enum vbox__RecordingRateControlMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingRateControlMode(soap, p, "vbox:RecordingRateControlMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingRateControlMode(struct soap *soap, const char *URL, enum vbox__RecordingRateControlMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingRateControlMode(soap, p, "vbox:RecordingRateControlMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingRateControlMode(struct soap *soap, enum vbox__RecordingRateControlMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingRateControlMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingRateControlMode(struct soap *soap, const char *URL, enum vbox__RecordingRateControlMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingRateControlMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingRateControlMode(struct soap *soap, enum vbox__RecordingRateControlMode *p)
{
	if (::soap_read_vbox__RecordingRateControlMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingVideoScalingMode(struct soap *soap, enum vbox__RecordingVideoScalingMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingVideoScalingMode
	*a = SOAP_DEFAULT_vbox__RecordingVideoScalingMode;
#else
	*a = (enum vbox__RecordingVideoScalingMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingVideoScalingMode(struct soap *soap, enum vbox__RecordingVideoScalingMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingVideoScalingMode(soap, p, "vbox:RecordingVideoScalingMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingVideoScalingMode(struct soap *soap, const char *URL, enum vbox__RecordingVideoScalingMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingVideoScalingMode(soap, p, "vbox:RecordingVideoScalingMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingVideoScalingMode(struct soap *soap, const char *URL, enum vbox__RecordingVideoScalingMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingVideoScalingMode(soap, p, "vbox:RecordingVideoScalingMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingVideoScalingMode(struct soap *soap, const char *URL, enum vbox__RecordingVideoScalingMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingVideoScalingMode(soap, p, "vbox:RecordingVideoScalingMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingVideoScalingMode(struct soap *soap, enum vbox__RecordingVideoScalingMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingVideoScalingMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingVideoScalingMode(struct soap *soap, const char *URL, enum vbox__RecordingVideoScalingMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingVideoScalingMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingVideoScalingMode(struct soap *soap, enum vbox__RecordingVideoScalingMode *p)
{
	if (::soap_read_vbox__RecordingVideoScalingMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingVideoCodec(struct soap *soap, enum vbox__RecordingVideoCodec *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingVideoCodec
	*a = SOAP_DEFAULT_vbox__RecordingVideoCodec;
#else
	*a = (enum vbox__RecordingVideoCodec)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingVideoCodec(struct soap *soap, enum vbox__RecordingVideoCodec const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingVideoCodec(soap, p, "vbox:RecordingVideoCodec", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingVideoCodec(struct soap *soap, const char *URL, enum vbox__RecordingVideoCodec const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingVideoCodec(soap, p, "vbox:RecordingVideoCodec", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingVideoCodec(struct soap *soap, const char *URL, enum vbox__RecordingVideoCodec const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingVideoCodec(soap, p, "vbox:RecordingVideoCodec", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingVideoCodec(struct soap *soap, const char *URL, enum vbox__RecordingVideoCodec const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingVideoCodec(soap, p, "vbox:RecordingVideoCodec", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingVideoCodec(struct soap *soap, enum vbox__RecordingVideoCodec *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingVideoCodec(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingVideoCodec(struct soap *soap, const char *URL, enum vbox__RecordingVideoCodec *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingVideoCodec(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingVideoCodec(struct soap *soap, enum vbox__RecordingVideoCodec *p)
{
	if (::soap_read_vbox__RecordingVideoCodec(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingCodecDeadline(struct soap *soap, enum vbox__RecordingCodecDeadline *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingCodecDeadline
	*a = SOAP_DEFAULT_vbox__RecordingCodecDeadline;
#else
	*a = (enum vbox__RecordingCodecDeadline)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingCodecDeadline(struct soap *soap, enum vbox__RecordingCodecDeadline const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingCodecDeadline(soap, p, "vbox:RecordingCodecDeadline", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingCodecDeadline(struct soap *soap, const char *URL, enum vbox__RecordingCodecDeadline const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingCodecDeadline(soap, p, "vbox:RecordingCodecDeadline", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingCodecDeadline(struct soap *soap, const char *URL, enum vbox__RecordingCodecDeadline const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingCodecDeadline(soap, p, "vbox:RecordingCodecDeadline", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingCodecDeadline(struct soap *soap, const char *URL, enum vbox__RecordingCodecDeadline const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingCodecDeadline(soap, p, "vbox:RecordingCodecDeadline", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingCodecDeadline(struct soap *soap, enum vbox__RecordingCodecDeadline *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingCodecDeadline(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingCodecDeadline(struct soap *soap, const char *URL, enum vbox__RecordingCodecDeadline *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingCodecDeadline(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingCodecDeadline(struct soap *soap, enum vbox__RecordingCodecDeadline *p)
{
	if (::soap_read_vbox__RecordingCodecDeadline(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingAudioCodec(struct soap *soap, enum vbox__RecordingAudioCodec *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingAudioCodec
	*a = SOAP_DEFAULT_vbox__RecordingAudioCodec;
#else
	*a = (enum vbox__RecordingAudioCodec)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingAudioCodec(struct soap *soap, enum vbox__RecordingAudioCodec const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingAudioCodec(soap, p, "vbox:RecordingAudioCodec", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingAudioCodec(struct soap *soap, const char *URL, enum vbox__RecordingAudioCodec const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingAudioCodec(soap, p, "vbox:RecordingAudioCodec", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingAudioCodec(struct soap *soap, const char *URL, enum vbox__RecordingAudioCodec const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingAudioCodec(soap, p, "vbox:RecordingAudioCodec", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingAudioCodec(struct soap *soap, const char *URL, enum vbox__RecordingAudioCodec const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingAudioCodec(soap, p, "vbox:RecordingAudioCodec", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingAudioCodec(struct soap *soap, enum vbox__RecordingAudioCodec *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingAudioCodec(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingAudioCodec(struct soap *soap, const char *URL, enum vbox__RecordingAudioCodec *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingAudioCodec(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingAudioCodec(struct soap *soap, enum vbox__RecordingAudioCodec *p)
{
	if (::soap_read_vbox__RecordingAudioCodec(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingFeature(struct soap *soap, enum vbox__RecordingFeature *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingFeature
	*a = SOAP_DEFAULT_vbox__RecordingFeature;
#else
	*a = (enum vbox__RecordingFeature)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingFeature(struct soap *soap, enum vbox__RecordingFeature const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingFeature(soap, p, "vbox:RecordingFeature", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingFeature(struct soap *soap, const char *URL, enum vbox__RecordingFeature const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingFeature(soap, p, "vbox:RecordingFeature", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingFeature(struct soap *soap, const char *URL, enum vbox__RecordingFeature const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingFeature(soap, p, "vbox:RecordingFeature", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingFeature(struct soap *soap, const char *URL, enum vbox__RecordingFeature const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingFeature(soap, p, "vbox:RecordingFeature", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingFeature(struct soap *soap, enum vbox__RecordingFeature *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingFeature(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingFeature(struct soap *soap, const char *URL, enum vbox__RecordingFeature *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingFeature(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingFeature(struct soap *soap, enum vbox__RecordingFeature *p)
{
	if (::soap_read_vbox__RecordingFeature(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__RecordingDestination(struct soap *soap, enum vbox__RecordingDestination *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__RecordingDestination
	*a = SOAP_DEFAULT_vbox__RecordingDestination;
#else
	*a = (enum vbox__RecordingDestination)0;
#endif
}

/*noinline*/ int soap_write_vbox__RecordingDestination(struct soap *soap, enum vbox__RecordingDestination const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__RecordingDestination(soap, p, "vbox:RecordingDestination", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__RecordingDestination(struct soap *soap, const char *URL, enum vbox__RecordingDestination const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingDestination(soap, p, "vbox:RecordingDestination", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__RecordingDestination(struct soap *soap, const char *URL, enum vbox__RecordingDestination const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingDestination(soap, p, "vbox:RecordingDestination", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__RecordingDestination(struct soap *soap, const char *URL, enum vbox__RecordingDestination const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__RecordingDestination(soap, p, "vbox:RecordingDestination", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__RecordingDestination(struct soap *soap, enum vbox__RecordingDestination *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__RecordingDestination(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__RecordingDestination(struct soap *soap, const char *URL, enum vbox__RecordingDestination *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__RecordingDestination(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__RecordingDestination(struct soap *soap, enum vbox__RecordingDestination *p)
{
	if (::soap_read_vbox__RecordingDestination(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__TpmType(struct soap *soap, enum vbox__TpmType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__TpmType
	*a = SOAP_DEFAULT_vbox__TpmType;
#else
	*a = (enum vbox__TpmType)0;
#endif
}

/*noinline*/ int soap_write_vbox__TpmType(struct soap *soap, enum vbox__TpmType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__TpmType(soap, p, "vbox:TpmType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__TpmType(struct soap *soap, const char *URL, enum vbox__TpmType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__TpmType(soap, p, "vbox:TpmType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__TpmType(struct soap *soap, const char *URL, enum vbox__TpmType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__TpmType(soap, p, "vbox:TpmType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__TpmType(struct soap *soap, const char *URL, enum vbox__TpmType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__TpmType(soap, p, "vbox:TpmType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__TpmType(struct soap *soap, enum vbox__TpmType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__TpmType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__TpmType(struct soap *soap, const char *URL, enum vbox__TpmType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__TpmType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__TpmType(struct soap *soap, enum vbox__TpmType *p)
{
	if (::soap_read_vbox__TpmType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionValueType;
#else
	*a = (enum vbox__VirtualSystemDescriptionValueType)0;
#endif
}

/*noinline*/ int soap_write_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__VirtualSystemDescriptionValueType(soap, p, "vbox:VirtualSystemDescriptionValueType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionValueType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VirtualSystemDescriptionValueType(soap, p, "vbox:VirtualSystemDescriptionValueType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionValueType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VirtualSystemDescriptionValueType(soap, p, "vbox:VirtualSystemDescriptionValueType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionValueType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VirtualSystemDescriptionValueType(soap, p, "vbox:VirtualSystemDescriptionValueType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__VirtualSystemDescriptionValueType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__VirtualSystemDescriptionValueType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionValueType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__VirtualSystemDescriptionValueType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__VirtualSystemDescriptionValueType(struct soap *soap, enum vbox__VirtualSystemDescriptionValueType *p)
{
	if (::soap_read_vbox__VirtualSystemDescriptionValueType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VirtualSystemDescriptionType
	*a = SOAP_DEFAULT_vbox__VirtualSystemDescriptionType;
#else
	*a = (enum vbox__VirtualSystemDescriptionType)0;
#endif
}

/*noinline*/ int soap_write_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__VirtualSystemDescriptionType(soap, p, "vbox:VirtualSystemDescriptionType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VirtualSystemDescriptionType(soap, p, "vbox:VirtualSystemDescriptionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VirtualSystemDescriptionType(soap, p, "vbox:VirtualSystemDescriptionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VirtualSystemDescriptionType(soap, p, "vbox:VirtualSystemDescriptionType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__VirtualSystemDescriptionType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__VirtualSystemDescriptionType(struct soap *soap, const char *URL, enum vbox__VirtualSystemDescriptionType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__VirtualSystemDescriptionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__VirtualSystemDescriptionType(struct soap *soap, enum vbox__VirtualSystemDescriptionType *p)
{
	if (::soap_read_vbox__VirtualSystemDescriptionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CertificateVersion(struct soap *soap, enum vbox__CertificateVersion *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CertificateVersion
	*a = SOAP_DEFAULT_vbox__CertificateVersion;
#else
	*a = (enum vbox__CertificateVersion)0;
#endif
}

/*noinline*/ int soap_write_vbox__CertificateVersion(struct soap *soap, enum vbox__CertificateVersion const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CertificateVersion(soap, p, "vbox:CertificateVersion", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CertificateVersion(struct soap *soap, const char *URL, enum vbox__CertificateVersion const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CertificateVersion(soap, p, "vbox:CertificateVersion", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CertificateVersion(struct soap *soap, const char *URL, enum vbox__CertificateVersion const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CertificateVersion(soap, p, "vbox:CertificateVersion", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CertificateVersion(struct soap *soap, const char *URL, enum vbox__CertificateVersion const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CertificateVersion(soap, p, "vbox:CertificateVersion", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CertificateVersion(struct soap *soap, enum vbox__CertificateVersion *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CertificateVersion(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CertificateVersion(struct soap *soap, const char *URL, enum vbox__CertificateVersion *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CertificateVersion(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CertificateVersion(struct soap *soap, enum vbox__CertificateVersion *p)
{
	if (::soap_read_vbox__CertificateVersion(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ExportOptions(struct soap *soap, enum vbox__ExportOptions *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ExportOptions
	*a = SOAP_DEFAULT_vbox__ExportOptions;
#else
	*a = (enum vbox__ExportOptions)0;
#endif
}

/*noinline*/ int soap_write_vbox__ExportOptions(struct soap *soap, enum vbox__ExportOptions const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ExportOptions(soap, p, "vbox:ExportOptions", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ExportOptions(struct soap *soap, const char *URL, enum vbox__ExportOptions const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ExportOptions(soap, p, "vbox:ExportOptions", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ExportOptions(struct soap *soap, const char *URL, enum vbox__ExportOptions const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ExportOptions(soap, p, "vbox:ExportOptions", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ExportOptions(struct soap *soap, const char *URL, enum vbox__ExportOptions const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ExportOptions(soap, p, "vbox:ExportOptions", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ExportOptions(struct soap *soap, enum vbox__ExportOptions *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ExportOptions(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ExportOptions(struct soap *soap, const char *URL, enum vbox__ExportOptions *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ExportOptions(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ExportOptions(struct soap *soap, enum vbox__ExportOptions *p)
{
	if (::soap_read_vbox__ExportOptions(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ImportOptions(struct soap *soap, enum vbox__ImportOptions *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ImportOptions
	*a = SOAP_DEFAULT_vbox__ImportOptions;
#else
	*a = (enum vbox__ImportOptions)0;
#endif
}

/*noinline*/ int soap_write_vbox__ImportOptions(struct soap *soap, enum vbox__ImportOptions const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ImportOptions(soap, p, "vbox:ImportOptions", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ImportOptions(struct soap *soap, const char *URL, enum vbox__ImportOptions const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ImportOptions(soap, p, "vbox:ImportOptions", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ImportOptions(struct soap *soap, const char *URL, enum vbox__ImportOptions const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ImportOptions(soap, p, "vbox:ImportOptions", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ImportOptions(struct soap *soap, const char *URL, enum vbox__ImportOptions const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ImportOptions(soap, p, "vbox:ImportOptions", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ImportOptions(struct soap *soap, enum vbox__ImportOptions *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ImportOptions(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ImportOptions(struct soap *soap, const char *URL, enum vbox__ImportOptions *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ImportOptions(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ImportOptions(struct soap *soap, enum vbox__ImportOptions *p)
{
	if (::soap_read_vbox__ImportOptions(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__VFSType(struct soap *soap, enum vbox__VFSType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__VFSType
	*a = SOAP_DEFAULT_vbox__VFSType;
#else
	*a = (enum vbox__VFSType)0;
#endif
}

/*noinline*/ int soap_write_vbox__VFSType(struct soap *soap, enum vbox__VFSType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__VFSType(soap, p, "vbox:VFSType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__VFSType(struct soap *soap, const char *URL, enum vbox__VFSType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VFSType(soap, p, "vbox:VFSType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__VFSType(struct soap *soap, const char *URL, enum vbox__VFSType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VFSType(soap, p, "vbox:VFSType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__VFSType(struct soap *soap, const char *URL, enum vbox__VFSType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__VFSType(soap, p, "vbox:VFSType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__VFSType(struct soap *soap, enum vbox__VFSType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__VFSType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__VFSType(struct soap *soap, const char *URL, enum vbox__VFSType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__VFSType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__VFSType(struct soap *soap, enum vbox__VFSType *p)
{
	if (::soap_read_vbox__VFSType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DHCPGroupConditionType(struct soap *soap, enum vbox__DHCPGroupConditionType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DHCPGroupConditionType
	*a = SOAP_DEFAULT_vbox__DHCPGroupConditionType;
#else
	*a = (enum vbox__DHCPGroupConditionType)0;
#endif
}

/*noinline*/ int soap_write_vbox__DHCPGroupConditionType(struct soap *soap, enum vbox__DHCPGroupConditionType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DHCPGroupConditionType(soap, p, "vbox:DHCPGroupConditionType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DHCPGroupConditionType(struct soap *soap, const char *URL, enum vbox__DHCPGroupConditionType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPGroupConditionType(soap, p, "vbox:DHCPGroupConditionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DHCPGroupConditionType(struct soap *soap, const char *URL, enum vbox__DHCPGroupConditionType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPGroupConditionType(soap, p, "vbox:DHCPGroupConditionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DHCPGroupConditionType(struct soap *soap, const char *URL, enum vbox__DHCPGroupConditionType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPGroupConditionType(soap, p, "vbox:DHCPGroupConditionType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DHCPGroupConditionType(struct soap *soap, enum vbox__DHCPGroupConditionType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DHCPGroupConditionType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DHCPGroupConditionType(struct soap *soap, const char *URL, enum vbox__DHCPGroupConditionType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DHCPGroupConditionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DHCPGroupConditionType(struct soap *soap, enum vbox__DHCPGroupConditionType *p)
{
	if (::soap_read_vbox__DHCPGroupConditionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DHCPConfigScope(struct soap *soap, enum vbox__DHCPConfigScope *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DHCPConfigScope
	*a = SOAP_DEFAULT_vbox__DHCPConfigScope;
#else
	*a = (enum vbox__DHCPConfigScope)0;
#endif
}

/*noinline*/ int soap_write_vbox__DHCPConfigScope(struct soap *soap, enum vbox__DHCPConfigScope const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DHCPConfigScope(soap, p, "vbox:DHCPConfigScope", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DHCPConfigScope(struct soap *soap, const char *URL, enum vbox__DHCPConfigScope const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPConfigScope(soap, p, "vbox:DHCPConfigScope", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DHCPConfigScope(struct soap *soap, const char *URL, enum vbox__DHCPConfigScope const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPConfigScope(soap, p, "vbox:DHCPConfigScope", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DHCPConfigScope(struct soap *soap, const char *URL, enum vbox__DHCPConfigScope const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPConfigScope(soap, p, "vbox:DHCPConfigScope", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DHCPConfigScope(struct soap *soap, enum vbox__DHCPConfigScope *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DHCPConfigScope(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DHCPConfigScope(struct soap *soap, const char *URL, enum vbox__DHCPConfigScope *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DHCPConfigScope(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DHCPConfigScope(struct soap *soap, enum vbox__DHCPConfigScope *p)
{
	if (::soap_read_vbox__DHCPConfigScope(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DHCPOptionEncoding(struct soap *soap, enum vbox__DHCPOptionEncoding *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DHCPOptionEncoding
	*a = SOAP_DEFAULT_vbox__DHCPOptionEncoding;
#else
	*a = (enum vbox__DHCPOptionEncoding)0;
#endif
}

/*noinline*/ int soap_write_vbox__DHCPOptionEncoding(struct soap *soap, enum vbox__DHCPOptionEncoding const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DHCPOptionEncoding(soap, p, "vbox:DHCPOptionEncoding", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DHCPOptionEncoding(struct soap *soap, const char *URL, enum vbox__DHCPOptionEncoding const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPOptionEncoding(soap, p, "vbox:DHCPOptionEncoding", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DHCPOptionEncoding(struct soap *soap, const char *URL, enum vbox__DHCPOptionEncoding const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPOptionEncoding(soap, p, "vbox:DHCPOptionEncoding", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DHCPOptionEncoding(struct soap *soap, const char *URL, enum vbox__DHCPOptionEncoding const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPOptionEncoding(soap, p, "vbox:DHCPOptionEncoding", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DHCPOptionEncoding(struct soap *soap, enum vbox__DHCPOptionEncoding *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DHCPOptionEncoding(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DHCPOptionEncoding(struct soap *soap, const char *URL, enum vbox__DHCPOptionEncoding *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DHCPOptionEncoding(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DHCPOptionEncoding(struct soap *soap, enum vbox__DHCPOptionEncoding *p)
{
	if (::soap_read_vbox__DHCPOptionEncoding(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DHCPOption(struct soap *soap, enum vbox__DHCPOption *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DHCPOption
	*a = SOAP_DEFAULT_vbox__DHCPOption;
#else
	*a = (enum vbox__DHCPOption)0;
#endif
}

/*noinline*/ int soap_write_vbox__DHCPOption(struct soap *soap, enum vbox__DHCPOption const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DHCPOption(soap, p, "vbox:DHCPOption", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DHCPOption(struct soap *soap, const char *URL, enum vbox__DHCPOption const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPOption(soap, p, "vbox:DHCPOption", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DHCPOption(struct soap *soap, const char *URL, enum vbox__DHCPOption const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPOption(soap, p, "vbox:DHCPOption", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DHCPOption(struct soap *soap, const char *URL, enum vbox__DHCPOption const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DHCPOption(soap, p, "vbox:DHCPOption", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DHCPOption(struct soap *soap, enum vbox__DHCPOption *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DHCPOption(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DHCPOption(struct soap *soap, const char *URL, enum vbox__DHCPOption *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DHCPOption(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DHCPOption(struct soap *soap, enum vbox__DHCPOption *p)
{
	if (::soap_read_vbox__DHCPOption(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PartitionType(struct soap *soap, enum vbox__PartitionType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PartitionType
	*a = SOAP_DEFAULT_vbox__PartitionType;
#else
	*a = (enum vbox__PartitionType)0;
#endif
}

/*noinline*/ int soap_write_vbox__PartitionType(struct soap *soap, enum vbox__PartitionType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PartitionType(soap, p, "vbox:PartitionType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PartitionType(struct soap *soap, const char *URL, enum vbox__PartitionType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitionType(soap, p, "vbox:PartitionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PartitionType(struct soap *soap, const char *URL, enum vbox__PartitionType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitionType(soap, p, "vbox:PartitionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PartitionType(struct soap *soap, const char *URL, enum vbox__PartitionType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitionType(soap, p, "vbox:PartitionType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PartitionType(struct soap *soap, enum vbox__PartitionType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PartitionType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PartitionType(struct soap *soap, const char *URL, enum vbox__PartitionType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PartitionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PartitionType(struct soap *soap, enum vbox__PartitionType *p)
{
	if (::soap_read_vbox__PartitionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PartitioningType(struct soap *soap, enum vbox__PartitioningType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PartitioningType
	*a = SOAP_DEFAULT_vbox__PartitioningType;
#else
	*a = (enum vbox__PartitioningType)0;
#endif
}

/*noinline*/ int soap_write_vbox__PartitioningType(struct soap *soap, enum vbox__PartitioningType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PartitioningType(soap, p, "vbox:PartitioningType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PartitioningType(struct soap *soap, const char *URL, enum vbox__PartitioningType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitioningType(soap, p, "vbox:PartitioningType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PartitioningType(struct soap *soap, const char *URL, enum vbox__PartitioningType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitioningType(soap, p, "vbox:PartitioningType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PartitioningType(struct soap *soap, const char *URL, enum vbox__PartitioningType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PartitioningType(soap, p, "vbox:PartitioningType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PartitioningType(struct soap *soap, enum vbox__PartitioningType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PartitioningType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PartitioningType(struct soap *soap, const char *URL, enum vbox__PartitioningType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PartitioningType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PartitioningType(struct soap *soap, enum vbox__PartitioningType *p)
{
	if (::soap_read_vbox__PartitioningType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__BitmapFormat(struct soap *soap, enum vbox__BitmapFormat *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__BitmapFormat
	*a = SOAP_DEFAULT_vbox__BitmapFormat;
#else
	*a = (enum vbox__BitmapFormat)0;
#endif
}

/*noinline*/ int soap_write_vbox__BitmapFormat(struct soap *soap, enum vbox__BitmapFormat const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__BitmapFormat(soap, p, "vbox:BitmapFormat", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__BitmapFormat(struct soap *soap, const char *URL, enum vbox__BitmapFormat const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__BitmapFormat(soap, p, "vbox:BitmapFormat", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__BitmapFormat(struct soap *soap, const char *URL, enum vbox__BitmapFormat const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__BitmapFormat(soap, p, "vbox:BitmapFormat", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__BitmapFormat(struct soap *soap, const char *URL, enum vbox__BitmapFormat const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__BitmapFormat(soap, p, "vbox:BitmapFormat", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__BitmapFormat(struct soap *soap, enum vbox__BitmapFormat *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__BitmapFormat(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__BitmapFormat(struct soap *soap, const char *URL, enum vbox__BitmapFormat *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__BitmapFormat(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__BitmapFormat(struct soap *soap, enum vbox__BitmapFormat *p)
{
	if (::soap_read_vbox__BitmapFormat(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__KeyboardHIDType(struct soap *soap, enum vbox__KeyboardHIDType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__KeyboardHIDType
	*a = SOAP_DEFAULT_vbox__KeyboardHIDType;
#else
	*a = (enum vbox__KeyboardHIDType)0;
#endif
}

/*noinline*/ int soap_write_vbox__KeyboardHIDType(struct soap *soap, enum vbox__KeyboardHIDType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__KeyboardHIDType(soap, p, "vbox:KeyboardHIDType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__KeyboardHIDType(struct soap *soap, const char *URL, enum vbox__KeyboardHIDType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__KeyboardHIDType(soap, p, "vbox:KeyboardHIDType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__KeyboardHIDType(struct soap *soap, const char *URL, enum vbox__KeyboardHIDType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__KeyboardHIDType(soap, p, "vbox:KeyboardHIDType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__KeyboardHIDType(struct soap *soap, const char *URL, enum vbox__KeyboardHIDType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__KeyboardHIDType(soap, p, "vbox:KeyboardHIDType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__KeyboardHIDType(struct soap *soap, enum vbox__KeyboardHIDType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__KeyboardHIDType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__KeyboardHIDType(struct soap *soap, const char *URL, enum vbox__KeyboardHIDType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__KeyboardHIDType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__KeyboardHIDType(struct soap *soap, enum vbox__KeyboardHIDType *p)
{
	if (::soap_read_vbox__KeyboardHIDType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PointingHIDType(struct soap *soap, enum vbox__PointingHIDType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PointingHIDType
	*a = SOAP_DEFAULT_vbox__PointingHIDType;
#else
	*a = (enum vbox__PointingHIDType)0;
#endif
}

/*noinline*/ int soap_write_vbox__PointingHIDType(struct soap *soap, enum vbox__PointingHIDType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PointingHIDType(soap, p, "vbox:PointingHIDType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PointingHIDType(struct soap *soap, const char *URL, enum vbox__PointingHIDType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PointingHIDType(soap, p, "vbox:PointingHIDType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PointingHIDType(struct soap *soap, const char *URL, enum vbox__PointingHIDType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PointingHIDType(soap, p, "vbox:PointingHIDType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PointingHIDType(struct soap *soap, const char *URL, enum vbox__PointingHIDType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PointingHIDType(soap, p, "vbox:PointingHIDType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PointingHIDType(struct soap *soap, enum vbox__PointingHIDType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PointingHIDType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PointingHIDType(struct soap *soap, const char *URL, enum vbox__PointingHIDType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PointingHIDType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PointingHIDType(struct soap *soap, enum vbox__PointingHIDType *p)
{
	if (::soap_read_vbox__PointingHIDType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FirmwareType
	*a = SOAP_DEFAULT_vbox__FirmwareType;
#else
	*a = (enum vbox__FirmwareType)0;
#endif
}

/*noinline*/ int soap_write_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FirmwareType(soap, p, "vbox:FirmwareType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FirmwareType(struct soap *soap, const char *URL, enum vbox__FirmwareType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FirmwareType(soap, p, "vbox:FirmwareType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FirmwareType(struct soap *soap, const char *URL, enum vbox__FirmwareType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FirmwareType(soap, p, "vbox:FirmwareType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FirmwareType(struct soap *soap, const char *URL, enum vbox__FirmwareType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FirmwareType(soap, p, "vbox:FirmwareType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FirmwareType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FirmwareType(struct soap *soap, const char *URL, enum vbox__FirmwareType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FirmwareType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FirmwareType(struct soap *soap, enum vbox__FirmwareType *p)
{
	if (::soap_read_vbox__FirmwareType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ProcessorFeature
	*a = SOAP_DEFAULT_vbox__ProcessorFeature;
#else
	*a = (enum vbox__ProcessorFeature)0;
#endif
}

/*noinline*/ int soap_write_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ProcessorFeature(soap, p, "vbox:ProcessorFeature", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ProcessorFeature(struct soap *soap, const char *URL, enum vbox__ProcessorFeature const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessorFeature(soap, p, "vbox:ProcessorFeature", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ProcessorFeature(struct soap *soap, const char *URL, enum vbox__ProcessorFeature const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessorFeature(soap, p, "vbox:ProcessorFeature", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ProcessorFeature(struct soap *soap, const char *URL, enum vbox__ProcessorFeature const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ProcessorFeature(soap, p, "vbox:ProcessorFeature", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ProcessorFeature(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ProcessorFeature(struct soap *soap, const char *URL, enum vbox__ProcessorFeature *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ProcessorFeature(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ProcessorFeature(struct soap *soap, enum vbox__ProcessorFeature *p)
{
	if (::soap_read_vbox__ProcessorFeature(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__APICMode(struct soap *soap, enum vbox__APICMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__APICMode
	*a = SOAP_DEFAULT_vbox__APICMode;
#else
	*a = (enum vbox__APICMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__APICMode(struct soap *soap, enum vbox__APICMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__APICMode(soap, p, "vbox:APICMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__APICMode(struct soap *soap, const char *URL, enum vbox__APICMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__APICMode(soap, p, "vbox:APICMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__APICMode(struct soap *soap, const char *URL, enum vbox__APICMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__APICMode(soap, p, "vbox:APICMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__APICMode(struct soap *soap, const char *URL, enum vbox__APICMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__APICMode(soap, p, "vbox:APICMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__APICMode(struct soap *soap, enum vbox__APICMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__APICMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__APICMode(struct soap *soap, const char *URL, enum vbox__APICMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__APICMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__APICMode(struct soap *soap, enum vbox__APICMode *p)
{
	if (::soap_read_vbox__APICMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__FirmwareBootMenuMode(struct soap *soap, enum vbox__FirmwareBootMenuMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__FirmwareBootMenuMode
	*a = SOAP_DEFAULT_vbox__FirmwareBootMenuMode;
#else
	*a = (enum vbox__FirmwareBootMenuMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__FirmwareBootMenuMode(struct soap *soap, enum vbox__FirmwareBootMenuMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__FirmwareBootMenuMode(soap, p, "vbox:FirmwareBootMenuMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__FirmwareBootMenuMode(struct soap *soap, const char *URL, enum vbox__FirmwareBootMenuMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FirmwareBootMenuMode(soap, p, "vbox:FirmwareBootMenuMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__FirmwareBootMenuMode(struct soap *soap, const char *URL, enum vbox__FirmwareBootMenuMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FirmwareBootMenuMode(soap, p, "vbox:FirmwareBootMenuMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__FirmwareBootMenuMode(struct soap *soap, const char *URL, enum vbox__FirmwareBootMenuMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__FirmwareBootMenuMode(soap, p, "vbox:FirmwareBootMenuMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__FirmwareBootMenuMode(struct soap *soap, enum vbox__FirmwareBootMenuMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__FirmwareBootMenuMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__FirmwareBootMenuMode(struct soap *soap, const char *URL, enum vbox__FirmwareBootMenuMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__FirmwareBootMenuMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__FirmwareBootMenuMode(struct soap *soap, enum vbox__FirmwareBootMenuMode *p)
{
	if (::soap_read_vbox__FirmwareBootMenuMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__Scope(struct soap *soap, enum vbox__Scope *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__Scope
	*a = SOAP_DEFAULT_vbox__Scope;
#else
	*a = (enum vbox__Scope)0;
#endif
}

/*noinline*/ int soap_write_vbox__Scope(struct soap *soap, enum vbox__Scope const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__Scope(soap, p, "vbox:Scope", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__Scope(struct soap *soap, const char *URL, enum vbox__Scope const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__Scope(soap, p, "vbox:Scope", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__Scope(struct soap *soap, const char *URL, enum vbox__Scope const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__Scope(soap, p, "vbox:Scope", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__Scope(struct soap *soap, const char *URL, enum vbox__Scope const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__Scope(soap, p, "vbox:Scope", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__Scope(struct soap *soap, enum vbox__Scope *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__Scope(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__Scope(struct soap *soap, const char *URL, enum vbox__Scope *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__Scope(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__Scope(struct soap *soap, enum vbox__Scope *p)
{
	if (::soap_read_vbox__Scope(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DnDMode(struct soap *soap, enum vbox__DnDMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DnDMode
	*a = SOAP_DEFAULT_vbox__DnDMode;
#else
	*a = (enum vbox__DnDMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__DnDMode(struct soap *soap, enum vbox__DnDMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DnDMode(soap, p, "vbox:DnDMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DnDMode(struct soap *soap, const char *URL, enum vbox__DnDMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DnDMode(soap, p, "vbox:DnDMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DnDMode(struct soap *soap, const char *URL, enum vbox__DnDMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DnDMode(soap, p, "vbox:DnDMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DnDMode(struct soap *soap, const char *URL, enum vbox__DnDMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DnDMode(soap, p, "vbox:DnDMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DnDMode(struct soap *soap, enum vbox__DnDMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DnDMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DnDMode(struct soap *soap, const char *URL, enum vbox__DnDMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DnDMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DnDMode(struct soap *soap, enum vbox__DnDMode *p)
{
	if (::soap_read_vbox__DnDMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ClipboardMode
	*a = SOAP_DEFAULT_vbox__ClipboardMode;
#else
	*a = (enum vbox__ClipboardMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ClipboardMode(soap, p, "vbox:ClipboardMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ClipboardMode(struct soap *soap, const char *URL, enum vbox__ClipboardMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ClipboardMode(soap, p, "vbox:ClipboardMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ClipboardMode(struct soap *soap, const char *URL, enum vbox__ClipboardMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ClipboardMode(soap, p, "vbox:ClipboardMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ClipboardMode(struct soap *soap, const char *URL, enum vbox__ClipboardMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ClipboardMode(soap, p, "vbox:ClipboardMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ClipboardMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ClipboardMode(struct soap *soap, const char *URL, enum vbox__ClipboardMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ClipboardMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ClipboardMode(struct soap *soap, enum vbox__ClipboardMode *p)
{
	if (::soap_read_vbox__ClipboardMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceActivity
	*a = SOAP_DEFAULT_vbox__DeviceActivity;
#else
	*a = (enum vbox__DeviceActivity)0;
#endif
}

/*noinline*/ int soap_write_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DeviceActivity(soap, p, "vbox:DeviceActivity", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DeviceActivity(struct soap *soap, const char *URL, enum vbox__DeviceActivity const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DeviceActivity(soap, p, "vbox:DeviceActivity", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DeviceActivity(struct soap *soap, const char *URL, enum vbox__DeviceActivity const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DeviceActivity(soap, p, "vbox:DeviceActivity", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DeviceActivity(struct soap *soap, const char *URL, enum vbox__DeviceActivity const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DeviceActivity(soap, p, "vbox:DeviceActivity", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DeviceActivity(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DeviceActivity(struct soap *soap, const char *URL, enum vbox__DeviceActivity *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DeviceActivity(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DeviceActivity(struct soap *soap, enum vbox__DeviceActivity *p)
{
	if (::soap_read_vbox__DeviceActivity(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__DeviceType
	*a = SOAP_DEFAULT_vbox__DeviceType;
#else
	*a = (enum vbox__DeviceType)0;
#endif
}

/*noinline*/ int soap_write_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__DeviceType(soap, p, "vbox:DeviceType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__DeviceType(struct soap *soap, const char *URL, enum vbox__DeviceType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DeviceType(soap, p, "vbox:DeviceType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__DeviceType(struct soap *soap, const char *URL, enum vbox__DeviceType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DeviceType(soap, p, "vbox:DeviceType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__DeviceType(struct soap *soap, const char *URL, enum vbox__DeviceType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__DeviceType(soap, p, "vbox:DeviceType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__DeviceType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__DeviceType(struct soap *soap, const char *URL, enum vbox__DeviceType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__DeviceType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__DeviceType(struct soap *soap, enum vbox__DeviceType *p)
{
	if (::soap_read_vbox__DeviceType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SessionType(struct soap *soap, enum vbox__SessionType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionType
	*a = SOAP_DEFAULT_vbox__SessionType;
#else
	*a = (enum vbox__SessionType)0;
#endif
}

/*noinline*/ int soap_write_vbox__SessionType(struct soap *soap, enum vbox__SessionType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SessionType(soap, p, "vbox:SessionType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SessionType(struct soap *soap, const char *URL, enum vbox__SessionType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SessionType(soap, p, "vbox:SessionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SessionType(struct soap *soap, const char *URL, enum vbox__SessionType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SessionType(soap, p, "vbox:SessionType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SessionType(struct soap *soap, const char *URL, enum vbox__SessionType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SessionType(soap, p, "vbox:SessionType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SessionType(struct soap *soap, enum vbox__SessionType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SessionType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SessionType(struct soap *soap, const char *URL, enum vbox__SessionType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SessionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SessionType(struct soap *soap, enum vbox__SessionType *p)
{
	if (::soap_read_vbox__SessionType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__LockType(struct soap *soap, enum vbox__LockType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__LockType
	*a = SOAP_DEFAULT_vbox__LockType;
#else
	*a = (enum vbox__LockType)0;
#endif
}

/*noinline*/ int soap_write_vbox__LockType(struct soap *soap, enum vbox__LockType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__LockType(soap, p, "vbox:LockType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__LockType(struct soap *soap, const char *URL, enum vbox__LockType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__LockType(soap, p, "vbox:LockType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__LockType(struct soap *soap, const char *URL, enum vbox__LockType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__LockType(soap, p, "vbox:LockType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__LockType(struct soap *soap, const char *URL, enum vbox__LockType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__LockType(soap, p, "vbox:LockType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__LockType(struct soap *soap, enum vbox__LockType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__LockType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__LockType(struct soap *soap, const char *URL, enum vbox__LockType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__LockType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__LockType(struct soap *soap, enum vbox__LockType *p)
{
	if (::soap_read_vbox__LockType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__ParavirtProvider(struct soap *soap, enum vbox__ParavirtProvider *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__ParavirtProvider
	*a = SOAP_DEFAULT_vbox__ParavirtProvider;
#else
	*a = (enum vbox__ParavirtProvider)0;
#endif
}

/*noinline*/ int soap_write_vbox__ParavirtProvider(struct soap *soap, enum vbox__ParavirtProvider const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__ParavirtProvider(soap, p, "vbox:ParavirtProvider", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__ParavirtProvider(struct soap *soap, const char *URL, enum vbox__ParavirtProvider const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ParavirtProvider(soap, p, "vbox:ParavirtProvider", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__ParavirtProvider(struct soap *soap, const char *URL, enum vbox__ParavirtProvider const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ParavirtProvider(soap, p, "vbox:ParavirtProvider", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__ParavirtProvider(struct soap *soap, const char *URL, enum vbox__ParavirtProvider const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__ParavirtProvider(soap, p, "vbox:ParavirtProvider", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__ParavirtProvider(struct soap *soap, enum vbox__ParavirtProvider *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__ParavirtProvider(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__ParavirtProvider(struct soap *soap, const char *URL, enum vbox__ParavirtProvider *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__ParavirtProvider(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__ParavirtProvider(struct soap *soap, enum vbox__ParavirtProvider *p)
{
	if (::soap_read_vbox__ParavirtProvider(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__HWVirtExPropertyType
	*a = SOAP_DEFAULT_vbox__HWVirtExPropertyType;
#else
	*a = (enum vbox__HWVirtExPropertyType)0;
#endif
}

/*noinline*/ int soap_write_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__HWVirtExPropertyType(soap, p, "vbox:HWVirtExPropertyType", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__HWVirtExPropertyType(struct soap *soap, const char *URL, enum vbox__HWVirtExPropertyType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HWVirtExPropertyType(soap, p, "vbox:HWVirtExPropertyType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__HWVirtExPropertyType(struct soap *soap, const char *URL, enum vbox__HWVirtExPropertyType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HWVirtExPropertyType(soap, p, "vbox:HWVirtExPropertyType", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__HWVirtExPropertyType(struct soap *soap, const char *URL, enum vbox__HWVirtExPropertyType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__HWVirtExPropertyType(soap, p, "vbox:HWVirtExPropertyType", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__HWVirtExPropertyType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__HWVirtExPropertyType(struct soap *soap, const char *URL, enum vbox__HWVirtExPropertyType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__HWVirtExPropertyType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__HWVirtExPropertyType(struct soap *soap, enum vbox__HWVirtExPropertyType *p)
{
	if (::soap_read_vbox__HWVirtExPropertyType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CPUPropertyTypeX86(struct soap *soap, enum vbox__CPUPropertyTypeX86 *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CPUPropertyTypeX86
	*a = SOAP_DEFAULT_vbox__CPUPropertyTypeX86;
#else
	*a = (enum vbox__CPUPropertyTypeX86)0;
#endif
}

/*noinline*/ int soap_write_vbox__CPUPropertyTypeX86(struct soap *soap, enum vbox__CPUPropertyTypeX86 const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CPUPropertyTypeX86(soap, p, "vbox:CPUPropertyTypeX86", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CPUPropertyTypeX86(struct soap *soap, const char *URL, enum vbox__CPUPropertyTypeX86 const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CPUPropertyTypeX86(soap, p, "vbox:CPUPropertyTypeX86", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CPUPropertyTypeX86(struct soap *soap, const char *URL, enum vbox__CPUPropertyTypeX86 const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CPUPropertyTypeX86(soap, p, "vbox:CPUPropertyTypeX86", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CPUPropertyTypeX86(struct soap *soap, const char *URL, enum vbox__CPUPropertyTypeX86 const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CPUPropertyTypeX86(soap, p, "vbox:CPUPropertyTypeX86", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CPUPropertyTypeX86(struct soap *soap, enum vbox__CPUPropertyTypeX86 *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CPUPropertyTypeX86(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CPUPropertyTypeX86(struct soap *soap, const char *URL, enum vbox__CPUPropertyTypeX86 *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CPUPropertyTypeX86(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CPUPropertyTypeX86(struct soap *soap, enum vbox__CPUPropertyTypeX86 *p)
{
	if (::soap_read_vbox__CPUPropertyTypeX86(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__CPUArchitecture(struct soap *soap, enum vbox__CPUArchitecture *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__CPUArchitecture
	*a = SOAP_DEFAULT_vbox__CPUArchitecture;
#else
	*a = (enum vbox__CPUArchitecture)0;
#endif
}

/*noinline*/ int soap_write_vbox__CPUArchitecture(struct soap *soap, enum vbox__CPUArchitecture const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__CPUArchitecture(soap, p, "vbox:CPUArchitecture", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__CPUArchitecture(struct soap *soap, const char *URL, enum vbox__CPUArchitecture const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CPUArchitecture(soap, p, "vbox:CPUArchitecture", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__CPUArchitecture(struct soap *soap, const char *URL, enum vbox__CPUArchitecture const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CPUArchitecture(soap, p, "vbox:CPUArchitecture", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__CPUArchitecture(struct soap *soap, const char *URL, enum vbox__CPUArchitecture const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__CPUArchitecture(soap, p, "vbox:CPUArchitecture", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__CPUArchitecture(struct soap *soap, enum vbox__CPUArchitecture *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__CPUArchitecture(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__CPUArchitecture(struct soap *soap, const char *URL, enum vbox__CPUArchitecture *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__CPUArchitecture(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__CPUArchitecture(struct soap *soap, enum vbox__CPUArchitecture *p)
{
	if (::soap_read_vbox__CPUArchitecture(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__PlatformArchitecture(struct soap *soap, enum vbox__PlatformArchitecture *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__PlatformArchitecture
	*a = SOAP_DEFAULT_vbox__PlatformArchitecture;
#else
	*a = (enum vbox__PlatformArchitecture)0;
#endif
}

/*noinline*/ int soap_write_vbox__PlatformArchitecture(struct soap *soap, enum vbox__PlatformArchitecture const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__PlatformArchitecture(soap, p, "vbox:PlatformArchitecture", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__PlatformArchitecture(struct soap *soap, const char *URL, enum vbox__PlatformArchitecture const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PlatformArchitecture(soap, p, "vbox:PlatformArchitecture", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__PlatformArchitecture(struct soap *soap, const char *URL, enum vbox__PlatformArchitecture const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PlatformArchitecture(soap, p, "vbox:PlatformArchitecture", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__PlatformArchitecture(struct soap *soap, const char *URL, enum vbox__PlatformArchitecture const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__PlatformArchitecture(soap, p, "vbox:PlatformArchitecture", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__PlatformArchitecture(struct soap *soap, enum vbox__PlatformArchitecture *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__PlatformArchitecture(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__PlatformArchitecture(struct soap *soap, const char *URL, enum vbox__PlatformArchitecture *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__PlatformArchitecture(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__PlatformArchitecture(struct soap *soap, enum vbox__PlatformArchitecture *p)
{
	if (::soap_read_vbox__PlatformArchitecture(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SessionState(struct soap *soap, enum vbox__SessionState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SessionState
	*a = SOAP_DEFAULT_vbox__SessionState;
#else
	*a = (enum vbox__SessionState)0;
#endif
}

/*noinline*/ int soap_write_vbox__SessionState(struct soap *soap, enum vbox__SessionState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SessionState(soap, p, "vbox:SessionState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SessionState(struct soap *soap, const char *URL, enum vbox__SessionState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SessionState(soap, p, "vbox:SessionState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SessionState(struct soap *soap, const char *URL, enum vbox__SessionState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SessionState(soap, p, "vbox:SessionState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SessionState(struct soap *soap, const char *URL, enum vbox__SessionState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SessionState(soap, p, "vbox:SessionState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SessionState(struct soap *soap, enum vbox__SessionState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SessionState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SessionState(struct soap *soap, const char *URL, enum vbox__SessionState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SessionState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SessionState(struct soap *soap, enum vbox__SessionState *p)
{
	if (::soap_read_vbox__SessionState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__MachineState(struct soap *soap, enum vbox__MachineState *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__MachineState
	*a = SOAP_DEFAULT_vbox__MachineState;
#else
	*a = (enum vbox__MachineState)0;
#endif
}

/*noinline*/ int soap_write_vbox__MachineState(struct soap *soap, enum vbox__MachineState const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__MachineState(soap, p, "vbox:MachineState", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__MachineState(struct soap *soap, const char *URL, enum vbox__MachineState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MachineState(soap, p, "vbox:MachineState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__MachineState(struct soap *soap, const char *URL, enum vbox__MachineState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MachineState(soap, p, "vbox:MachineState", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__MachineState(struct soap *soap, const char *URL, enum vbox__MachineState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__MachineState(soap, p, "vbox:MachineState", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__MachineState(struct soap *soap, enum vbox__MachineState *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__MachineState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__MachineState(struct soap *soap, const char *URL, enum vbox__MachineState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__MachineState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__MachineState(struct soap *soap, enum vbox__MachineState *p)
{
	if (::soap_read_vbox__MachineState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__AccessMode
	*a = SOAP_DEFAULT_vbox__AccessMode;
#else
	*a = (enum vbox__AccessMode)0;
#endif
}

/*noinline*/ int soap_write_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__AccessMode(soap, p, "vbox:AccessMode", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__AccessMode(struct soap *soap, const char *URL, enum vbox__AccessMode const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AccessMode(soap, p, "vbox:AccessMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__AccessMode(struct soap *soap, const char *URL, enum vbox__AccessMode const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AccessMode(soap, p, "vbox:AccessMode", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__AccessMode(struct soap *soap, const char *URL, enum vbox__AccessMode const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__AccessMode(soap, p, "vbox:AccessMode", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__AccessMode(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__AccessMode(struct soap *soap, const char *URL, enum vbox__AccessMode *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__AccessMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__AccessMode(struct soap *soap, enum vbox__AccessMode *p)
{
	if (::soap_read_vbox__AccessMode(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ void soap_default_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *a)
{
	(void)soap; /* appease -Wall -Werror */
#ifdef SOAP_DEFAULT_vbox__SettingsVersion
	*a = SOAP_DEFAULT_vbox__SettingsVersion;
#else
	*a = (enum vbox__SettingsVersion)0;
#endif
}

/*noinline*/ int soap_write_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion const*p)
{
	soap_free_temp(soap);
	if (p)
	{	if (soap_begin_send(soap) || ::soap_put_vbox__SettingsVersion(soap, p, "vbox:SettingsVersion", "") || soap_end_send(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_PUT_vbox__SettingsVersion(struct soap *soap, const char *URL, enum vbox__SettingsVersion const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SettingsVersion(soap, p, "vbox:SettingsVersion", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH_vbox__SettingsVersion(struct soap *soap, const char *URL, enum vbox__SettingsVersion const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SettingsVersion(soap, p, "vbox:SettingsVersion", "") || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send_vbox__SettingsVersion(struct soap *soap, const char *URL, enum vbox__SettingsVersion const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || ::soap_put_vbox__SettingsVersion(soap, p, "vbox:SettingsVersion", "") || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *p)
{
	if (p)
	{	if (soap_begin_recv(soap) || ::soap_get_vbox__SettingsVersion(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET_vbox__SettingsVersion(struct soap *soap, const char *URL, enum vbox__SettingsVersion *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read_vbox__SettingsVersion(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv_vbox__SettingsVersion(struct soap *soap, enum vbox__SettingsVersion *p)
{
	if (::soap_read_vbox__SettingsVersion(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse * soap_new__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse * soap_new_req__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse *_p = ::soap_new__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse * soap_new_set__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse *_p = ::soap_new__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageIdResponse", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageIdResponse", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageIdResponse", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageIdResponse", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(struct soap *soap, _vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse *p)
{
	if (::soap_read__vbox__ILanguageChangedEvent_USCOREgetLanguageIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ILanguageChangedEvent_USCOREgetLanguageId * soap_new__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ILanguageChangedEvent_USCOREgetLanguageId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ILanguageChangedEvent_USCOREgetLanguageId * soap_new_req__vbox__ILanguageChangedEvent_USCOREgetLanguageId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ILanguageChangedEvent_USCOREgetLanguageId *_p = ::soap_new__vbox__ILanguageChangedEvent_USCOREgetLanguageId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ILanguageChangedEvent_USCOREgetLanguageId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ILanguageChangedEvent_USCOREgetLanguageId * soap_new_set__vbox__ILanguageChangedEvent_USCOREgetLanguageId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ILanguageChangedEvent_USCOREgetLanguageId *_p = ::soap_new__vbox__ILanguageChangedEvent_USCOREgetLanguageId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ILanguageChangedEvent_USCOREgetLanguageId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, _vbox__ILanguageChangedEvent_USCOREgetLanguageId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageId", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageId", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageId", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ILanguageChangedEvent_getLanguageId", p->soap_type() == SOAP_TYPE__vbox__ILanguageChangedEvent_USCOREgetLanguageId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, _vbox__ILanguageChangedEvent_USCOREgetLanguageId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ILanguageChangedEvent_USCOREgetLanguageId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, const char *URL, _vbox__ILanguageChangedEvent_USCOREgetLanguageId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ILanguageChangedEvent_USCOREgetLanguageId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ILanguageChangedEvent_USCOREgetLanguageId(struct soap *soap, _vbox__ILanguageChangedEvent_USCOREgetLanguageId *p)
{
	if (::soap_read__vbox__ILanguageChangedEvent_USCOREgetLanguageId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse * soap_new__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse * soap_new_req__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse * soap_new_set__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetName * soap_new__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileChangedEvent_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetName * soap_new_req__vbox__ICloudProfileChangedEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetName *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetName * soap_new_set__vbox__ICloudProfileChangedEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetName *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileChangedEvent_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileChangedEvent_USCOREgetName(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetName *p)
{
	if (::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse * soap_new__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse * soap_new_req__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse * soap_new_set__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse *p)
{
	if (::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetProviderIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetProviderId * soap_new__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetProviderId * soap_new_req__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetProviderId *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetProviderId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileChangedEvent_USCOREgetProviderId * soap_new_set__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileChangedEvent_USCOREgetProviderId *_p = ::soap_new__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileChangedEvent_USCOREgetProviderId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileChangedEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileChangedEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfileChangedEvent_USCOREgetProviderId *p)
{
	if (::soap_read__vbox__ICloudProfileChangedEvent_USCOREgetProviderId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse * soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse * soap_new_req__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse * soap_new_set__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse *p)
{
	if (::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetRegisteredResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered * soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered * soap_new_req__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered * soap_new_set__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered *p)
{
	if (::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetRegistered(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse * soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse * soap_new_req__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse * soap_new_set__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetName * soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileRegisteredEvent_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetName * soap_new_req__vbox__ICloudProfileRegisteredEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetName *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetName * soap_new_set__vbox__ICloudProfileRegisteredEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetName *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileRegisteredEvent_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileRegisteredEvent_USCOREgetName(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetName *p)
{
	if (::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse * soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse * soap_new_req__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse * soap_new_set__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse *p)
{
	if (::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId * soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId * soap_new_req__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId * soap_new_set__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId *_p = ::soap_new__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfileRegisteredEvent_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId *p)
{
	if (::soap_read__vbox__ICloudProfileRegisteredEvent_USCOREgetProviderId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse * soap_new__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse * soap_new_req__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse * soap_new_set__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse *p)
{
	if (::soap_read__vbox__ICloudProviderUninstallEvent_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderUninstallEvent_USCOREgetId * soap_new__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderUninstallEvent_USCOREgetId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderUninstallEvent_USCOREgetId * soap_new_req__vbox__ICloudProviderUninstallEvent_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderUninstallEvent_USCOREgetId *_p = ::soap_new__vbox__ICloudProviderUninstallEvent_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderUninstallEvent_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderUninstallEvent_USCOREgetId * soap_new_set__vbox__ICloudProviderUninstallEvent_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderUninstallEvent_USCOREgetId *_p = ::soap_new__vbox__ICloudProviderUninstallEvent_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderUninstallEvent_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, _vbox__ICloudProviderUninstallEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderUninstallEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderUninstallEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, _vbox__ICloudProviderUninstallEvent_USCOREgetId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderUninstallEvent_USCOREgetId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderUninstallEvent_USCOREgetId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderUninstallEvent_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderUninstallEvent_USCOREgetId(struct soap *soap, _vbox__ICloudProviderUninstallEvent_USCOREgetId *p)
{
	if (::soap_read__vbox__ICloudProviderUninstallEvent_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse * soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse * soap_new_req__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse * soap_new_set__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse *p)
{
	if (::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetRegisteredResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered * soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered * soap_new_req__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered * soap_new_set__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered *p)
{
	if (::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetRegistered(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse * soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse * soap_new_req__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse * soap_new_set__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse *p)
{
	if (::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetId * soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderRegisteredEvent_USCOREgetId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetId * soap_new_req__vbox__ICloudProviderRegisteredEvent_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetId *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderRegisteredEvent_USCOREgetId * soap_new_set__vbox__ICloudProviderRegisteredEvent_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderRegisteredEvent_USCOREgetId *_p = ::soap_new__vbox__ICloudProviderRegisteredEvent_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderRegisteredEvent_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderRegisteredEvent_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderRegisteredEvent_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderRegisteredEvent_USCOREgetId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProviderRegisteredEvent_USCOREgetId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderRegisteredEvent_USCOREgetId(struct soap *soap, _vbox__ICloudProviderRegisteredEvent_USCOREgetId *p)
{
	if (::soap_read__vbox__ICloudProviderRegisteredEvent_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse * soap_new__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse * soap_new_req__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse *_p = ::soap_new__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse * soap_new_set__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse *_p = ::soap_new__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegisteredResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(struct soap *soap, _vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse *p)
{
	if (::soap_read__vbox__ICloudProviderListChangedEvent_USCOREgetRegisteredResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered * soap_new__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered * soap_new_req__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderListChangedEvent_USCOREgetRegistered *_p = ::soap_new__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderListChangedEvent_USCOREgetRegistered::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered * soap_new_set__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderListChangedEvent_USCOREgetRegistered *_p = ::soap_new__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderListChangedEvent_USCOREgetRegistered::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderListChangedEvent_getRegistered", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, const char *URL, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(struct soap *soap, _vbox__ICloudProviderListChangedEvent_USCOREgetRegistered *p)
{
	if (::soap_read__vbox__ICloudProviderListChangedEvent_USCOREgetRegistered(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse * soap_new__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByNameResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByNameResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByNameResponse *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByName * soap_new__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviderByName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByName * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviderByName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& providerName)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByName *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByName::providerName = providerName;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByName * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviderByName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& providerName)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByName *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByName::providerName = providerName;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviderByName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviderByName(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByName *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse * soap_new__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByShortNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByShortName * soap_new__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviderByShortName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByShortName * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviderByShortName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& providerName)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByShortName *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByShortName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByShortName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByShortName::providerName = providerName;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByShortName * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviderByShortName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& providerName)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByShortName *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByShortName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByShortName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByShortName::providerName = providerName;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByShortName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByShortName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByShortName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviderByShortName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByShortName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByShortName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviderByShortName(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByShortName *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByShortName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse * soap_new__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByIdResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProviderByIdResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderByIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderByIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderByIdResponse *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviderByIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderById * soap_new__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviderById(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderById * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviderById(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& providerId)
{
	_vbox__ICloudProviderManager_USCOREgetProviderById *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderById(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderById::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProviderManager_USCOREgetProviderById::providerId = providerId;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviderById * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviderById(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& providerId)
{
	_vbox__ICloudProviderManager_USCOREgetProviderById *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviderById(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviderById::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProviderManager_USCOREgetProviderById::providerId = providerId;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderById const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderById", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderById ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderById const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderById", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderById ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderById const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderById", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderById ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderById const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviderById", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviderById ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderById *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviderById(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviderById *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviderById(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviderById(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviderById *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviderById(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProvidersResponse * soap_new__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProvidersResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProvidersResponse * soap_new_req__vbox__ICloudProviderManager_USCOREgetProvidersResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProvidersResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProvidersResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProvidersResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProvidersResponse * soap_new_set__vbox__ICloudProviderManager_USCOREgetProvidersResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProviderManager_USCOREgetProvidersResponse *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProvidersResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProvidersResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProvidersResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProvidersResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProvidersResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProvidersResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProvidersResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProvidersResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProvidersResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProvidersResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProvidersResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProvidersResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProvidersResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProvidersResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProvidersResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProvidersResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProvidersResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProvidersResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProvidersResponse(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProvidersResponse *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProvidersResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviders * soap_new__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProviderManager_USCOREgetProviders(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviders * soap_new_req__vbox__ICloudProviderManager_USCOREgetProviders(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderManager_USCOREgetProviders *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviders(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviders::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProviderManager_USCOREgetProviders * soap_new_set__vbox__ICloudProviderManager_USCOREgetProviders(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProviderManager_USCOREgetProviders *_p = ::soap_new__vbox__ICloudProviderManager_USCOREgetProviders(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProviderManager_USCOREgetProviders::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviders const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviders", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviders ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviders const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviders", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviders ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviders const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviders", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviders ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviders const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProviderManager_getProviders", p->soap_type() == SOAP_TYPE__vbox__ICloudProviderManager_USCOREgetProviders ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviders *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProviderManager_USCOREgetProviders(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, const char *URL, _vbox__ICloudProviderManager_USCOREgetProviders *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProviderManager_USCOREgetProviders(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProviderManager_USCOREgetProviders(struct soap *soap, _vbox__ICloudProviderManager_USCOREgetProviders *p)
{
	if (::soap_read__vbox__ICloudProviderManager_USCOREgetProviders(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREprepareUninstallResponse * soap_new__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREprepareUninstallResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREprepareUninstallResponse * soap_new_req__vbox__ICloudProvider_USCOREprepareUninstallResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREprepareUninstallResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREprepareUninstallResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREprepareUninstallResponse * soap_new_set__vbox__ICloudProvider_USCOREprepareUninstallResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREprepareUninstallResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREprepareUninstallResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, _vbox__ICloudProvider_USCOREprepareUninstallResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstallResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstallResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstallResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstallResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstallResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstallResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstallResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstallResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstallResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstallResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstallResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, _vbox__ICloudProvider_USCOREprepareUninstallResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREprepareUninstallResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstallResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREprepareUninstallResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREprepareUninstallResponse(struct soap *soap, _vbox__ICloudProvider_USCOREprepareUninstallResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREprepareUninstallResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREprepareUninstall * soap_new__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREprepareUninstall(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREprepareUninstall * soap_new_req__vbox__ICloudProvider_USCOREprepareUninstall(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREprepareUninstall *_p = ::soap_new__vbox__ICloudProvider_USCOREprepareUninstall(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREprepareUninstall::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREprepareUninstall * soap_new_set__vbox__ICloudProvider_USCOREprepareUninstall(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREprepareUninstall *_p = ::soap_new__vbox__ICloudProvider_USCOREprepareUninstall(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREprepareUninstall::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, _vbox__ICloudProvider_USCOREprepareUninstall const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstall", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstall ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstall const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstall", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstall ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstall const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstall", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstall ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstall const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_prepareUninstall", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREprepareUninstall ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, _vbox__ICloudProvider_USCOREprepareUninstall *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREprepareUninstall(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREprepareUninstall *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREprepareUninstall(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREprepareUninstall(struct soap *soap, _vbox__ICloudProvider_USCOREprepareUninstall *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREprepareUninstall(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileByNameResponse * soap_new__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetProfileByNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileByNameResponse * soap_new_req__vbox__ICloudProvider_USCOREgetProfileByNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetProfileByNameResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileByNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileByNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileByNameResponse * soap_new_set__vbox__ICloudProvider_USCOREgetProfileByNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetProfileByNameResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileByNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileByNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileByNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetProfileByNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetProfileByNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetProfileByNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileByNameResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetProfileByNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileByName * soap_new__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetProfileByName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileByName * soap_new_req__vbox__ICloudProvider_USCOREgetProfileByName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& profileName)
{
	_vbox__ICloudProvider_USCOREgetProfileByName *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileByName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileByName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProvider_USCOREgetProfileByName::profileName = profileName;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileByName * soap_new_set__vbox__ICloudProvider_USCOREgetProfileByName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& profileName)
{
	_vbox__ICloudProvider_USCOREgetProfileByName *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileByName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileByName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProvider_USCOREgetProfileByName::profileName = profileName;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileByName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileByName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileByName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileByName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetProfileByName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileByName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetProfileByName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetProfileByName(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileByName *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetProfileByName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREsaveProfilesResponse * soap_new__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREsaveProfilesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREsaveProfilesResponse * soap_new_req__vbox__ICloudProvider_USCOREsaveProfilesResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREsaveProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREsaveProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREsaveProfilesResponse * soap_new_set__vbox__ICloudProvider_USCOREsaveProfilesResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREsaveProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREsaveProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREsaveProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREsaveProfilesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREsaveProfilesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfilesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREsaveProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREsaveProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREsaveProfilesResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREsaveProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREsaveProfiles * soap_new__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREsaveProfiles(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREsaveProfiles * soap_new_req__vbox__ICloudProvider_USCOREsaveProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREsaveProfiles *_p = ::soap_new__vbox__ICloudProvider_USCOREsaveProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREsaveProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREsaveProfiles * soap_new_set__vbox__ICloudProvider_USCOREsaveProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREsaveProfiles *_p = ::soap_new__vbox__ICloudProvider_USCOREsaveProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREsaveProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREsaveProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfiles ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_saveProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREsaveProfiles ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREsaveProfiles *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREsaveProfiles(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREsaveProfiles *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREsaveProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREsaveProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREsaveProfiles *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREsaveProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCORErestoreProfilesResponse * soap_new__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCORErestoreProfilesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCORErestoreProfilesResponse * soap_new_req__vbox__ICloudProvider_USCORErestoreProfilesResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCORErestoreProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCORErestoreProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCORErestoreProfilesResponse * soap_new_set__vbox__ICloudProvider_USCORErestoreProfilesResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCORErestoreProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCORErestoreProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCORErestoreProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCORErestoreProfilesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCORErestoreProfilesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfilesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCORErestoreProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCORErestoreProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCORErestoreProfilesResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCORErestoreProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCORErestoreProfiles * soap_new__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCORErestoreProfiles(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCORErestoreProfiles * soap_new_req__vbox__ICloudProvider_USCORErestoreProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCORErestoreProfiles *_p = ::soap_new__vbox__ICloudProvider_USCORErestoreProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCORErestoreProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCORErestoreProfiles * soap_new_set__vbox__ICloudProvider_USCORErestoreProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCORErestoreProfiles *_p = ::soap_new__vbox__ICloudProvider_USCORErestoreProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCORErestoreProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, _vbox__ICloudProvider_USCORErestoreProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfiles ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_restoreProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCORErestoreProfiles ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, _vbox__ICloudProvider_USCORErestoreProfiles *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCORErestoreProfiles(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCORErestoreProfiles *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCORErestoreProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCORErestoreProfiles(struct soap *soap, _vbox__ICloudProvider_USCORErestoreProfiles *p)
{
	if (::soap_read__vbox__ICloudProvider_USCORErestoreProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREimportProfilesResponse * soap_new__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREimportProfilesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREimportProfilesResponse * soap_new_req__vbox__ICloudProvider_USCOREimportProfilesResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREimportProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREimportProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREimportProfilesResponse * soap_new_set__vbox__ICloudProvider_USCOREimportProfilesResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREimportProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREimportProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREimportProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREimportProfilesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREimportProfilesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfilesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREimportProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREimportProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREimportProfilesResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREimportProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREimportProfiles * soap_new__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREimportProfiles(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREimportProfiles * soap_new_req__vbox__ICloudProvider_USCOREimportProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREimportProfiles *_p = ::soap_new__vbox__ICloudProvider_USCOREimportProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREimportProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREimportProfiles * soap_new_set__vbox__ICloudProvider_USCOREimportProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREimportProfiles *_p = ::soap_new__vbox__ICloudProvider_USCOREimportProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREimportProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREimportProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfiles ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_importProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREimportProfiles ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREimportProfiles *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREimportProfiles(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREimportProfiles *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREimportProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREimportProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREimportProfiles *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREimportProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREcreateProfileResponse * soap_new__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREcreateProfileResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREcreateProfileResponse * soap_new_req__vbox__ICloudProvider_USCOREcreateProfileResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREcreateProfileResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREcreateProfileResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREcreateProfileResponse * soap_new_set__vbox__ICloudProvider_USCOREcreateProfileResponse(
	struct soap *soap)
{
	_vbox__ICloudProvider_USCOREcreateProfileResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREcreateProfileResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, _vbox__ICloudProvider_USCOREcreateProfileResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfileResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfileResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfileResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfileResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfileResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfileResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfileResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfileResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfileResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfileResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfileResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, _vbox__ICloudProvider_USCOREcreateProfileResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREcreateProfileResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfileResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREcreateProfileResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREcreateProfileResponse(struct soap *soap, _vbox__ICloudProvider_USCOREcreateProfileResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREcreateProfileResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREcreateProfile * soap_new__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREcreateProfile(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREcreateProfile * soap_new_req__vbox__ICloudProvider_USCOREcreateProfile(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& profileName,
	const std::vector<std::string> & names,
	const std::vector<std::string> & values)
{
	_vbox__ICloudProvider_USCOREcreateProfile *_p = ::soap_new__vbox__ICloudProvider_USCOREcreateProfile(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREcreateProfile::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProvider_USCOREcreateProfile::profileName = profileName;
		_p->_vbox__ICloudProvider_USCOREcreateProfile::names = names;
		_p->_vbox__ICloudProvider_USCOREcreateProfile::values = values;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREcreateProfile * soap_new_set__vbox__ICloudProvider_USCOREcreateProfile(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& profileName,
	const std::vector<std::string> & names,
	const std::vector<std::string> & values)
{
	_vbox__ICloudProvider_USCOREcreateProfile *_p = ::soap_new__vbox__ICloudProvider_USCOREcreateProfile(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREcreateProfile::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProvider_USCOREcreateProfile::profileName = profileName;
		_p->_vbox__ICloudProvider_USCOREcreateProfile::names = names;
		_p->_vbox__ICloudProvider_USCOREcreateProfile::values = values;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, _vbox__ICloudProvider_USCOREcreateProfile const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfile", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfile ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfile const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfile", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfile ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfile const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfile", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfile ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfile const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_createProfile", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREcreateProfile ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, _vbox__ICloudProvider_USCOREcreateProfile *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREcreateProfile(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREcreateProfile *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREcreateProfile(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREcreateProfile(struct soap *soap, _vbox__ICloudProvider_USCOREcreateProfile *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREcreateProfile(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse * soap_new__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse * soap_new_req__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse * soap_new_set__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetPropertyDescriptionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetPropertyDescription * soap_new__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetPropertyDescription(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetPropertyDescription * soap_new_req__vbox__ICloudProvider_USCOREgetPropertyDescription(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name)
{
	_vbox__ICloudProvider_USCOREgetPropertyDescription *_p = ::soap_new__vbox__ICloudProvider_USCOREgetPropertyDescription(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetPropertyDescription::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProvider_USCOREgetPropertyDescription::name = name;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetPropertyDescription * soap_new_set__vbox__ICloudProvider_USCOREgetPropertyDescription(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name)
{
	_vbox__ICloudProvider_USCOREgetPropertyDescription *_p = ::soap_new__vbox__ICloudProvider_USCOREgetPropertyDescription(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetPropertyDescription::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProvider_USCOREgetPropertyDescription::name = name;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, _vbox__ICloudProvider_USCOREgetPropertyDescription const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescription", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescription ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescription const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescription", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescription ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescription const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescription", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescription ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescription const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getPropertyDescription", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetPropertyDescription ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, _vbox__ICloudProvider_USCOREgetPropertyDescription *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetPropertyDescription(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetPropertyDescription *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetPropertyDescription(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetPropertyDescription(struct soap *soap, _vbox__ICloudProvider_USCOREgetPropertyDescription *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetPropertyDescription(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse * soap_new__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse * soap_new_req__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse * soap_new_set__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetSupportedPropertyNamesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetSupportedPropertyNames * soap_new__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetSupportedPropertyNames * soap_new_req__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetSupportedPropertyNames *_p = ::soap_new__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetSupportedPropertyNames::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetSupportedPropertyNames * soap_new_set__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetSupportedPropertyNames *_p = ::soap_new__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetSupportedPropertyNames::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNames ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNames ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNames ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getSupportedPropertyNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetSupportedPropertyNames ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(struct soap *soap, _vbox__ICloudProvider_USCOREgetSupportedPropertyNames *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetSupportedPropertyNames(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileNamesResponse * soap_new__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetProfileNamesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileNamesResponse * soap_new_req__vbox__ICloudProvider_USCOREgetProfileNamesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProvider_USCOREgetProfileNamesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileNamesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileNamesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileNamesResponse * soap_new_set__vbox__ICloudProvider_USCOREgetProfileNamesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProvider_USCOREgetProfileNamesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileNamesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileNamesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNamesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNamesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNamesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNamesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileNamesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetProfileNamesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNamesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetProfileNamesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetProfileNamesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileNamesResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetProfileNamesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileNames * soap_new__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetProfileNames(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileNames * soap_new_req__vbox__ICloudProvider_USCOREgetProfileNames(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetProfileNames *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileNames(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileNames::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfileNames * soap_new_set__vbox__ICloudProvider_USCOREgetProfileNames(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetProfileNames *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfileNames(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfileNames::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileNames const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNames ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNames const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNames ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNames const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNames ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNames const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfileNames", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfileNames ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileNames *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetProfileNames(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfileNames *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetProfileNames(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetProfileNames(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfileNames *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetProfileNames(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfilesResponse * soap_new__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetProfilesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfilesResponse * soap_new_req__vbox__ICloudProvider_USCOREgetProfilesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProvider_USCOREgetProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfilesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfilesResponse * soap_new_set__vbox__ICloudProvider_USCOREgetProfilesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProvider_USCOREgetProfilesResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfilesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfilesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfilesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfilesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfilesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfilesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfilesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetProfilesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfilesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetProfilesResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfilesResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetProfilesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfiles * soap_new__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetProfiles(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfiles * soap_new_req__vbox__ICloudProvider_USCOREgetProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetProfiles *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetProfiles * soap_new_set__vbox__ICloudProvider_USCOREgetProfiles(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetProfiles *_p = ::soap_new__vbox__ICloudProvider_USCOREgetProfiles(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetProfiles::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfiles ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfiles ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfiles const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getProfiles", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetProfiles ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfiles *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetProfiles(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetProfiles *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetProfiles(struct soap *soap, _vbox__ICloudProvider_USCOREgetProfiles *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetProfiles(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetIdResponse * soap_new__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetIdResponse * soap_new_req__vbox__ICloudProvider_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetIdResponse * soap_new_set__vbox__ICloudProvider_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetIdResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetId * soap_new__vbox__ICloudProvider_USCOREgetId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetId * soap_new_req__vbox__ICloudProvider_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetId *_p = ::soap_new__vbox__ICloudProvider_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetId * soap_new_set__vbox__ICloudProvider_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetId *_p = ::soap_new__vbox__ICloudProvider_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetId(struct soap *soap, _vbox__ICloudProvider_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetId(struct soap *soap, _vbox__ICloudProvider_USCOREgetId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetId(struct soap *soap, _vbox__ICloudProvider_USCOREgetId *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetShortNameResponse * soap_new__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetShortNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetShortNameResponse * soap_new_req__vbox__ICloudProvider_USCOREgetShortNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetShortNameResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetShortNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetShortNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetShortNameResponse * soap_new_set__vbox__ICloudProvider_USCOREgetShortNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetShortNameResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetShortNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetShortNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetShortNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetShortNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetShortNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetShortNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetShortNameResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetShortNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetShortName * soap_new__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetShortName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetShortName * soap_new_req__vbox__ICloudProvider_USCOREgetShortName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetShortName *_p = ::soap_new__vbox__ICloudProvider_USCOREgetShortName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetShortName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetShortName * soap_new_set__vbox__ICloudProvider_USCOREgetShortName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetShortName *_p = ::soap_new__vbox__ICloudProvider_USCOREgetShortName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetShortName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, _vbox__ICloudProvider_USCOREgetShortName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getShortName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetShortName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, _vbox__ICloudProvider_USCOREgetShortName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetShortName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetShortName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetShortName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetShortName(struct soap *soap, _vbox__ICloudProvider_USCOREgetShortName *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetShortName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetNameResponse * soap_new__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetNameResponse * soap_new_req__vbox__ICloudProvider_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetNameResponse * soap_new_set__vbox__ICloudProvider_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProvider_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProvider_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProvider_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetName * soap_new__vbox__ICloudProvider_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProvider_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetName * soap_new_req__vbox__ICloudProvider_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetName *_p = ::soap_new__vbox__ICloudProvider_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProvider_USCOREgetName * soap_new_set__vbox__ICloudProvider_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProvider_USCOREgetName *_p = ::soap_new__vbox__ICloudProvider_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProvider_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProvider_USCOREgetName(struct soap *soap, _vbox__ICloudProvider_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProvider_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProvider_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProvider_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProvider_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProvider_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProvider_USCOREgetName(struct soap *soap, _vbox__ICloudProvider_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProvider_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProvider_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProvider_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProvider_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProvider_USCOREgetName(struct soap *soap, _vbox__ICloudProvider_USCOREgetName *p)
{
	if (::soap_read__vbox__ICloudProvider_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREcreateCloudClientResponse * soap_new__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREcreateCloudClientResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREcreateCloudClientResponse * soap_new_req__vbox__ICloudProfile_USCOREcreateCloudClientResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREcreateCloudClientResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREcreateCloudClientResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREcreateCloudClientResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREcreateCloudClientResponse * soap_new_set__vbox__ICloudProfile_USCOREcreateCloudClientResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREcreateCloudClientResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREcreateCloudClientResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREcreateCloudClientResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, _vbox__ICloudProfile_USCOREcreateCloudClientResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClientResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClientResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClientResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClientResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClientResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClientResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClientResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClientResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClientResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClientResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClientResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, _vbox__ICloudProfile_USCOREcreateCloudClientResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREcreateCloudClientResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClientResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREcreateCloudClientResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREcreateCloudClientResponse(struct soap *soap, _vbox__ICloudProfile_USCOREcreateCloudClientResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREcreateCloudClientResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREcreateCloudClient * soap_new__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREcreateCloudClient(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREcreateCloudClient * soap_new_req__vbox__ICloudProfile_USCOREcreateCloudClient(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREcreateCloudClient *_p = ::soap_new__vbox__ICloudProfile_USCOREcreateCloudClient(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREcreateCloudClient::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREcreateCloudClient * soap_new_set__vbox__ICloudProfile_USCOREcreateCloudClient(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREcreateCloudClient *_p = ::soap_new__vbox__ICloudProfile_USCOREcreateCloudClient(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREcreateCloudClient::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, _vbox__ICloudProfile_USCOREcreateCloudClient const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClient", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClient ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClient const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClient", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClient ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClient const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClient", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClient ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClient const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_createCloudClient", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREcreateCloudClient ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, _vbox__ICloudProfile_USCOREcreateCloudClient *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREcreateCloudClient(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREcreateCloudClient *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREcreateCloudClient(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREcreateCloudClient(struct soap *soap, _vbox__ICloudProfile_USCOREcreateCloudClient *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREcreateCloudClient(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREremoveResponse * soap_new__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREremoveResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREremoveResponse * soap_new_req__vbox__ICloudProfile_USCOREremoveResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREremoveResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREremoveResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREremoveResponse * soap_new_set__vbox__ICloudProfile_USCOREremoveResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREremoveResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREremoveResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, _vbox__ICloudProfile_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, _vbox__ICloudProfile_USCOREremoveResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREremoveResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremoveResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREremoveResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREremoveResponse(struct soap *soap, _vbox__ICloudProfile_USCOREremoveResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREremoveResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREremove * soap_new__vbox__ICloudProfile_USCOREremove(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREremove(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREremove * soap_new_req__vbox__ICloudProfile_USCOREremove(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREremove *_p = ::soap_new__vbox__ICloudProfile_USCOREremove(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREremove::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREremove * soap_new_set__vbox__ICloudProfile_USCOREremove(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREremove *_p = ::soap_new__vbox__ICloudProfile_USCOREremove(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREremove::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREremove(struct soap *soap, _vbox__ICloudProfile_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremove ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremove ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremove ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREremove ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREremove(struct soap *soap, _vbox__ICloudProfile_USCOREremove *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREremove(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREremove *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREremove(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREremove(struct soap *soap, _vbox__ICloudProfile_USCOREremove *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREremove(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetPropertiesResponse * soap_new__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREsetPropertiesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetPropertiesResponse * soap_new_req__vbox__ICloudProfile_USCOREsetPropertiesResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREsetPropertiesResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREsetPropertiesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetPropertiesResponse * soap_new_set__vbox__ICloudProfile_USCOREsetPropertiesResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREsetPropertiesResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREsetPropertiesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertiesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertiesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertiesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertiesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetPropertiesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREsetPropertiesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertiesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREsetPropertiesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREsetPropertiesResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetPropertiesResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREsetPropertiesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetProperties * soap_new__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREsetProperties(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetProperties * soap_new_req__vbox__ICloudProfile_USCOREsetProperties(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<std::string> & names,
	const std::vector<std::string> & values)
{
	_vbox__ICloudProfile_USCOREsetProperties *_p = ::soap_new__vbox__ICloudProfile_USCOREsetProperties(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREsetProperties::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREsetProperties::names = names;
		_p->_vbox__ICloudProfile_USCOREsetProperties::values = values;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetProperties * soap_new_set__vbox__ICloudProfile_USCOREsetProperties(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<std::string> & names,
	const std::vector<std::string> & values)
{
	_vbox__ICloudProfile_USCOREsetProperties *_p = ::soap_new__vbox__ICloudProfile_USCOREsetProperties(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREsetProperties::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREsetProperties::names = names;
		_p->_vbox__ICloudProfile_USCOREsetProperties::values = values;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, _vbox__ICloudProfile_USCOREsetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperties ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperties ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperties ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperties ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, _vbox__ICloudProfile_USCOREsetProperties *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREsetProperties(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperties *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREsetProperties(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREsetProperties(struct soap *soap, _vbox__ICloudProfile_USCOREsetProperties *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREsetProperties(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetPropertiesResponse * soap_new__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetPropertiesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetPropertiesResponse * soap_new_req__vbox__ICloudProfile_USCOREgetPropertiesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnNames,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProfile_USCOREgetPropertiesResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetPropertiesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetPropertiesResponse::returnNames = returnNames;
		_p->_vbox__ICloudProfile_USCOREgetPropertiesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetPropertiesResponse * soap_new_set__vbox__ICloudProfile_USCOREgetPropertiesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnNames,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudProfile_USCOREgetPropertiesResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetPropertiesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetPropertiesResponse::returnNames = returnNames;
		_p->_vbox__ICloudProfile_USCOREgetPropertiesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertiesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertiesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertiesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertiesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertiesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertiesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetPropertiesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetPropertiesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertiesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetPropertiesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetPropertiesResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetPropertiesResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetPropertiesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProperties * soap_new__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetProperties(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProperties * soap_new_req__vbox__ICloudProfile_USCOREgetProperties(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& names)
{
	_vbox__ICloudProfile_USCOREgetProperties *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProperties(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProperties::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREgetProperties::names = names;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProperties * soap_new_set__vbox__ICloudProfile_USCOREgetProperties(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& names)
{
	_vbox__ICloudProfile_USCOREgetProperties *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProperties(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProperties::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREgetProperties::names = names;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, _vbox__ICloudProfile_USCOREgetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperties ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperties ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperties ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperties const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperties", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperties ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, _vbox__ICloudProfile_USCOREgetProperties *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetProperties(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperties *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetProperties(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetProperties(struct soap *soap, _vbox__ICloudProfile_USCOREgetProperties *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetProperties(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetPropertyResponse * soap_new__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREsetPropertyResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetPropertyResponse * soap_new_req__vbox__ICloudProfile_USCOREsetPropertyResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREsetPropertyResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREsetPropertyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetPropertyResponse * soap_new_set__vbox__ICloudProfile_USCOREsetPropertyResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREsetPropertyResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREsetPropertyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertyResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetPropertyResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetPropertyResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREsetPropertyResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetPropertyResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREsetPropertyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREsetPropertyResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetPropertyResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREsetPropertyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetProperty * soap_new__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREsetProperty(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetProperty * soap_new_req__vbox__ICloudProfile_USCOREsetProperty(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name,
	const std::string& value)
{
	_vbox__ICloudProfile_USCOREsetProperty *_p = ::soap_new__vbox__ICloudProfile_USCOREsetProperty(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREsetProperty::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREsetProperty::name = name;
		_p->_vbox__ICloudProfile_USCOREsetProperty::value = value;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetProperty * soap_new_set__vbox__ICloudProfile_USCOREsetProperty(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name,
	const std::string& value)
{
	_vbox__ICloudProfile_USCOREsetProperty *_p = ::soap_new__vbox__ICloudProfile_USCOREsetProperty(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREsetProperty::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREsetProperty::name = name;
		_p->_vbox__ICloudProfile_USCOREsetProperty::value = value;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, _vbox__ICloudProfile_USCOREsetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperty ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperty ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperty ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetProperty ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, _vbox__ICloudProfile_USCOREsetProperty *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREsetProperty(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetProperty *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREsetProperty(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREsetProperty(struct soap *soap, _vbox__ICloudProfile_USCOREsetProperty *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREsetProperty(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetPropertyResponse * soap_new__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetPropertyResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetPropertyResponse * soap_new_req__vbox__ICloudProfile_USCOREgetPropertyResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREgetPropertyResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetPropertyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetPropertyResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetPropertyResponse * soap_new_set__vbox__ICloudProfile_USCOREgetPropertyResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREgetPropertyResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetPropertyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetPropertyResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertyResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getPropertyResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetPropertyResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetPropertyResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetPropertyResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetPropertyResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetPropertyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetPropertyResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetPropertyResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetPropertyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProperty * soap_new__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetProperty(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProperty * soap_new_req__vbox__ICloudProfile_USCOREgetProperty(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name)
{
	_vbox__ICloudProfile_USCOREgetProperty *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProperty(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProperty::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREgetProperty::name = name;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProperty * soap_new_set__vbox__ICloudProfile_USCOREgetProperty(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name)
{
	_vbox__ICloudProfile_USCOREgetProperty *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProperty(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProperty::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREgetProperty::name = name;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, _vbox__ICloudProfile_USCOREgetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperty ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperty ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperty ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperty const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProperty", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProperty ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, _vbox__ICloudProfile_USCOREgetProperty *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetProperty(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProperty *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetProperty(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetProperty(struct soap *soap, _vbox__ICloudProfile_USCOREgetProperty *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetProperty(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProviderIdResponse * soap_new__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetProviderIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProviderIdResponse * soap_new_req__vbox__ICloudProfile_USCOREgetProviderIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREgetProviderIdResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProviderIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProviderIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProviderIdResponse * soap_new_set__vbox__ICloudProfile_USCOREgetProviderIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREgetProviderIdResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProviderIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProviderIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetProviderIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetProviderIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetProviderIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetProviderIdResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetProviderIdResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetProviderIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProviderId * soap_new__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetProviderId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProviderId * soap_new_req__vbox__ICloudProfile_USCOREgetProviderId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREgetProviderId *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProviderId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProviderId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetProviderId * soap_new_set__vbox__ICloudProfile_USCOREgetProviderId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREgetProviderId *_p = ::soap_new__vbox__ICloudProfile_USCOREgetProviderId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetProviderId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfile_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getProviderId", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetProviderId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfile_USCOREgetProviderId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetProviderId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetProviderId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetProviderId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetProviderId(struct soap *soap, _vbox__ICloudProfile_USCOREgetProviderId *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetProviderId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetNameResponse * soap_new__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREsetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetNameResponse * soap_new_req__vbox__ICloudProfile_USCOREsetNameResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREsetNameResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREsetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetNameResponse * soap_new_set__vbox__ICloudProfile_USCOREsetNameResponse(
	struct soap *soap)
{
	_vbox__ICloudProfile_USCOREsetNameResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREsetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREsetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREsetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREsetNameResponse(struct soap *soap, _vbox__ICloudProfile_USCOREsetNameResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREsetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetName * soap_new__vbox__ICloudProfile_USCOREsetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREsetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetName * soap_new_req__vbox__ICloudProfile_USCOREsetName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name)
{
	_vbox__ICloudProfile_USCOREsetName *_p = ::soap_new__vbox__ICloudProfile_USCOREsetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREsetName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREsetName::name = name;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREsetName * soap_new_set__vbox__ICloudProfile_USCOREsetName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& name)
{
	_vbox__ICloudProfile_USCOREsetName *_p = ::soap_new__vbox__ICloudProfile_USCOREsetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREsetName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudProfile_USCOREsetName::name = name;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREsetName(struct soap *soap, _vbox__ICloudProfile_USCOREsetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREsetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREsetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREsetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_setName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREsetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREsetName(struct soap *soap, _vbox__ICloudProfile_USCOREsetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREsetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREsetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREsetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREsetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREsetName(struct soap *soap, _vbox__ICloudProfile_USCOREsetName *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREsetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetNameResponse * soap_new__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetNameResponse * soap_new_req__vbox__ICloudProfile_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetNameResponse * soap_new_set__vbox__ICloudProfile_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudProfile_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudProfile_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudProfile_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetName * soap_new__vbox__ICloudProfile_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudProfile_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetName * soap_new_req__vbox__ICloudProfile_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREgetName *_p = ::soap_new__vbox__ICloudProfile_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudProfile_USCOREgetName * soap_new_set__vbox__ICloudProfile_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudProfile_USCOREgetName *_p = ::soap_new__vbox__ICloudProfile_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudProfile_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudProfile_USCOREgetName(struct soap *soap, _vbox__ICloudProfile_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudProfile_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudProfile_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudProfile_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudProfile_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudProfile_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudProfile_USCOREgetName(struct soap *soap, _vbox__ICloudProfile_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudProfile_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudProfile_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudProfile_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudProfile_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudProfile_USCOREgetName(struct soap *soap, _vbox__ICloudProfile_USCOREgetName *p)
{
	if (::soap_read__vbox__ICloudProfile_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse * soap_new__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse * soap_new_req__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(
	struct soap *soap,
	enum vbox__MetricType returnval)
{
	_vbox__ICloudClient_USCOREgetMetricTypeByNameResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetMetricTypeByNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse * soap_new_set__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(
	struct soap *soap,
	enum vbox__MetricType returnval)
{
	_vbox__ICloudClient_USCOREgetMetricTypeByNameResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetMetricTypeByNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetMetricTypeByNameResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetMetricTypeByNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetMetricTypeByName * soap_new__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetMetricTypeByName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetMetricTypeByName * soap_new_req__vbox__ICloudClient_USCOREgetMetricTypeByName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& metricName)
{
	_vbox__ICloudClient_USCOREgetMetricTypeByName *_p = ::soap_new__vbox__ICloudClient_USCOREgetMetricTypeByName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetMetricTypeByName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetMetricTypeByName::metricName = metricName;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetMetricTypeByName * soap_new_set__vbox__ICloudClient_USCOREgetMetricTypeByName(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& metricName)
{
	_vbox__ICloudClient_USCOREgetMetricTypeByName *_p = ::soap_new__vbox__ICloudClient_USCOREgetMetricTypeByName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetMetricTypeByName::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetMetricTypeByName::metricName = metricName;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, _vbox__ICloudClient_USCOREgetMetricTypeByName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByName", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByName", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByName", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getMetricTypeByName", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetMetricTypeByName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, _vbox__ICloudClient_USCOREgetMetricTypeByName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetMetricTypeByName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetMetricTypeByName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetMetricTypeByName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetMetricTypeByName(struct soap *soap, _vbox__ICloudClient_USCOREgetMetricTypeByName *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetMetricTypeByName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse * soap_new__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse * soap_new_req__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse * soap_new_set__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetSubnetSelectionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetSubnetSelectionForm * soap_new__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetSubnetSelectionForm(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetSubnetSelectionForm * soap_new_req__vbox__ICloudClient_USCOREgetSubnetSelectionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetSubnetSelectionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetSubnetSelectionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionForm::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetSubnetSelectionForm * soap_new_set__vbox__ICloudClient_USCOREgetSubnetSelectionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetSubnetSelectionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetSubnetSelectionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetSubnetSelectionForm::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetSubnetSelectionForm const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionForm ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionForm const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getSubnetSelectionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetSubnetSelectionForm ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetSubnetSelectionForm *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetSubnetSelectionForm(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetSubnetSelectionForm *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetSubnetSelectionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetSubnetSelectionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetSubnetSelectionForm *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetSubnetSelectionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetVnicInfoResponse * soap_new__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetVnicInfoResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetVnicInfoResponse * soap_new_req__vbox__ICloudClient_USCOREgetVnicInfoResponse(
	struct soap *soap,
	const std::string& infoArray,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetVnicInfoResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetVnicInfoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetVnicInfoResponse::infoArray = infoArray;
		_p->_vbox__ICloudClient_USCOREgetVnicInfoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetVnicInfoResponse * soap_new_set__vbox__ICloudClient_USCOREgetVnicInfoResponse(
	struct soap *soap,
	const std::string& infoArray,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetVnicInfoResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetVnicInfoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetVnicInfoResponse::infoArray = infoArray;
		_p->_vbox__ICloudClient_USCOREgetVnicInfoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetVnicInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfoResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfoResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetVnicInfoResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetVnicInfoResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfoResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetVnicInfoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetVnicInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetVnicInfoResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetVnicInfoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetVnicInfo * soap_new__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetVnicInfo(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetVnicInfo * soap_new_req__vbox__ICloudClient_USCOREgetVnicInfo(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREgetVnicInfo *_p = ::soap_new__vbox__ICloudClient_USCOREgetVnicInfo(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetVnicInfo::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetVnicInfo::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetVnicInfo * soap_new_set__vbox__ICloudClient_USCOREgetVnicInfo(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREgetVnicInfo *_p = ::soap_new__vbox__ICloudClient_USCOREgetVnicInfo(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetVnicInfo::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetVnicInfo::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetVnicInfo const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfo ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfo const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfo ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfo const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfo ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfo const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getVnicInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetVnicInfo ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetVnicInfo *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetVnicInfo(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetVnicInfo *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetVnicInfo(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetVnicInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetVnicInfo *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetVnicInfo(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse * soap_new__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse * soap_new_req__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(
	struct soap *soap,
	const std::string& networkEnvironmentInfo,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse *_p = ::soap_new__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse::networkEnvironmentInfo = networkEnvironmentInfo;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse * soap_new_set__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(
	struct soap *soap,
	const std::string& networkEnvironmentInfo,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse *_p = ::soap_new__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse::networkEnvironmentInfo = networkEnvironmentInfo;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironmentResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironmentResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironmentResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironmentResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(struct soap *soap, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironmentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment * soap_new__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment * soap_new_req__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& tunnelNetworkName,
	const std::string& tunnelNetworkRange,
	const std::string& gatewayOsName,
	const std::string& gatewayOsVersion,
	const std::string& gatewayShape)
{
	_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment *_p = ::soap_new__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::tunnelNetworkName = tunnelNetworkName;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::tunnelNetworkRange = tunnelNetworkRange;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::gatewayOsName = gatewayOsName;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::gatewayOsVersion = gatewayOsVersion;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::gatewayShape = gatewayShape;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment * soap_new_set__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& tunnelNetworkName,
	const std::string& tunnelNetworkRange,
	const std::string& gatewayOsName,
	const std::string& gatewayOsVersion,
	const std::string& gatewayShape)
{
	_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment *_p = ::soap_new__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::tunnelNetworkName = tunnelNetworkName;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::tunnelNetworkRange = tunnelNetworkRange;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::gatewayOsName = gatewayOsName;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::gatewayOsVersion = gatewayOsVersion;
		_p->_vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment::gatewayShape = gatewayShape;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironment", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironment", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironment", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_setupCloudNetworkEnvironment", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(struct soap *soap, _vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREsetupCloudNetworkEnvironment(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse * soap_new__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse * soap_new_req__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(
	struct soap *soap,
	const std::string& gatewayInfo,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse *_p = ::soap_new__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse::gatewayInfo = gatewayInfo;
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse * soap_new_set__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(
	struct soap *soap,
	const std::string& gatewayInfo,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse *_p = ::soap_new__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse::gatewayInfo = gatewayInfo;
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(struct soap *soap, _vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREstartCloudNetworkGatewayResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartCloudNetworkGateway * soap_new__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREstartCloudNetworkGateway(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartCloudNetworkGateway * soap_new_req__vbox__ICloudClient_USCOREstartCloudNetworkGateway(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& network,
	const std::string& sshPublicKey)
{
	_vbox__ICloudClient_USCOREstartCloudNetworkGateway *_p = ::soap_new__vbox__ICloudClient_USCOREstartCloudNetworkGateway(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGateway::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGateway::network = network;
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGateway::sshPublicKey = sshPublicKey;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREstartCloudNetworkGateway * soap_new_set__vbox__ICloudClient_USCOREstartCloudNetworkGateway(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& network,
	const std::string& sshPublicKey)
{
	_vbox__ICloudClient_USCOREstartCloudNetworkGateway *_p = ::soap_new__vbox__ICloudClient_USCOREstartCloudNetworkGateway(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGateway::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGateway::network = network;
		_p->_vbox__ICloudClient_USCOREstartCloudNetworkGateway::sshPublicKey = sshPublicKey;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, _vbox__ICloudClient_USCOREstartCloudNetworkGateway const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGateway", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGateway ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGateway const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGateway", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGateway ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGateway const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGateway", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGateway ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGateway const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startCloudNetworkGateway", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartCloudNetworkGateway ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, _vbox__ICloudClient_USCOREstartCloudNetworkGateway *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREstartCloudNetworkGateway(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartCloudNetworkGateway *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREstartCloudNetworkGateway(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREstartCloudNetworkGateway(struct soap *soap, _vbox__ICloudClient_USCOREstartCloudNetworkGateway *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREstartCloudNetworkGateway(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImageInfoResponse * soap_new__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetImageInfoResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImageInfoResponse * soap_new_req__vbox__ICloudClient_USCOREgetImageInfoResponse(
	struct soap *soap,
	const std::string& infoArray,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetImageInfoResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetImageInfoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImageInfoResponse::infoArray = infoArray;
		_p->_vbox__ICloudClient_USCOREgetImageInfoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImageInfoResponse * soap_new_set__vbox__ICloudClient_USCOREgetImageInfoResponse(
	struct soap *soap,
	const std::string& infoArray,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetImageInfoResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetImageInfoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImageInfoResponse::infoArray = infoArray;
		_p->_vbox__ICloudClient_USCOREgetImageInfoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetImageInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfoResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfoResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetImageInfoResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetImageInfoResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfoResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetImageInfoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetImageInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetImageInfoResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetImageInfoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImageInfo * soap_new__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetImageInfo(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImageInfo * soap_new_req__vbox__ICloudClient_USCOREgetImageInfo(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREgetImageInfo *_p = ::soap_new__vbox__ICloudClient_USCOREgetImageInfo(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImageInfo::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetImageInfo::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImageInfo * soap_new_set__vbox__ICloudClient_USCOREgetImageInfo(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREgetImageInfo *_p = ::soap_new__vbox__ICloudClient_USCOREgetImageInfo(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImageInfo::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetImageInfo::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetImageInfo const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfo ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfo const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfo ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfo const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfo ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfo const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImageInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImageInfo ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetImageInfo *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetImageInfo(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImageInfo *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetImageInfo(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetImageInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetImageInfo *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetImageInfo(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREdeleteImageResponse * soap_new__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREdeleteImageResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREdeleteImageResponse * soap_new_req__vbox__ICloudClient_USCOREdeleteImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREdeleteImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREdeleteImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREdeleteImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREdeleteImageResponse * soap_new_set__vbox__ICloudClient_USCOREdeleteImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREdeleteImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREdeleteImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREdeleteImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREdeleteImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREdeleteImageResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREdeleteImageResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImageResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREdeleteImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREdeleteImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREdeleteImageResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREdeleteImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREdeleteImage * soap_new__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREdeleteImage(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREdeleteImage * soap_new_req__vbox__ICloudClient_USCOREdeleteImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREdeleteImage *_p = ::soap_new__vbox__ICloudClient_USCOREdeleteImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREdeleteImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREdeleteImage::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREdeleteImage * soap_new_set__vbox__ICloudClient_USCOREdeleteImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREdeleteImage *_p = ::soap_new__vbox__ICloudClient_USCOREdeleteImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREdeleteImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREdeleteImage::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, _vbox__ICloudClient_USCOREdeleteImage const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImage ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImage const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImage const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImage const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_deleteImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREdeleteImage ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, _vbox__ICloudClient_USCOREdeleteImage *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREdeleteImage(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREdeleteImage *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREdeleteImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREdeleteImage(struct soap *soap, _vbox__ICloudClient_USCOREdeleteImage *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREdeleteImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportImageResponse * soap_new__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREimportImageResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportImageResponse * soap_new_req__vbox__ICloudClient_USCOREimportImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREimportImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREimportImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREimportImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREimportImageResponse * soap_new_set__vbox__ICloudClient_USCOREimportImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREimportImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREimportImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREimportImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREimportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREimportImageResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREimportImageResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImageResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREimportImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREimportImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREimportImageResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREimportImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportImage * soap_new__vbox__ICloudClient_USCOREimportImage(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREimportImage(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportImage * soap_new_req__vbox__ICloudClient_USCOREimportImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCOREimportImage *_p = ::soap_new__vbox__ICloudClient_USCOREimportImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREimportImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREimportImage::uid = uid;
		_p->_vbox__ICloudClient_USCOREimportImage::parameters = parameters;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREimportImage * soap_new_set__vbox__ICloudClient_USCOREimportImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCOREimportImage *_p = ::soap_new__vbox__ICloudClient_USCOREimportImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREimportImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREimportImage::uid = uid;
		_p->_vbox__ICloudClient_USCOREimportImage::parameters = parameters;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREimportImage(struct soap *soap, _vbox__ICloudClient_USCOREimportImage const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImage ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREimportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImage const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREimportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImage const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREimportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImage const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportImage ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREimportImage(struct soap *soap, _vbox__ICloudClient_USCOREimportImage *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREimportImage(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREimportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportImage *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREimportImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREimportImage(struct soap *soap, _vbox__ICloudClient_USCOREimportImage *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREimportImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportImageResponse * soap_new__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREexportImageResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportImageResponse * soap_new_req__vbox__ICloudClient_USCOREexportImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREexportImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREexportImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREexportImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREexportImageResponse * soap_new_set__vbox__ICloudClient_USCOREexportImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREexportImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREexportImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREexportImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREexportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREexportImageResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREexportImageResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImageResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREexportImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREexportImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREexportImageResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREexportImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportImage * soap_new__vbox__ICloudClient_USCOREexportImage(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREexportImage(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportImage * soap_new_req__vbox__ICloudClient_USCOREexportImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& image,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCOREexportImage *_p = ::soap_new__vbox__ICloudClient_USCOREexportImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREexportImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREexportImage::image = image;
		_p->_vbox__ICloudClient_USCOREexportImage::parameters = parameters;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREexportImage * soap_new_set__vbox__ICloudClient_USCOREexportImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& image,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCOREexportImage *_p = ::soap_new__vbox__ICloudClient_USCOREexportImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREexportImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREexportImage::image = image;
		_p->_vbox__ICloudClient_USCOREexportImage::parameters = parameters;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREexportImage(struct soap *soap, _vbox__ICloudClient_USCOREexportImage const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImage ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREexportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImage const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREexportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImage const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREexportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImage const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportImage ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREexportImage(struct soap *soap, _vbox__ICloudClient_USCOREexportImage *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREexportImage(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREexportImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportImage *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREexportImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREexportImage(struct soap *soap, _vbox__ICloudClient_USCOREexportImage *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREexportImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateImageResponse * soap_new__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREcreateImageResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateImageResponse * soap_new_req__vbox__ICloudClient_USCOREcreateImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREcreateImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREcreateImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateImageResponse * soap_new_set__vbox__ICloudClient_USCOREcreateImageResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREcreateImageResponse *_p = ::soap_new__vbox__ICloudClient_USCOREcreateImageResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateImageResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREcreateImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImageResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImageResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImageResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImageResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREcreateImageResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREcreateImageResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImageResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREcreateImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREcreateImageResponse(struct soap *soap, _vbox__ICloudClient_USCOREcreateImageResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREcreateImageResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateImage * soap_new__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREcreateImage(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateImage * soap_new_req__vbox__ICloudClient_USCOREcreateImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCOREcreateImage *_p = ::soap_new__vbox__ICloudClient_USCOREcreateImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREcreateImage::parameters = parameters;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateImage * soap_new_set__vbox__ICloudClient_USCOREcreateImage(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCOREcreateImage *_p = ::soap_new__vbox__ICloudClient_USCOREcreateImage(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateImage::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREcreateImage::parameters = parameters;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, _vbox__ICloudClient_USCOREcreateImage const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImage ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImage const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImage const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImage ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImage const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createImage", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateImage ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, _vbox__ICloudClient_USCOREcreateImage *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREcreateImage(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateImage *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREcreateImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREcreateImage(struct soap *soap, _vbox__ICloudClient_USCOREcreateImage *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREcreateImage(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREcloneInstanceResponse * soap_new__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREcloneInstanceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREcloneInstanceResponse * soap_new_req__vbox__ICloudClient_USCOREcloneInstanceResponse(
	struct soap *soap,
	const std::string& clone,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREcloneInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREcloneInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcloneInstanceResponse::clone = clone;
		_p->_vbox__ICloudClient_USCOREcloneInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREcloneInstanceResponse * soap_new_set__vbox__ICloudClient_USCOREcloneInstanceResponse(
	struct soap *soap,
	const std::string& clone,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREcloneInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREcloneInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcloneInstanceResponse::clone = clone;
		_p->_vbox__ICloudClient_USCOREcloneInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREcloneInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREcloneInstanceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREcloneInstanceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstanceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREcloneInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREcloneInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREcloneInstanceResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREcloneInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREcloneInstance * soap_new__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREcloneInstance(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREcloneInstance * soap_new_req__vbox__ICloudClient_USCOREcloneInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid,
	const std::string& newName)
{
	_vbox__ICloudClient_USCOREcloneInstance *_p = ::soap_new__vbox__ICloudClient_USCOREcloneInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcloneInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREcloneInstance::uid = uid;
		_p->_vbox__ICloudClient_USCOREcloneInstance::newName = newName;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREcloneInstance * soap_new_set__vbox__ICloudClient_USCOREcloneInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid,
	const std::string& newName)
{
	_vbox__ICloudClient_USCOREcloneInstance *_p = ::soap_new__vbox__ICloudClient_USCOREcloneInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcloneInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREcloneInstance::uid = uid;
		_p->_vbox__ICloudClient_USCOREcloneInstance::newName = newName;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, _vbox__ICloudClient_USCOREcloneInstance const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstance ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstance const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_cloneInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcloneInstance ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, _vbox__ICloudClient_USCOREcloneInstance *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREcloneInstance(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcloneInstance *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREcloneInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREcloneInstance(struct soap *soap, _vbox__ICloudClient_USCOREcloneInstance *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREcloneInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREresetInstanceResponse * soap_new__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREresetInstanceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREresetInstanceResponse * soap_new_req__vbox__ICloudClient_USCOREresetInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREresetInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREresetInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREresetInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREresetInstanceResponse * soap_new_set__vbox__ICloudClient_USCOREresetInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREresetInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREresetInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREresetInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREresetInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREresetInstanceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREresetInstanceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstanceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREresetInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREresetInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREresetInstanceResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREresetInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREresetInstance * soap_new__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREresetInstance(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREresetInstance * soap_new_req__vbox__ICloudClient_USCOREresetInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREresetInstance *_p = ::soap_new__vbox__ICloudClient_USCOREresetInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREresetInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREresetInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREresetInstance * soap_new_set__vbox__ICloudClient_USCOREresetInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREresetInstance *_p = ::soap_new__vbox__ICloudClient_USCOREresetInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREresetInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREresetInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, _vbox__ICloudClient_USCOREresetInstance const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstance ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstance const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_resetInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREresetInstance ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, _vbox__ICloudClient_USCOREresetInstance *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREresetInstance(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREresetInstance *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREresetInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREresetInstance(struct soap *soap, _vbox__ICloudClient_USCOREresetInstance *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREresetInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREterminateInstanceResponse * soap_new__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREterminateInstanceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREterminateInstanceResponse * soap_new_req__vbox__ICloudClient_USCOREterminateInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREterminateInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREterminateInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREterminateInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREterminateInstanceResponse * soap_new_set__vbox__ICloudClient_USCOREterminateInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREterminateInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREterminateInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREterminateInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREterminateInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREterminateInstanceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREterminateInstanceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstanceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREterminateInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREterminateInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREterminateInstanceResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREterminateInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREterminateInstance * soap_new__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREterminateInstance(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREterminateInstance * soap_new_req__vbox__ICloudClient_USCOREterminateInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREterminateInstance *_p = ::soap_new__vbox__ICloudClient_USCOREterminateInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREterminateInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREterminateInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREterminateInstance * soap_new_set__vbox__ICloudClient_USCOREterminateInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREterminateInstance *_p = ::soap_new__vbox__ICloudClient_USCOREterminateInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREterminateInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREterminateInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, _vbox__ICloudClient_USCOREterminateInstance const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstance ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstance const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_terminateInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREterminateInstance ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, _vbox__ICloudClient_USCOREterminateInstance *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREterminateInstance(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREterminateInstance *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREterminateInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREterminateInstance(struct soap *soap, _vbox__ICloudClient_USCOREterminateInstance *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREterminateInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREpauseInstanceResponse * soap_new__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREpauseInstanceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREpauseInstanceResponse * soap_new_req__vbox__ICloudClient_USCOREpauseInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREpauseInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREpauseInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREpauseInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREpauseInstanceResponse * soap_new_set__vbox__ICloudClient_USCOREpauseInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREpauseInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREpauseInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREpauseInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREpauseInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREpauseInstanceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREpauseInstanceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstanceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREpauseInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREpauseInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREpauseInstanceResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREpauseInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREpauseInstance * soap_new__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREpauseInstance(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREpauseInstance * soap_new_req__vbox__ICloudClient_USCOREpauseInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREpauseInstance *_p = ::soap_new__vbox__ICloudClient_USCOREpauseInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREpauseInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREpauseInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREpauseInstance * soap_new_set__vbox__ICloudClient_USCOREpauseInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREpauseInstance *_p = ::soap_new__vbox__ICloudClient_USCOREpauseInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREpauseInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREpauseInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, _vbox__ICloudClient_USCOREpauseInstance const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstance ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstance const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_pauseInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREpauseInstance ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, _vbox__ICloudClient_USCOREpauseInstance *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREpauseInstance(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREpauseInstance *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREpauseInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREpauseInstance(struct soap *soap, _vbox__ICloudClient_USCOREpauseInstance *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREpauseInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartInstanceResponse * soap_new__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREstartInstanceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartInstanceResponse * soap_new_req__vbox__ICloudClient_USCOREstartInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREstartInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREstartInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREstartInstanceResponse * soap_new_set__vbox__ICloudClient_USCOREstartInstanceResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREstartInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREstartInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartInstanceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREstartInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREstartInstanceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREstartInstanceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstanceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREstartInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREstartInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREstartInstanceResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREstartInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartInstance * soap_new__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREstartInstance(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREstartInstance * soap_new_req__vbox__ICloudClient_USCOREstartInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREstartInstance *_p = ::soap_new__vbox__ICloudClient_USCOREstartInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREstartInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREstartInstance * soap_new_set__vbox__ICloudClient_USCOREstartInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid)
{
	_vbox__ICloudClient_USCOREstartInstance *_p = ::soap_new__vbox__ICloudClient_USCOREstartInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREstartInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREstartInstance::uid = uid;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, _vbox__ICloudClient_USCOREstartInstance const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstance ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstance const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_startInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREstartInstance ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, _vbox__ICloudClient_USCOREstartInstance *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREstartInstance(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREstartInstance *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREstartInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREstartInstance(struct soap *soap, _vbox__ICloudClient_USCOREstartInstance *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREstartInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetInstanceInfoResponse * soap_new__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetInstanceInfoResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetInstanceInfoResponse * soap_new_req__vbox__ICloudClient_USCOREgetInstanceInfoResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetInstanceInfoResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetInstanceInfoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetInstanceInfoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetInstanceInfoResponse * soap_new_set__vbox__ICloudClient_USCOREgetInstanceInfoResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetInstanceInfoResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetInstanceInfoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetInstanceInfoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetInstanceInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfoResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfoResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfoResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetInstanceInfoResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetInstanceInfoResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfoResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetInstanceInfoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetInstanceInfoResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetInstanceInfoResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetInstanceInfoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetInstanceInfo * soap_new__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetInstanceInfo(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetInstanceInfo * soap_new_req__vbox__ICloudClient_USCOREgetInstanceInfo(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetInstanceInfo *_p = ::soap_new__vbox__ICloudClient_USCOREgetInstanceInfo(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetInstanceInfo::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetInstanceInfo::uid = uid;
		_p->_vbox__ICloudClient_USCOREgetInstanceInfo::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetInstanceInfo * soap_new_set__vbox__ICloudClient_USCOREgetInstanceInfo(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& uid,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetInstanceInfo *_p = ::soap_new__vbox__ICloudClient_USCOREgetInstanceInfo(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetInstanceInfo::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetInstanceInfo::uid = uid;
		_p->_vbox__ICloudClient_USCOREgetInstanceInfo::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetInstanceInfo const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfo ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfo const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfo ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfo const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfo ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfo const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getInstanceInfo", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetInstanceInfo ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetInstanceInfo *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetInstanceInfo(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetInstanceInfo *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetInstanceInfo(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetInstanceInfo(struct soap *soap, _vbox__ICloudClient_USCOREgetInstanceInfo *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetInstanceInfo(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistVnicAttachmentsResponse * soap_new__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistVnicAttachmentsResponse * soap_new_req__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(
	struct soap *soap,
	const std::string& returnVnicAttachmentIds,
	const std::string& returnVnicIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistVnicAttachmentsResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistVnicAttachmentsResponse::returnVnicAttachmentIds = returnVnicAttachmentIds;
		_p->_vbox__ICloudClient_USCORElistVnicAttachmentsResponse::returnVnicIds = returnVnicIds;
		_p->_vbox__ICloudClient_USCORElistVnicAttachmentsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistVnicAttachmentsResponse * soap_new_set__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(
	struct soap *soap,
	const std::string& returnVnicAttachmentIds,
	const std::string& returnVnicIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistVnicAttachmentsResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistVnicAttachmentsResponse::returnVnicAttachmentIds = returnVnicAttachmentIds;
		_p->_vbox__ICloudClient_USCORElistVnicAttachmentsResponse::returnVnicIds = returnVnicIds;
		_p->_vbox__ICloudClient_USCORElistVnicAttachmentsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachmentsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachmentsResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachmentsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachmentsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachmentsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachmentsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachmentsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachmentsResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(struct soap *soap, _vbox__ICloudClient_USCORElistVnicAttachmentsResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistVnicAttachmentsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistVnicAttachments * soap_new__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistVnicAttachments(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistVnicAttachments * soap_new_req__vbox__ICloudClient_USCORElistVnicAttachments(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCORElistVnicAttachments *_p = ::soap_new__vbox__ICloudClient_USCORElistVnicAttachments(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistVnicAttachments::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElistVnicAttachments::parameters = parameters;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistVnicAttachments * soap_new_set__vbox__ICloudClient_USCORElistVnicAttachments(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<std::string> & parameters)
{
	_vbox__ICloudClient_USCORElistVnicAttachments *_p = ::soap_new__vbox__ICloudClient_USCORElistVnicAttachments(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistVnicAttachments::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElistVnicAttachments::parameters = parameters;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, _vbox__ICloudClient_USCORElistVnicAttachments const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachments", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachments ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachments const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachments", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachments ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachments const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachments", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachments ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachments const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listVnicAttachments", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistVnicAttachments ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, _vbox__ICloudClient_USCORElistVnicAttachments *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistVnicAttachments(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistVnicAttachments *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistVnicAttachments(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistVnicAttachments(struct soap *soap, _vbox__ICloudClient_USCORElistVnicAttachments *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistVnicAttachments(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceBootVolumesResponse * soap_new__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceBootVolumesResponse * soap_new_req__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistSourceBootVolumesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceBootVolumesResponse * soap_new_set__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistSourceBootVolumesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistSourceBootVolumesResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistSourceBootVolumesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceBootVolumes * soap_new__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistSourceBootVolumes(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceBootVolumes * soap_new_req__vbox__ICloudClient_USCORElistSourceBootVolumes(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCORElistSourceBootVolumes *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceBootVolumes(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumes::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceBootVolumes * soap_new_set__vbox__ICloudClient_USCORElistSourceBootVolumes(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCORElistSourceBootVolumes *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceBootVolumes(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceBootVolumes::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, _vbox__ICloudClient_USCORElistSourceBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumes ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumes ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumes ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceBootVolumes ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, _vbox__ICloudClient_USCORElistSourceBootVolumes *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistSourceBootVolumes(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceBootVolumes *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistSourceBootVolumes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistSourceBootVolumes(struct soap *soap, _vbox__ICloudClient_USCORElistSourceBootVolumes *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistSourceBootVolumes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistBootVolumesResponse * soap_new__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistBootVolumesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistBootVolumesResponse * soap_new_req__vbox__ICloudClient_USCORElistBootVolumesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistBootVolumesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistBootVolumesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistBootVolumesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistBootVolumesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistBootVolumesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistBootVolumesResponse * soap_new_set__vbox__ICloudClient_USCORElistBootVolumesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistBootVolumesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistBootVolumesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistBootVolumesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistBootVolumesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistBootVolumesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistBootVolumesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistBootVolumesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistBootVolumesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistBootVolumesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistBootVolumesResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistBootVolumesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistBootVolumes * soap_new__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistBootVolumes(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistBootVolumes * soap_new_req__vbox__ICloudClient_USCORElistBootVolumes(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCORElistBootVolumes *_p = ::soap_new__vbox__ICloudClient_USCORElistBootVolumes(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistBootVolumes::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistBootVolumes * soap_new_set__vbox__ICloudClient_USCORElistBootVolumes(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCORElistBootVolumes *_p = ::soap_new__vbox__ICloudClient_USCORElistBootVolumes(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistBootVolumes::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, _vbox__ICloudClient_USCORElistBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumes ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumes ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumes ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumes const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listBootVolumes", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistBootVolumes ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, _vbox__ICloudClient_USCORElistBootVolumes *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistBootVolumes(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistBootVolumes *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistBootVolumes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistBootVolumes(struct soap *soap, _vbox__ICloudClient_USCORElistBootVolumes *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistBootVolumes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistImagesResponse * soap_new__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistImagesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistImagesResponse * soap_new_req__vbox__ICloudClient_USCORElistImagesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistImagesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistImagesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistImagesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistImagesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistImagesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistImagesResponse * soap_new_set__vbox__ICloudClient_USCORElistImagesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistImagesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistImagesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistImagesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistImagesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistImagesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistImagesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImagesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImagesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImagesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImagesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImagesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImagesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImagesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImagesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImagesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImagesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImagesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistImagesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistImagesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImagesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistImagesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistImagesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistImagesResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistImagesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistImages * soap_new__vbox__ICloudClient_USCORElistImages(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistImages(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistImages * soap_new_req__vbox__ICloudClient_USCORElistImages(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<enum vbox__CloudImageState> & imageState)
{
	_vbox__ICloudClient_USCORElistImages *_p = ::soap_new__vbox__ICloudClient_USCORElistImages(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistImages::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElistImages::imageState = imageState;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistImages * soap_new_set__vbox__ICloudClient_USCORElistImages(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<enum vbox__CloudImageState> & imageState)
{
	_vbox__ICloudClient_USCORElistImages *_p = ::soap_new__vbox__ICloudClient_USCORElistImages(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistImages::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElistImages::imageState = imageState;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistImages(struct soap *soap, _vbox__ICloudClient_USCORElistImages const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImages", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImages ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistImages(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImages const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImages", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImages ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistImages(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImages const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImages", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImages ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistImages(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImages const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listImages", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistImages ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistImages(struct soap *soap, _vbox__ICloudClient_USCORElistImages *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistImages(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistImages(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistImages *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistImages(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistImages(struct soap *soap, _vbox__ICloudClient_USCORElistImages *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistImages(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceInstancesResponse * soap_new__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistSourceInstancesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceInstancesResponse * soap_new_req__vbox__ICloudClient_USCORElistSourceInstancesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistSourceInstancesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceInstancesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceInstancesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistSourceInstancesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistSourceInstancesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceInstancesResponse * soap_new_set__vbox__ICloudClient_USCORElistSourceInstancesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistSourceInstancesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceInstancesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceInstancesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistSourceInstancesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistSourceInstancesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistSourceInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstancesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstancesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstancesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstancesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistSourceInstancesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistSourceInstancesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstancesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistSourceInstancesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistSourceInstancesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistSourceInstancesResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistSourceInstancesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceInstances * soap_new__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistSourceInstances(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceInstances * soap_new_req__vbox__ICloudClient_USCORElistSourceInstances(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCORElistSourceInstances *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceInstances(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceInstances::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistSourceInstances * soap_new_set__vbox__ICloudClient_USCORElistSourceInstances(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCORElistSourceInstances *_p = ::soap_new__vbox__ICloudClient_USCORElistSourceInstances(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistSourceInstances::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, _vbox__ICloudClient_USCORElistSourceInstances const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstances ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstances const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstances ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstances const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstances ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstances const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listSourceInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistSourceInstances ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, _vbox__ICloudClient_USCORElistSourceInstances *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistSourceInstances(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistSourceInstances *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistSourceInstances(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistSourceInstances(struct soap *soap, _vbox__ICloudClient_USCORElistSourceInstances *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistSourceInstances(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistInstancesResponse * soap_new__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistInstancesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistInstancesResponse * soap_new_req__vbox__ICloudClient_USCORElistInstancesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistInstancesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistInstancesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistInstancesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistInstancesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistInstancesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistInstancesResponse * soap_new_set__vbox__ICloudClient_USCORElistInstancesResponse(
	struct soap *soap,
	const std::string& returnNames,
	const std::string& returnIds,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElistInstancesResponse *_p = ::soap_new__vbox__ICloudClient_USCORElistInstancesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistInstancesResponse::returnNames = returnNames;
		_p->_vbox__ICloudClient_USCORElistInstancesResponse::returnIds = returnIds;
		_p->_vbox__ICloudClient_USCORElistInstancesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstancesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstancesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstancesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstancesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstancesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstancesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistInstancesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistInstancesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstancesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistInstancesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistInstancesResponse(struct soap *soap, _vbox__ICloudClient_USCORElistInstancesResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistInstancesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElistInstances * soap_new__vbox__ICloudClient_USCORElistInstances(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElistInstances(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElistInstances * soap_new_req__vbox__ICloudClient_USCORElistInstances(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<enum vbox__CloudMachineState> & machineState)
{
	_vbox__ICloudClient_USCORElistInstances *_p = ::soap_new__vbox__ICloudClient_USCORElistInstances(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistInstances::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElistInstances::machineState = machineState;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElistInstances * soap_new_set__vbox__ICloudClient_USCORElistInstances(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::vector<enum vbox__CloudMachineState> & machineState)
{
	_vbox__ICloudClient_USCORElistInstances *_p = ::soap_new__vbox__ICloudClient_USCORElistInstances(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElistInstances::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElistInstances::machineState = machineState;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElistInstances(struct soap *soap, _vbox__ICloudClient_USCORElistInstances const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstances ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElistInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstances const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstances ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElistInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstances const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstances ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElistInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstances const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_listInstances", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElistInstances ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElistInstances(struct soap *soap, _vbox__ICloudClient_USCORElistInstances *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElistInstances(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElistInstances(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElistInstances *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElistInstances(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElistInstances(struct soap *soap, _vbox__ICloudClient_USCORElistInstances *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElistInstances(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateCloudMachineResponse * soap_new__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREcreateCloudMachineResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateCloudMachineResponse * soap_new_req__vbox__ICloudClient_USCOREcreateCloudMachineResponse(
	struct soap *soap,
	const std::string& machine,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREcreateCloudMachineResponse *_p = ::soap_new__vbox__ICloudClient_USCOREcreateCloudMachineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateCloudMachineResponse::machine = machine;
		_p->_vbox__ICloudClient_USCOREcreateCloudMachineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateCloudMachineResponse * soap_new_set__vbox__ICloudClient_USCOREcreateCloudMachineResponse(
	struct soap *soap,
	const std::string& machine,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREcreateCloudMachineResponse *_p = ::soap_new__vbox__ICloudClient_USCOREcreateCloudMachineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateCloudMachineResponse::machine = machine;
		_p->_vbox__ICloudClient_USCOREcreateCloudMachineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREcreateCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachineResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachineResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREcreateCloudMachineResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREcreateCloudMachineResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachineResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREcreateCloudMachineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREcreateCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREcreateCloudMachineResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREcreateCloudMachineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateCloudMachine * soap_new__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREcreateCloudMachine(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateCloudMachine * soap_new_req__vbox__ICloudClient_USCOREcreateCloudMachine(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREcreateCloudMachine *_p = ::soap_new__vbox__ICloudClient_USCOREcreateCloudMachine(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateCloudMachine::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREcreateCloudMachine::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREcreateCloudMachine * soap_new_set__vbox__ICloudClient_USCOREcreateCloudMachine(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREcreateCloudMachine *_p = ::soap_new__vbox__ICloudClient_USCOREcreateCloudMachine(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREcreateCloudMachine::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREcreateCloudMachine::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREcreateCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachine ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachine ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachine ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_createCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREcreateCloudMachine ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREcreateCloudMachine *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREcreateCloudMachine(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREcreateCloudMachine *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREcreateCloudMachine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREcreateCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREcreateCloudMachine *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREcreateCloudMachine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREaddCloudMachineResponse * soap_new__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREaddCloudMachineResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREaddCloudMachineResponse * soap_new_req__vbox__ICloudClient_USCOREaddCloudMachineResponse(
	struct soap *soap,
	const std::string& machine,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREaddCloudMachineResponse *_p = ::soap_new__vbox__ICloudClient_USCOREaddCloudMachineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREaddCloudMachineResponse::machine = machine;
		_p->_vbox__ICloudClient_USCOREaddCloudMachineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREaddCloudMachineResponse * soap_new_set__vbox__ICloudClient_USCOREaddCloudMachineResponse(
	struct soap *soap,
	const std::string& machine,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREaddCloudMachineResponse *_p = ::soap_new__vbox__ICloudClient_USCOREaddCloudMachineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREaddCloudMachineResponse::machine = machine;
		_p->_vbox__ICloudClient_USCOREaddCloudMachineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREaddCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachineResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachineResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREaddCloudMachineResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREaddCloudMachineResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachineResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREaddCloudMachineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREaddCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREaddCloudMachineResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREaddCloudMachineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREaddCloudMachine * soap_new__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREaddCloudMachine(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREaddCloudMachine * soap_new_req__vbox__ICloudClient_USCOREaddCloudMachine(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& instanceId)
{
	_vbox__ICloudClient_USCOREaddCloudMachine *_p = ::soap_new__vbox__ICloudClient_USCOREaddCloudMachine(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREaddCloudMachine::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREaddCloudMachine::instanceId = instanceId;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREaddCloudMachine * soap_new_set__vbox__ICloudClient_USCOREaddCloudMachine(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& instanceId)
{
	_vbox__ICloudClient_USCOREaddCloudMachine *_p = ::soap_new__vbox__ICloudClient_USCOREaddCloudMachine(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREaddCloudMachine::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREaddCloudMachine::instanceId = instanceId;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREaddCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachine ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachine ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachine ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_addCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREaddCloudMachine ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREaddCloudMachine *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREaddCloudMachine(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREaddCloudMachine *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREaddCloudMachine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREaddCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREaddCloudMachine *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREaddCloudMachine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse * soap_new__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse * soap_new_req__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREreadCloudMachineStubListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineStubListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse * soap_new_set__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREreadCloudMachineStubListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineStubListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineStubListResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREreadCloudMachineStubListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineStubList * soap_new__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREreadCloudMachineStubList(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineStubList * soap_new_req__vbox__ICloudClient_USCOREreadCloudMachineStubList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREreadCloudMachineStubList *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineStubList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineStubList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineStubList * soap_new_set__vbox__ICloudClient_USCOREreadCloudMachineStubList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREreadCloudMachineStubList *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineStubList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineStubList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubList ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineStubList ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineStubList *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREreadCloudMachineStubList(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineStubList *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREreadCloudMachineStubList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREreadCloudMachineStubList(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineStubList *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREreadCloudMachineStubList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineListResponse * soap_new__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREreadCloudMachineListResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineListResponse * soap_new_req__vbox__ICloudClient_USCOREreadCloudMachineListResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREreadCloudMachineListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineListResponse * soap_new_set__vbox__ICloudClient_USCOREreadCloudMachineListResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREreadCloudMachineListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineListResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineListResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineListResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREreadCloudMachineListResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineListResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREreadCloudMachineListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREreadCloudMachineListResponse(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineListResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREreadCloudMachineListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineList * soap_new__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREreadCloudMachineList(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineList * soap_new_req__vbox__ICloudClient_USCOREreadCloudMachineList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREreadCloudMachineList *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREreadCloudMachineList * soap_new_set__vbox__ICloudClient_USCOREreadCloudMachineList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREreadCloudMachineList *_p = ::soap_new__vbox__ICloudClient_USCOREreadCloudMachineList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREreadCloudMachineList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineList ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_readCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREreadCloudMachineList ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineList *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREreadCloudMachineList(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREreadCloudMachineList *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREreadCloudMachineList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREreadCloudMachineList(struct soap *soap, _vbox__ICloudClient_USCOREreadCloudMachineList *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREreadCloudMachineList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineResponse * soap_new__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetCloudMachineResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineResponse * soap_new_req__vbox__ICloudClient_USCOREgetCloudMachineResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetCloudMachineResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineResponse * soap_new_set__vbox__ICloudClient_USCOREgetCloudMachineResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetCloudMachineResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetCloudMachineResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetCloudMachineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetCloudMachineResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetCloudMachineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachine * soap_new__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetCloudMachine(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachine * soap_new_req__vbox__ICloudClient_USCOREgetCloudMachine(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& id)
{
	_vbox__ICloudClient_USCOREgetCloudMachine *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachine(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachine::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetCloudMachine::id = id;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachine * soap_new_set__vbox__ICloudClient_USCOREgetCloudMachine(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& id)
{
	_vbox__ICloudClient_USCOREgetCloudMachine *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachine(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachine::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetCloudMachine::id = id;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachine ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachine ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachine ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachine const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachine", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachine ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachine *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetCloudMachine(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachine *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetCloudMachine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetCloudMachine(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachine *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetCloudMachine(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportInstanceResponse * soap_new__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREimportInstanceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportInstanceResponse * soap_new_req__vbox__ICloudClient_USCOREimportInstanceResponse(
	struct soap *soap)
{
	_vbox__ICloudClient_USCOREimportInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREimportInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREimportInstanceResponse * soap_new_set__vbox__ICloudClient_USCOREimportInstanceResponse(
	struct soap *soap)
{
	_vbox__ICloudClient_USCOREimportInstanceResponse *_p = ::soap_new__vbox__ICloudClient_USCOREimportInstanceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREimportInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstanceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstanceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstanceResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstanceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREimportInstanceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREimportInstanceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstanceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREimportInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREimportInstanceResponse(struct soap *soap, _vbox__ICloudClient_USCOREimportInstanceResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREimportInstanceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportInstance * soap_new__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREimportInstance(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREimportInstance * soap_new_req__vbox__ICloudClient_USCOREimportInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description,
	const std::string& progress)
{
	_vbox__ICloudClient_USCOREimportInstance *_p = ::soap_new__vbox__ICloudClient_USCOREimportInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREimportInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREimportInstance::description = description;
		_p->_vbox__ICloudClient_USCOREimportInstance::progress = progress;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREimportInstance * soap_new_set__vbox__ICloudClient_USCOREimportInstance(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description,
	const std::string& progress)
{
	_vbox__ICloudClient_USCOREimportInstance *_p = ::soap_new__vbox__ICloudClient_USCOREimportInstance(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREimportInstance::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREimportInstance::description = description;
		_p->_vbox__ICloudClient_USCOREimportInstance::progress = progress;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, _vbox__ICloudClient_USCOREimportInstance const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstance ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstance const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstance ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstance const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_importInstance", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREimportInstance ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, _vbox__ICloudClient_USCOREimportInstance *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREimportInstance(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREimportInstance *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREimportInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREimportInstance(struct soap *soap, _vbox__ICloudClient_USCOREimportInstance *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREimportInstance(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse * soap_new__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse * soap_new_req__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetImportDescriptionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse * soap_new_set__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetImportDescriptionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetImportDescriptionFormResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetImportDescriptionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImportDescriptionForm * soap_new__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetImportDescriptionForm(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImportDescriptionForm * soap_new_req__vbox__ICloudClient_USCOREgetImportDescriptionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetImportDescriptionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetImportDescriptionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionForm::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetImportDescriptionForm * soap_new_set__vbox__ICloudClient_USCOREgetImportDescriptionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetImportDescriptionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetImportDescriptionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetImportDescriptionForm::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetImportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionForm ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getImportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetImportDescriptionForm ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetImportDescriptionForm *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetImportDescriptionForm(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetImportDescriptionForm *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetImportDescriptionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetImportDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetImportDescriptionForm *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetImportDescriptionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElaunchVMResponse * soap_new__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElaunchVMResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElaunchVMResponse * soap_new_req__vbox__ICloudClient_USCORElaunchVMResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElaunchVMResponse *_p = ::soap_new__vbox__ICloudClient_USCORElaunchVMResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElaunchVMResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElaunchVMResponse * soap_new_set__vbox__ICloudClient_USCORElaunchVMResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCORElaunchVMResponse *_p = ::soap_new__vbox__ICloudClient_USCORElaunchVMResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElaunchVMResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, _vbox__ICloudClient_USCORElaunchVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVMResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVMResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVMResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVMResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, _vbox__ICloudClient_USCORElaunchVMResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElaunchVMResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVMResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElaunchVMResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElaunchVMResponse(struct soap *soap, _vbox__ICloudClient_USCORElaunchVMResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElaunchVMResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCORElaunchVM * soap_new__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCORElaunchVM(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCORElaunchVM * soap_new_req__vbox__ICloudClient_USCORElaunchVM(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCORElaunchVM *_p = ::soap_new__vbox__ICloudClient_USCORElaunchVM(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElaunchVM::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElaunchVM::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCORElaunchVM * soap_new_set__vbox__ICloudClient_USCORElaunchVM(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCORElaunchVM *_p = ::soap_new__vbox__ICloudClient_USCORElaunchVM(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCORElaunchVM::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCORElaunchVM::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, _vbox__ICloudClient_USCORElaunchVM const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVM ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVM const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVM ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVM const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVM ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVM const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_launchVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCORElaunchVM ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, _vbox__ICloudClient_USCORElaunchVM *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCORElaunchVM(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCORElaunchVM *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCORElaunchVM(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCORElaunchVM(struct soap *soap, _vbox__ICloudClient_USCORElaunchVM *p)
{
	if (::soap_read__vbox__ICloudClient_USCORElaunchVM(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse * soap_new__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse * soap_new_req__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse * soap_new_set__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetLaunchDescriptionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetLaunchDescriptionForm * soap_new__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetLaunchDescriptionForm * soap_new_req__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetLaunchDescriptionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionForm::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetLaunchDescriptionForm * soap_new_set__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetLaunchDescriptionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetLaunchDescriptionForm::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionForm ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getLaunchDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetLaunchDescriptionForm ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetLaunchDescriptionForm *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetLaunchDescriptionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportVMResponse * soap_new__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREexportVMResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportVMResponse * soap_new_req__vbox__ICloudClient_USCOREexportVMResponse(
	struct soap *soap)
{
	_vbox__ICloudClient_USCOREexportVMResponse *_p = ::soap_new__vbox__ICloudClient_USCOREexportVMResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREexportVMResponse * soap_new_set__vbox__ICloudClient_USCOREexportVMResponse(
	struct soap *soap)
{
	_vbox__ICloudClient_USCOREexportVMResponse *_p = ::soap_new__vbox__ICloudClient_USCOREexportVMResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, _vbox__ICloudClient_USCOREexportVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVMResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVMResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVMResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVMResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVMResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVMResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, _vbox__ICloudClient_USCOREexportVMResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREexportVMResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVMResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREexportVMResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREexportVMResponse(struct soap *soap, _vbox__ICloudClient_USCOREexportVMResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREexportVMResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportVM * soap_new__vbox__ICloudClient_USCOREexportVM(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREexportVM(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREexportVM * soap_new_req__vbox__ICloudClient_USCOREexportVM(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description,
	const std::string& progress)
{
	_vbox__ICloudClient_USCOREexportVM *_p = ::soap_new__vbox__ICloudClient_USCOREexportVM(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREexportVM::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREexportVM::description = description;
		_p->_vbox__ICloudClient_USCOREexportVM::progress = progress;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREexportVM * soap_new_set__vbox__ICloudClient_USCOREexportVM(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description,
	const std::string& progress)
{
	_vbox__ICloudClient_USCOREexportVM *_p = ::soap_new__vbox__ICloudClient_USCOREexportVM(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREexportVM::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREexportVM::description = description;
		_p->_vbox__ICloudClient_USCOREexportVM::progress = progress;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREexportVM(struct soap *soap, _vbox__ICloudClient_USCOREexportVM const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVM ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREexportVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVM const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVM ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREexportVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVM const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVM ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREexportVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVM const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_exportVM", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREexportVM ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREexportVM(struct soap *soap, _vbox__ICloudClient_USCOREexportVM *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREexportVM(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREexportVM(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREexportVM *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREexportVM(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREexportVM(struct soap *soap, _vbox__ICloudClient_USCOREexportVM *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREexportVM(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse * soap_new__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse * soap_new_req__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetExportDescriptionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse * soap_new_set__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudClient_USCOREgetExportDescriptionFormResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionFormResponse::form = form;
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetExportDescriptionFormResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetExportDescriptionFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetExportDescriptionForm * soap_new__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetExportDescriptionForm(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetExportDescriptionForm * soap_new_req__vbox__ICloudClient_USCOREgetExportDescriptionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetExportDescriptionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetExportDescriptionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionForm::description = description;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetExportDescriptionForm * soap_new_set__vbox__ICloudClient_USCOREgetExportDescriptionForm(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& description)
{
	_vbox__ICloudClient_USCOREgetExportDescriptionForm *_p = ::soap_new__vbox__ICloudClient_USCOREgetExportDescriptionForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionForm::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudClient_USCOREgetExportDescriptionForm::description = description;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetExportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionForm ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionForm const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getExportDescriptionForm", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetExportDescriptionForm ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetExportDescriptionForm *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetExportDescriptionForm(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetExportDescriptionForm *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetExportDescriptionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetExportDescriptionForm(struct soap *soap, _vbox__ICloudClient_USCOREgetExportDescriptionForm *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetExportDescriptionForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse * soap_new__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse * soap_new_req__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudClient_USCOREgetCloudMachineStubListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineStubListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse * soap_new_set__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudClient_USCOREgetCloudMachineStubListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineStubListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineStubListResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetCloudMachineStubListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineStubList * soap_new__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetCloudMachineStubList(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineStubList * soap_new_req__vbox__ICloudClient_USCOREgetCloudMachineStubList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREgetCloudMachineStubList *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineStubList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineStubList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineStubList * soap_new_set__vbox__ICloudClient_USCOREgetCloudMachineStubList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREgetCloudMachineStubList *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineStubList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineStubList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubList ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubList const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineStubList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineStubList ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineStubList *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetCloudMachineStubList(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineStubList *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetCloudMachineStubList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetCloudMachineStubList(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineStubList *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetCloudMachineStubList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineListResponse * soap_new__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetCloudMachineListResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineListResponse * soap_new_req__vbox__ICloudClient_USCOREgetCloudMachineListResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudClient_USCOREgetCloudMachineListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineListResponse * soap_new_set__vbox__ICloudClient_USCOREgetCloudMachineListResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__ICloudClient_USCOREgetCloudMachineListResponse *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineListResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineListResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineListResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineListResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineListResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineListResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineListResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineListResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetCloudMachineListResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineListResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetCloudMachineListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetCloudMachineListResponse(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineListResponse *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetCloudMachineListResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineList * soap_new__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudClient_USCOREgetCloudMachineList(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineList * soap_new_req__vbox__ICloudClient_USCOREgetCloudMachineList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREgetCloudMachineList *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudClient_USCOREgetCloudMachineList * soap_new_set__vbox__ICloudClient_USCOREgetCloudMachineList(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudClient_USCOREgetCloudMachineList *_p = ::soap_new__vbox__ICloudClient_USCOREgetCloudMachineList(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudClient_USCOREgetCloudMachineList::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineList ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineList ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineList const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudClient_getCloudMachineList", p->soap_type() == SOAP_TYPE__vbox__ICloudClient_USCOREgetCloudMachineList ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineList *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudClient_USCOREgetCloudMachineList(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, const char *URL, _vbox__ICloudClient_USCOREgetCloudMachineList *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudClient_USCOREgetCloudMachineList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudClient_USCOREgetCloudMachineList(struct soap *soap, _vbox__ICloudClient_USCOREgetCloudMachineList *p)
{
	if (::soap_read__vbox__ICloudClient_USCOREgetCloudMachineList(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREenumerateMetricDataResponse * soap_new__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREenumerateMetricDataResponse * soap_new_req__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(
	struct soap *soap,
	const std::string& values,
	const std::string& timestamps,
	const std::string& unit,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREenumerateMetricDataResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::values = values;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::timestamps = timestamps;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::unit = unit;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREenumerateMetricDataResponse * soap_new_set__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(
	struct soap *soap,
	const std::string& values,
	const std::string& timestamps,
	const std::string& unit,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREenumerateMetricDataResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::values = values;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::timestamps = timestamps;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::unit = unit;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricDataResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricDataResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricDataResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricDataResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricDataResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(struct soap *soap, _vbox__ICloudMachine_USCOREenumerateMetricDataResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREenumerateMetricDataResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREenumerateMetricData * soap_new__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREenumerateMetricData(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREenumerateMetricData * soap_new_req__vbox__ICloudMachine_USCOREenumerateMetricData(
	struct soap *soap,
	const std::string& _USCOREthis,
	enum vbox__MetricType metricType,
	unsigned int pointsNumber)
{
	_vbox__ICloudMachine_USCOREenumerateMetricData *_p = ::soap_new__vbox__ICloudMachine_USCOREenumerateMetricData(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREenumerateMetricData::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricData::metricType = metricType;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricData::pointsNumber = pointsNumber;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREenumerateMetricData * soap_new_set__vbox__ICloudMachine_USCOREenumerateMetricData(
	struct soap *soap,
	const std::string& _USCOREthis,
	enum vbox__MetricType metricType,
	unsigned int pointsNumber)
{
	_vbox__ICloudMachine_USCOREenumerateMetricData *_p = ::soap_new__vbox__ICloudMachine_USCOREenumerateMetricData(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREenumerateMetricData::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricData::metricType = metricType;
		_p->_vbox__ICloudMachine_USCOREenumerateMetricData::pointsNumber = pointsNumber;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, _vbox__ICloudMachine_USCOREenumerateMetricData const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricData", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricData ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricData const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricData", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricData ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricData const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricData", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricData ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricData const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_enumerateMetricData", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREenumerateMetricData ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, _vbox__ICloudMachine_USCOREenumerateMetricData *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREenumerateMetricData(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREenumerateMetricData *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREenumerateMetricData(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREenumerateMetricData(struct soap *soap, _vbox__ICloudMachine_USCOREenumerateMetricData *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREenumerateMetricData(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCORElistMetricNamesResponse * soap_new__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCORElistMetricNamesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCORElistMetricNamesResponse * soap_new_req__vbox__ICloudMachine_USCORElistMetricNamesResponse(
	struct soap *soap,
	const std::string& metricNames,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCORElistMetricNamesResponse *_p = ::soap_new__vbox__ICloudMachine_USCORElistMetricNamesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORElistMetricNamesResponse::metricNames = metricNames;
		_p->_vbox__ICloudMachine_USCORElistMetricNamesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCORElistMetricNamesResponse * soap_new_set__vbox__ICloudMachine_USCORElistMetricNamesResponse(
	struct soap *soap,
	const std::string& metricNames,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCORElistMetricNamesResponse *_p = ::soap_new__vbox__ICloudMachine_USCORElistMetricNamesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORElistMetricNamesResponse::metricNames = metricNames;
		_p->_vbox__ICloudMachine_USCORElistMetricNamesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, _vbox__ICloudMachine_USCORElistMetricNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNamesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNamesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNamesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNamesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNamesResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNamesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, _vbox__ICloudMachine_USCORElistMetricNamesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCORElistMetricNamesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNamesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCORElistMetricNamesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCORElistMetricNamesResponse(struct soap *soap, _vbox__ICloudMachine_USCORElistMetricNamesResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCORElistMetricNamesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCORElistMetricNames * soap_new__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCORElistMetricNames(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCORElistMetricNames * soap_new_req__vbox__ICloudMachine_USCORElistMetricNames(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCORElistMetricNames *_p = ::soap_new__vbox__ICloudMachine_USCORElistMetricNames(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORElistMetricNames::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCORElistMetricNames * soap_new_set__vbox__ICloudMachine_USCORElistMetricNames(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCORElistMetricNames *_p = ::soap_new__vbox__ICloudMachine_USCORElistMetricNames(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORElistMetricNames::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, _vbox__ICloudMachine_USCORElistMetricNames const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNames", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNames ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNames const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNames", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNames ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNames const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNames", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNames ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNames const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_listMetricNames", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORElistMetricNames ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, _vbox__ICloudMachine_USCORElistMetricNames *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCORElistMetricNames(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORElistMetricNames *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCORElistMetricNames(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCORElistMetricNames(struct soap *soap, _vbox__ICloudMachine_USCORElistMetricNames *p)
{
	if (::soap_read__vbox__ICloudMachine_USCORElistMetricNames(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse * soap_new__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse * soap_new_req__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse * soap_new_set__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(struct soap *soap, _vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREdeleteConsoleConnectionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREdeleteConsoleConnection * soap_new__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREdeleteConsoleConnection(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREdeleteConsoleConnection * soap_new_req__vbox__ICloudMachine_USCOREdeleteConsoleConnection(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREdeleteConsoleConnection *_p = ::soap_new__vbox__ICloudMachine_USCOREdeleteConsoleConnection(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREdeleteConsoleConnection::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREdeleteConsoleConnection * soap_new_set__vbox__ICloudMachine_USCOREdeleteConsoleConnection(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREdeleteConsoleConnection *_p = ::soap_new__vbox__ICloudMachine_USCOREdeleteConsoleConnection(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREdeleteConsoleConnection::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, _vbox__ICloudMachine_USCOREdeleteConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnection ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnection ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnection ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_deleteConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREdeleteConsoleConnection ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, _vbox__ICloudMachine_USCOREdeleteConsoleConnection *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREdeleteConsoleConnection(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREdeleteConsoleConnection *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREdeleteConsoleConnection(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREdeleteConsoleConnection(struct soap *soap, _vbox__ICloudMachine_USCOREdeleteConsoleConnection *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREdeleteConsoleConnection(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse * soap_new__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse * soap_new_req__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse * soap_new_set__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnectionResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(struct soap *soap, _vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREcreateConsoleConnectionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREcreateConsoleConnection * soap_new__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREcreateConsoleConnection(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREcreateConsoleConnection * soap_new_req__vbox__ICloudMachine_USCOREcreateConsoleConnection(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& sshPublicKey)
{
	_vbox__ICloudMachine_USCOREcreateConsoleConnection *_p = ::soap_new__vbox__ICloudMachine_USCOREcreateConsoleConnection(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREcreateConsoleConnection::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudMachine_USCOREcreateConsoleConnection::sshPublicKey = sshPublicKey;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREcreateConsoleConnection * soap_new_set__vbox__ICloudMachine_USCOREcreateConsoleConnection(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& sshPublicKey)
{
	_vbox__ICloudMachine_USCOREcreateConsoleConnection *_p = ::soap_new__vbox__ICloudMachine_USCOREcreateConsoleConnection(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREcreateConsoleConnection::_USCOREthis = _USCOREthis;
		_p->_vbox__ICloudMachine_USCOREcreateConsoleConnection::sshPublicKey = sshPublicKey;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, _vbox__ICloudMachine_USCOREcreateConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnection ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnection ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnection ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnection const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_createConsoleConnection", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREcreateConsoleConnection ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, _vbox__ICloudMachine_USCOREcreateConsoleConnection *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREcreateConsoleConnection(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREcreateConsoleConnection *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREcreateConsoleConnection(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREcreateConsoleConnection(struct soap *soap, _vbox__ICloudMachine_USCOREcreateConsoleConnection *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREcreateConsoleConnection(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse * soap_new__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse * soap_new_req__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(
	struct soap *soap,
	const std::string& stream,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetConsoleHistoryResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleHistoryResponse::stream = stream;
		_p->_vbox__ICloudMachine_USCOREgetConsoleHistoryResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse * soap_new_set__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(
	struct soap *soap,
	const std::string& stream,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetConsoleHistoryResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleHistoryResponse::stream = stream;
		_p->_vbox__ICloudMachine_USCOREgetConsoleHistoryResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistoryResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistoryResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistoryResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistoryResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleHistoryResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetConsoleHistoryResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleHistory * soap_new__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetConsoleHistory(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleHistory * soap_new_req__vbox__ICloudMachine_USCOREgetConsoleHistory(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetConsoleHistory *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleHistory(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleHistory::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleHistory * soap_new_set__vbox__ICloudMachine_USCOREgetConsoleHistory(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetConsoleHistory *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleHistory(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleHistory::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleHistory const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistory", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistory ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistory const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistory", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistory ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistory const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistory", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistory ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistory const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleHistory", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleHistory ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleHistory *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetConsoleHistory(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleHistory *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetConsoleHistory(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetConsoleHistory(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleHistory *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetConsoleHistory(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREremoveResponse * soap_new__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREremoveResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREremoveResponse * soap_new_req__vbox__ICloudMachine_USCOREremoveResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREremoveResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREremoveResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREremoveResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREremoveResponse * soap_new_set__vbox__ICloudMachine_USCOREremoveResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREremoveResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREremoveResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREremoveResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, _vbox__ICloudMachine_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremoveResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_removeResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremoveResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, _vbox__ICloudMachine_USCOREremoveResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREremoveResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremoveResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREremoveResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREremoveResponse(struct soap *soap, _vbox__ICloudMachine_USCOREremoveResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREremoveResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREremove * soap_new__vbox__ICloudMachine_USCOREremove(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREremove(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREremove * soap_new_req__vbox__ICloudMachine_USCOREremove(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREremove *_p = ::soap_new__vbox__ICloudMachine_USCOREremove(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREremove::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREremove * soap_new_set__vbox__ICloudMachine_USCOREremove(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREremove *_p = ::soap_new__vbox__ICloudMachine_USCOREremove(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREremove::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREremove(struct soap *soap, _vbox__ICloudMachine_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremove ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremove ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremove ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremove const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_remove", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREremove ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREremove(struct soap *soap, _vbox__ICloudMachine_USCOREremove *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREremove(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREremove(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREremove *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREremove(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREremove(struct soap *soap, _vbox__ICloudMachine_USCOREremove *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREremove(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREunregisterResponse * soap_new__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREunregisterResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREunregisterResponse * soap_new_req__vbox__ICloudMachine_USCOREunregisterResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREunregisterResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREunregisterResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREunregisterResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREunregisterResponse * soap_new_set__vbox__ICloudMachine_USCOREunregisterResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREunregisterResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREunregisterResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREunregisterResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, _vbox__ICloudMachine_USCOREunregisterResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregisterResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregisterResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregisterResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregisterResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregisterResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregisterResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregisterResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregisterResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregisterResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregisterResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregisterResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, _vbox__ICloudMachine_USCOREunregisterResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREunregisterResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregisterResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREunregisterResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREunregisterResponse(struct soap *soap, _vbox__ICloudMachine_USCOREunregisterResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREunregisterResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREunregister * soap_new__vbox__ICloudMachine_USCOREunregister(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREunregister(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREunregister * soap_new_req__vbox__ICloudMachine_USCOREunregister(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREunregister *_p = ::soap_new__vbox__ICloudMachine_USCOREunregister(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREunregister::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREunregister * soap_new_set__vbox__ICloudMachine_USCOREunregister(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREunregister *_p = ::soap_new__vbox__ICloudMachine_USCOREunregister(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREunregister::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREunregister(struct soap *soap, _vbox__ICloudMachine_USCOREunregister const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregister", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregister ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREunregister(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregister const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregister", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregister ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREunregister(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregister const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregister", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregister ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREunregister(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregister const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_unregister", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREunregister ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREunregister(struct soap *soap, _vbox__ICloudMachine_USCOREunregister *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREunregister(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREunregister(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREunregister *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREunregister(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREunregister(struct soap *soap, _vbox__ICloudMachine_USCOREunregister *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREunregister(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREterminateResponse * soap_new__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREterminateResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREterminateResponse * soap_new_req__vbox__ICloudMachine_USCOREterminateResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREterminateResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREterminateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREterminateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREterminateResponse * soap_new_set__vbox__ICloudMachine_USCOREterminateResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREterminateResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREterminateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREterminateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, _vbox__ICloudMachine_USCOREterminateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminateResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminateResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, _vbox__ICloudMachine_USCOREterminateResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREterminateResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminateResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREterminateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREterminateResponse(struct soap *soap, _vbox__ICloudMachine_USCOREterminateResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREterminateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREterminate * soap_new__vbox__ICloudMachine_USCOREterminate(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREterminate(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREterminate * soap_new_req__vbox__ICloudMachine_USCOREterminate(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREterminate *_p = ::soap_new__vbox__ICloudMachine_USCOREterminate(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREterminate::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREterminate * soap_new_set__vbox__ICloudMachine_USCOREterminate(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREterminate *_p = ::soap_new__vbox__ICloudMachine_USCOREterminate(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREterminate::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREterminate(struct soap *soap, _vbox__ICloudMachine_USCOREterminate const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminate", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminate ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREterminate(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminate const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminate", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminate ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREterminate(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminate const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminate", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminate ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREterminate(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminate const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_terminate", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREterminate ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREterminate(struct soap *soap, _vbox__ICloudMachine_USCOREterminate *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREterminate(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREterminate(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREterminate *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREterminate(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREterminate(struct soap *soap, _vbox__ICloudMachine_USCOREterminate *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREterminate(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerDownResponse * soap_new__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREpowerDownResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerDownResponse * soap_new_req__vbox__ICloudMachine_USCOREpowerDownResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREpowerDownResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerDownResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerDownResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerDownResponse * soap_new_set__vbox__ICloudMachine_USCOREpowerDownResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREpowerDownResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerDownResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerDownResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, _vbox__ICloudMachine_USCOREpowerDownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDownResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDownResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDownResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDownResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, _vbox__ICloudMachine_USCOREpowerDownResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREpowerDownResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDownResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREpowerDownResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREpowerDownResponse(struct soap *soap, _vbox__ICloudMachine_USCOREpowerDownResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREpowerDownResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerDown * soap_new__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREpowerDown(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerDown * soap_new_req__vbox__ICloudMachine_USCOREpowerDown(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREpowerDown *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerDown(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerDown::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerDown * soap_new_set__vbox__ICloudMachine_USCOREpowerDown(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREpowerDown *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerDown(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerDown::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, _vbox__ICloudMachine_USCOREpowerDown const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDown ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDown const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDown ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDown const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDown ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDown const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerDown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerDown ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, _vbox__ICloudMachine_USCOREpowerDown *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREpowerDown(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerDown *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREpowerDown(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREpowerDown(struct soap *soap, _vbox__ICloudMachine_USCOREpowerDown *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREpowerDown(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREshutdownResponse * soap_new__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREshutdownResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREshutdownResponse * soap_new_req__vbox__ICloudMachine_USCOREshutdownResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREshutdownResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREshutdownResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREshutdownResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREshutdownResponse * soap_new_set__vbox__ICloudMachine_USCOREshutdownResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREshutdownResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREshutdownResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREshutdownResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, _vbox__ICloudMachine_USCOREshutdownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdownResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdownResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdownResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdownResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdownResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdownResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, _vbox__ICloudMachine_USCOREshutdownResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREshutdownResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdownResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREshutdownResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREshutdownResponse(struct soap *soap, _vbox__ICloudMachine_USCOREshutdownResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREshutdownResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREshutdown * soap_new__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREshutdown(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREshutdown * soap_new_req__vbox__ICloudMachine_USCOREshutdown(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREshutdown *_p = ::soap_new__vbox__ICloudMachine_USCOREshutdown(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREshutdown::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREshutdown * soap_new_set__vbox__ICloudMachine_USCOREshutdown(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREshutdown *_p = ::soap_new__vbox__ICloudMachine_USCOREshutdown(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREshutdown::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, _vbox__ICloudMachine_USCOREshutdown const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdown ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdown const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdown ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdown const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdown ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdown const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_shutdown", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREshutdown ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, _vbox__ICloudMachine_USCOREshutdown *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREshutdown(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREshutdown *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREshutdown(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREshutdown(struct soap *soap, _vbox__ICloudMachine_USCOREshutdown *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREshutdown(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREresetResponse * soap_new__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREresetResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREresetResponse * soap_new_req__vbox__ICloudMachine_USCOREresetResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREresetResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREresetResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREresetResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREresetResponse * soap_new_set__vbox__ICloudMachine_USCOREresetResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREresetResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREresetResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREresetResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, _vbox__ICloudMachine_USCOREresetResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_resetResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREresetResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREresetResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_resetResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREresetResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREresetResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_resetResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREresetResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREresetResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_resetResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREresetResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, _vbox__ICloudMachine_USCOREresetResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREresetResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREresetResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREresetResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREresetResponse(struct soap *soap, _vbox__ICloudMachine_USCOREresetResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREresetResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREreset * soap_new__vbox__ICloudMachine_USCOREreset(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREreset(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREreset * soap_new_req__vbox__ICloudMachine_USCOREreset(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREreset *_p = ::soap_new__vbox__ICloudMachine_USCOREreset(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREreset::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREreset * soap_new_set__vbox__ICloudMachine_USCOREreset(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREreset *_p = ::soap_new__vbox__ICloudMachine_USCOREreset(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREreset::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREreset(struct soap *soap, _vbox__ICloudMachine_USCOREreset const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reset", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreset ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREreset(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreset const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reset", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreset ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREreset(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreset const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reset", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreset ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREreset(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreset const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reset", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreset ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREreset(struct soap *soap, _vbox__ICloudMachine_USCOREreset *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREreset(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREreset(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreset *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREreset(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREreset(struct soap *soap, _vbox__ICloudMachine_USCOREreset *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREreset(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCORErebootResponse * soap_new__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCORErebootResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCORErebootResponse * soap_new_req__vbox__ICloudMachine_USCORErebootResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCORErebootResponse *_p = ::soap_new__vbox__ICloudMachine_USCORErebootResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORErebootResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCORErebootResponse * soap_new_set__vbox__ICloudMachine_USCORErebootResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCORErebootResponse *_p = ::soap_new__vbox__ICloudMachine_USCORErebootResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORErebootResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, _vbox__ICloudMachine_USCORErebootResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_rebootResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErebootResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErebootResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_rebootResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErebootResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErebootResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_rebootResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErebootResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErebootResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_rebootResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErebootResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, _vbox__ICloudMachine_USCORErebootResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCORErebootResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErebootResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCORErebootResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCORErebootResponse(struct soap *soap, _vbox__ICloudMachine_USCORErebootResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCORErebootResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREreboot * soap_new__vbox__ICloudMachine_USCOREreboot(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREreboot(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREreboot * soap_new_req__vbox__ICloudMachine_USCOREreboot(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREreboot *_p = ::soap_new__vbox__ICloudMachine_USCOREreboot(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREreboot::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREreboot * soap_new_set__vbox__ICloudMachine_USCOREreboot(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREreboot *_p = ::soap_new__vbox__ICloudMachine_USCOREreboot(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREreboot::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREreboot(struct soap *soap, _vbox__ICloudMachine_USCOREreboot const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reboot", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreboot ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREreboot(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreboot const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reboot", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreboot ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREreboot(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreboot const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reboot", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreboot ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREreboot(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreboot const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_reboot", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREreboot ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREreboot(struct soap *soap, _vbox__ICloudMachine_USCOREreboot *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREreboot(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREreboot(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREreboot *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREreboot(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREreboot(struct soap *soap, _vbox__ICloudMachine_USCOREreboot *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREreboot(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerUpResponse * soap_new__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREpowerUpResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerUpResponse * soap_new_req__vbox__ICloudMachine_USCOREpowerUpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREpowerUpResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerUpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerUpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerUpResponse * soap_new_set__vbox__ICloudMachine_USCOREpowerUpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREpowerUpResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerUpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerUpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, _vbox__ICloudMachine_USCOREpowerUpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUpResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUpResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUpResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUpResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUpResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUpResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, _vbox__ICloudMachine_USCOREpowerUpResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREpowerUpResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUpResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREpowerUpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREpowerUpResponse(struct soap *soap, _vbox__ICloudMachine_USCOREpowerUpResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREpowerUpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerUp * soap_new__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREpowerUp(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerUp * soap_new_req__vbox__ICloudMachine_USCOREpowerUp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREpowerUp *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerUp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerUp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREpowerUp * soap_new_set__vbox__ICloudMachine_USCOREpowerUp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREpowerUp *_p = ::soap_new__vbox__ICloudMachine_USCOREpowerUp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREpowerUp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, _vbox__ICloudMachine_USCOREpowerUp const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUp", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUp ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUp const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUp", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUp const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUp", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUp const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_powerUp", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREpowerUp ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, _vbox__ICloudMachine_USCOREpowerUp *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREpowerUp(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREpowerUp *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREpowerUp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREpowerUp(struct soap *soap, _vbox__ICloudMachine_USCOREpowerUp *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREpowerUp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSettingsFormResponse * soap_new__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetSettingsFormResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSettingsFormResponse * soap_new_req__vbox__ICloudMachine_USCOREgetSettingsFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetSettingsFormResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSettingsFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSettingsFormResponse::form = form;
		_p->_vbox__ICloudMachine_USCOREgetSettingsFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSettingsFormResponse * soap_new_set__vbox__ICloudMachine_USCOREgetSettingsFormResponse(
	struct soap *soap,
	const std::string& form,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetSettingsFormResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSettingsFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSettingsFormResponse::form = form;
		_p->_vbox__ICloudMachine_USCOREgetSettingsFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSettingsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSettingsFormResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetSettingsFormResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsFormResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetSettingsFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetSettingsFormResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSettingsFormResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetSettingsFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSettingsForm * soap_new__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetSettingsForm(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSettingsForm * soap_new_req__vbox__ICloudMachine_USCOREgetSettingsForm(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetSettingsForm *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSettingsForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSettingsForm::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSettingsForm * soap_new_set__vbox__ICloudMachine_USCOREgetSettingsForm(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetSettingsForm *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSettingsForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSettingsForm::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, _vbox__ICloudMachine_USCOREgetSettingsForm const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsForm ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsForm const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsForm const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsForm const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSettingsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSettingsForm ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, _vbox__ICloudMachine_USCOREgetSettingsForm *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetSettingsForm(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSettingsForm *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetSettingsForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetSettingsForm(struct soap *soap, _vbox__ICloudMachine_USCOREgetSettingsForm *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetSettingsForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetDetailsFormResponse * soap_new__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetDetailsFormResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetDetailsFormResponse * soap_new_req__vbox__ICloudMachine_USCOREgetDetailsFormResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetDetailsFormResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetDetailsFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetDetailsFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetDetailsFormResponse * soap_new_set__vbox__ICloudMachine_USCOREgetDetailsFormResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetDetailsFormResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetDetailsFormResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetDetailsFormResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetDetailsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsFormResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsFormResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsFormResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsFormResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetDetailsFormResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetDetailsFormResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsFormResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetDetailsFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetDetailsFormResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetDetailsFormResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetDetailsFormResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetDetailsForm * soap_new__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetDetailsForm(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetDetailsForm * soap_new_req__vbox__ICloudMachine_USCOREgetDetailsForm(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetDetailsForm *_p = ::soap_new__vbox__ICloudMachine_USCOREgetDetailsForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetDetailsForm::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetDetailsForm * soap_new_set__vbox__ICloudMachine_USCOREgetDetailsForm(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetDetailsForm *_p = ::soap_new__vbox__ICloudMachine_USCOREgetDetailsForm(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetDetailsForm::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, _vbox__ICloudMachine_USCOREgetDetailsForm const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsForm ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsForm const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsForm const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsForm ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsForm const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getDetailsForm", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetDetailsForm ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, _vbox__ICloudMachine_USCOREgetDetailsForm *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetDetailsForm(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetDetailsForm *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetDetailsForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetDetailsForm(struct soap *soap, _vbox__ICloudMachine_USCOREgetDetailsForm *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetDetailsForm(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCORErefreshResponse * soap_new__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCORErefreshResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCORErefreshResponse * soap_new_req__vbox__ICloudMachine_USCORErefreshResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCORErefreshResponse *_p = ::soap_new__vbox__ICloudMachine_USCORErefreshResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORErefreshResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCORErefreshResponse * soap_new_set__vbox__ICloudMachine_USCORErefreshResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCORErefreshResponse *_p = ::soap_new__vbox__ICloudMachine_USCORErefreshResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORErefreshResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, _vbox__ICloudMachine_USCORErefreshResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refreshResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefreshResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefreshResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refreshResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefreshResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefreshResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refreshResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefreshResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefreshResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refreshResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefreshResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, _vbox__ICloudMachine_USCORErefreshResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCORErefreshResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefreshResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCORErefreshResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCORErefreshResponse(struct soap *soap, _vbox__ICloudMachine_USCORErefreshResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCORErefreshResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCORErefresh * soap_new__vbox__ICloudMachine_USCORErefresh(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCORErefresh(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCORErefresh * soap_new_req__vbox__ICloudMachine_USCORErefresh(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCORErefresh *_p = ::soap_new__vbox__ICloudMachine_USCORErefresh(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORErefresh::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCORErefresh * soap_new_set__vbox__ICloudMachine_USCORErefresh(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCORErefresh *_p = ::soap_new__vbox__ICloudMachine_USCORErefresh(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCORErefresh::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCORErefresh(struct soap *soap, _vbox__ICloudMachine_USCORErefresh const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refresh", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefresh ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCORErefresh(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefresh const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refresh", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefresh ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCORErefresh(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefresh const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refresh", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefresh ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCORErefresh(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefresh const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_refresh", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCORErefresh ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCORErefresh(struct soap *soap, _vbox__ICloudMachine_USCORErefresh *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCORErefresh(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCORErefresh(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCORErefresh *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCORErefresh(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCORErefresh(struct soap *soap, _vbox__ICloudMachine_USCORErefresh *p)
{
	if (::soap_read__vbox__ICloudMachine_USCORErefresh(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse * soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse * soap_new_req__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse * soap_new_set__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindowsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows * soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows * soap_new_req__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows * soap_new_set__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandWindows(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse * soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse * soap_new_req__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse * soap_new_set__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommandResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommand * soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommand * soap_new_req__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommand *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommand::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetVNCConsoleCommand * soap_new_set__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetVNCConsoleCommand *_p = ::soap_new__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetVNCConsoleCommand::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommand ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommand ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommand ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getVNCConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetVNCConsoleCommand ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(struct soap *soap, _vbox__ICloudMachine_USCOREgetVNCConsoleCommand *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetVNCConsoleCommand(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse * soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse * soap_new_req__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse * soap_new_set__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindowsResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindowsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows * soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows * soap_new_req__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows * soap_new_set__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandWindows", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandWindows(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse * soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse * soap_new_req__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse * soap_new_set__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommandResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommandResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommand * soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommand * soap_new_req__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommand *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommand::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetSerialConsoleCommand * soap_new_set__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetSerialConsoleCommand *_p = ::soap_new__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetSerialConsoleCommand::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommand ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommand ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommand ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getSerialConsoleCommand", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetSerialConsoleCommand ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(struct soap *soap, _vbox__ICloudMachine_USCOREgetSerialConsoleCommand *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetSerialConsoleCommand(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse * soap_new__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse * soap_new_req__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse * soap_new_set__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprintResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprintResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprintResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprintResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprintResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint * soap_new__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint * soap_new_req__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint * soap_new_set__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint *_p = ::soap_new__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprint", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprint", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprint", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getConsoleConnectionFingerprint", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(struct soap *soap, _vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetConsoleConnectionFingerprint(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetStateResponse * soap_new__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetStateResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetStateResponse * soap_new_req__vbox__ICloudMachine_USCOREgetStateResponse(
	struct soap *soap,
	enum vbox__CloudMachineState returnval)
{
	_vbox__ICloudMachine_USCOREgetStateResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetStateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetStateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetStateResponse * soap_new_set__vbox__ICloudMachine_USCOREgetStateResponse(
	struct soap *soap,
	enum vbox__CloudMachineState returnval)
{
	_vbox__ICloudMachine_USCOREgetStateResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetStateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetStateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetStateResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetStateResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetStateResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetStateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetStateResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetStateResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetStateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetState * soap_new__vbox__ICloudMachine_USCOREgetState(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetState(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetState * soap_new_req__vbox__ICloudMachine_USCOREgetState(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetState *_p = ::soap_new__vbox__ICloudMachine_USCOREgetState(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetState::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetState * soap_new_set__vbox__ICloudMachine_USCOREgetState(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetState *_p = ::soap_new__vbox__ICloudMachine_USCOREgetState(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetState::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetState(struct soap *soap, _vbox__ICloudMachine_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getState", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetState ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetState(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getState", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetState ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetState(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getState", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetState ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetState(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getState", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetState ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetState(struct soap *soap, _vbox__ICloudMachine_USCOREgetState *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetState(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetState(struct soap *soap, _vbox__ICloudMachine_USCOREgetState *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetOSTypeIdResponse * soap_new__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetOSTypeIdResponse * soap_new_req__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetOSTypeIdResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetOSTypeIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetOSTypeIdResponse * soap_new_set__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetOSTypeIdResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetOSTypeIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetOSTypeIdResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetOSTypeIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetOSTypeId * soap_new__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetOSTypeId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetOSTypeId * soap_new_req__vbox__ICloudMachine_USCOREgetOSTypeId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetOSTypeId *_p = ::soap_new__vbox__ICloudMachine_USCOREgetOSTypeId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetOSTypeId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetOSTypeId * soap_new_set__vbox__ICloudMachine_USCOREgetOSTypeId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetOSTypeId *_p = ::soap_new__vbox__ICloudMachine_USCOREgetOSTypeId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetOSTypeId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, _vbox__ICloudMachine_USCOREgetOSTypeId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getOSTypeId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetOSTypeId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, _vbox__ICloudMachine_USCOREgetOSTypeId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetOSTypeId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetOSTypeId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetOSTypeId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetOSTypeId(struct soap *soap, _vbox__ICloudMachine_USCOREgetOSTypeId *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetOSTypeId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetNameResponse * soap_new__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetNameResponse * soap_new_req__vbox__ICloudMachine_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetNameResponse * soap_new_set__vbox__ICloudMachine_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetNameResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetNameResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetName * soap_new__vbox__ICloudMachine_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetName * soap_new_req__vbox__ICloudMachine_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetName *_p = ::soap_new__vbox__ICloudMachine_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetName * soap_new_set__vbox__ICloudMachine_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetName *_p = ::soap_new__vbox__ICloudMachine_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetName(struct soap *soap, _vbox__ICloudMachine_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getName", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetName(struct soap *soap, _vbox__ICloudMachine_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetName(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetName(struct soap *soap, _vbox__ICloudMachine_USCOREgetName *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessErrorResponse * soap_new__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetAccessErrorResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessErrorResponse * soap_new_req__vbox__ICloudMachine_USCOREgetAccessErrorResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetAccessErrorResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessErrorResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessErrorResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessErrorResponse * soap_new_set__vbox__ICloudMachine_USCOREgetAccessErrorResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetAccessErrorResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessErrorResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessErrorResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessErrorResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessErrorResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessErrorResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessErrorResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessErrorResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessErrorResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessErrorResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessErrorResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessErrorResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetAccessErrorResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessErrorResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetAccessErrorResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetAccessErrorResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessErrorResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetAccessErrorResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessError * soap_new__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetAccessError(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessError * soap_new_req__vbox__ICloudMachine_USCOREgetAccessError(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetAccessError *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessError(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessError::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessError * soap_new_set__vbox__ICloudMachine_USCOREgetAccessError(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetAccessError *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessError(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessError::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessError const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessError", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessError ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessError const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessError", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessError ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessError const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessError", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessError ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessError const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessError", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessError ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessError *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetAccessError(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessError *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetAccessError(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetAccessError(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessError *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetAccessError(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessibleResponse * soap_new__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetAccessibleResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessibleResponse * soap_new_req__vbox__ICloudMachine_USCOREgetAccessibleResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudMachine_USCOREgetAccessibleResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessibleResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessibleResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessibleResponse * soap_new_set__vbox__ICloudMachine_USCOREgetAccessibleResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICloudMachine_USCOREgetAccessibleResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessibleResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessibleResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessibleResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessibleResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessibleResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessibleResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessibleResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessibleResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessibleResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessibleResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessibleResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetAccessibleResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessibleResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetAccessibleResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetAccessibleResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessibleResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetAccessibleResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessible * soap_new__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetAccessible(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessible * soap_new_req__vbox__ICloudMachine_USCOREgetAccessible(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetAccessible *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessible(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessible::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetAccessible * soap_new_set__vbox__ICloudMachine_USCOREgetAccessible(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetAccessible *_p = ::soap_new__vbox__ICloudMachine_USCOREgetAccessible(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetAccessible::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessible const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessible", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessible ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessible const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessible", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessible ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessible const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessible", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessible ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessible const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getAccessible", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetAccessible ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessible *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetAccessible(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetAccessible *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetAccessible(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetAccessible(struct soap *soap, _vbox__ICloudMachine_USCOREgetAccessible *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetAccessible(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetCloudIdResponse * soap_new__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetCloudIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetCloudIdResponse * soap_new_req__vbox__ICloudMachine_USCOREgetCloudIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetCloudIdResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetCloudIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetCloudIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetCloudIdResponse * soap_new_set__vbox__ICloudMachine_USCOREgetCloudIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetCloudIdResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetCloudIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetCloudIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetCloudIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetCloudIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetCloudIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetCloudIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetCloudIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetCloudIdResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetCloudIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetCloudId * soap_new__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetCloudId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetCloudId * soap_new_req__vbox__ICloudMachine_USCOREgetCloudId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetCloudId *_p = ::soap_new__vbox__ICloudMachine_USCOREgetCloudId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetCloudId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetCloudId * soap_new_set__vbox__ICloudMachine_USCOREgetCloudId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetCloudId *_p = ::soap_new__vbox__ICloudMachine_USCOREgetCloudId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetCloudId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, _vbox__ICloudMachine_USCOREgetCloudId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getCloudId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetCloudId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, _vbox__ICloudMachine_USCOREgetCloudId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetCloudId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetCloudId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetCloudId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetCloudId(struct soap *soap, _vbox__ICloudMachine_USCOREgetCloudId *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetCloudId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetIdResponse * soap_new__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetIdResponse * soap_new_req__vbox__ICloudMachine_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetIdResponse * soap_new_set__vbox__ICloudMachine_USCOREgetIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudMachine_USCOREgetIdResponse *_p = ::soap_new__vbox__ICloudMachine_USCOREgetIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetIdResponse(struct soap *soap, _vbox__ICloudMachine_USCOREgetIdResponse *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetId * soap_new__vbox__ICloudMachine_USCOREgetId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudMachine_USCOREgetId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetId * soap_new_req__vbox__ICloudMachine_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetId *_p = ::soap_new__vbox__ICloudMachine_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudMachine_USCOREgetId * soap_new_set__vbox__ICloudMachine_USCOREgetId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudMachine_USCOREgetId *_p = ::soap_new__vbox__ICloudMachine_USCOREgetId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudMachine_USCOREgetId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudMachine_USCOREgetId(struct soap *soap, _vbox__ICloudMachine_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudMachine_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudMachine_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudMachine_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudMachine_getId", p->soap_type() == SOAP_TYPE__vbox__ICloudMachine_USCOREgetId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudMachine_USCOREgetId(struct soap *soap, _vbox__ICloudMachine_USCOREgetId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudMachine_USCOREgetId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudMachine_USCOREgetId(struct soap *soap, const char *URL, _vbox__ICloudMachine_USCOREgetId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudMachine_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudMachine_USCOREgetId(struct soap *soap, _vbox__ICloudMachine_USCOREgetId *p)
{
	if (::soap_read__vbox__ICloudMachine_USCOREgetId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse * soap_new__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse * soap_new_req__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse *_p = ::soap_new__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse * soap_new_set__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse *_p = ::soap_new__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(struct soap *soap, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse *p)
{
	if (::soap_read__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId * soap_new__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId * soap_new_req__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId *_p = ::soap_new__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId * soap_new_set__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId *_p = ::soap_new__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkEnvironmentInfo_getTunnelNetworkId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, const char *URL, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(struct soap *soap, _vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId *p)
{
	if (::soap_read__vbox__ICloudNetworkEnvironmentInfo_USCOREgetTunnelNetworkId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceIdResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getInstanceId", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetInstanceId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddressResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddressResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddressResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddressResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddressResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddress", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddress", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddress", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getMacAddress", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetMacAddress(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIPResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getSecondaryPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetSecondaryPublicIP(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIPResponse", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIPResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP * soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP * soap_new_req__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP * soap_new_set__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP *_p = ::soap_new__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICloudNetworkGatewayInfo_getPublicIP", p->soap_type() == SOAP_TYPE__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, const char *URL, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(struct soap *soap, _vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP *p)
{
	if (::soap_read__vbox__ICloudNetworkGatewayInfo_USCOREgetPublicIP(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse * soap_new__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse * soap_new_req__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse *_p = ::soap_new__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse * soap_new_set__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse *_p = ::soap_new__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(struct soap *soap, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse *p)
{
	if (::soap_read__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescriptionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription * soap_new__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription * soap_new_req__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription *_p = ::soap_new__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription * soap_new_set__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription *_p = ::soap_new__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescription", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescription", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescription", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IVirtualSystemDescriptionForm_getVirtualSystemDescription", p->soap_type() == SOAP_TYPE__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, const char *URL, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(struct soap *soap, _vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription *p)
{
	if (::soap_read__vbox__IVirtualSystemDescriptionForm_USCOREgetVirtualSystemDescription(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IForm_USCOREapplyResponse * soap_new__vbox__IForm_USCOREapplyResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IForm_USCOREapplyResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IForm_USCOREapplyResponse * soap_new_req__vbox__IForm_USCOREapplyResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IForm_USCOREapplyResponse *_p = ::soap_new__vbox__IForm_USCOREapplyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREapplyResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IForm_USCOREapplyResponse * soap_new_set__vbox__IForm_USCOREapplyResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IForm_USCOREapplyResponse *_p = ::soap_new__vbox__IForm_USCOREapplyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREapplyResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IForm_USCOREapplyResponse(struct soap *soap, _vbox__IForm_USCOREapplyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_applyResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapplyResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IForm_USCOREapplyResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREapplyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_applyResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapplyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IForm_USCOREapplyResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREapplyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_applyResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapplyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IForm_USCOREapplyResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREapplyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_applyResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapplyResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IForm_USCOREapplyResponse(struct soap *soap, _vbox__IForm_USCOREapplyResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IForm_USCOREapplyResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IForm_USCOREapplyResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREapplyResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IForm_USCOREapplyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IForm_USCOREapplyResponse(struct soap *soap, _vbox__IForm_USCOREapplyResponse *p)
{
	if (::soap_read__vbox__IForm_USCOREapplyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IForm_USCOREapply * soap_new__vbox__IForm_USCOREapply(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IForm_USCOREapply(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IForm_USCOREapply * soap_new_req__vbox__IForm_USCOREapply(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IForm_USCOREapply *_p = ::soap_new__vbox__IForm_USCOREapply(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREapply::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IForm_USCOREapply * soap_new_set__vbox__IForm_USCOREapply(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IForm_USCOREapply *_p = ::soap_new__vbox__IForm_USCOREapply(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREapply::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IForm_USCOREapply(struct soap *soap, _vbox__IForm_USCOREapply const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_apply", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapply ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IForm_USCOREapply(struct soap *soap, const char *URL, _vbox__IForm_USCOREapply const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_apply", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapply ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IForm_USCOREapply(struct soap *soap, const char *URL, _vbox__IForm_USCOREapply const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_apply", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapply ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IForm_USCOREapply(struct soap *soap, const char *URL, _vbox__IForm_USCOREapply const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_apply", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREapply ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IForm_USCOREapply(struct soap *soap, _vbox__IForm_USCOREapply *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IForm_USCOREapply(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IForm_USCOREapply(struct soap *soap, const char *URL, _vbox__IForm_USCOREapply *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IForm_USCOREapply(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IForm_USCOREapply(struct soap *soap, _vbox__IForm_USCOREapply *p)
{
	if (::soap_read__vbox__IForm_USCOREapply(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IForm_USCOREgetFieldGroupResponse * soap_new__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IForm_USCOREgetFieldGroupResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IForm_USCOREgetFieldGroupResponse * soap_new_req__vbox__IForm_USCOREgetFieldGroupResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IForm_USCOREgetFieldGroupResponse *_p = ::soap_new__vbox__IForm_USCOREgetFieldGroupResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetFieldGroupResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IForm_USCOREgetFieldGroupResponse * soap_new_set__vbox__IForm_USCOREgetFieldGroupResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IForm_USCOREgetFieldGroupResponse *_p = ::soap_new__vbox__IForm_USCOREgetFieldGroupResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetFieldGroupResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, _vbox__IForm_USCOREgetFieldGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroupResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroupResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroupResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroupResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, _vbox__IForm_USCOREgetFieldGroupResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IForm_USCOREgetFieldGroupResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroupResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IForm_USCOREgetFieldGroupResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IForm_USCOREgetFieldGroupResponse(struct soap *soap, _vbox__IForm_USCOREgetFieldGroupResponse *p)
{
	if (::soap_read__vbox__IForm_USCOREgetFieldGroupResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IForm_USCOREgetFieldGroup * soap_new__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IForm_USCOREgetFieldGroup(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IForm_USCOREgetFieldGroup * soap_new_req__vbox__IForm_USCOREgetFieldGroup(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& field)
{
	_vbox__IForm_USCOREgetFieldGroup *_p = ::soap_new__vbox__IForm_USCOREgetFieldGroup(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetFieldGroup::_USCOREthis = _USCOREthis;
		_p->_vbox__IForm_USCOREgetFieldGroup::field = field;
	}
	return _p;
}

/*noinline*/ _vbox__IForm_USCOREgetFieldGroup * soap_new_set__vbox__IForm_USCOREgetFieldGroup(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& field)
{
	_vbox__IForm_USCOREgetFieldGroup *_p = ::soap_new__vbox__IForm_USCOREgetFieldGroup(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetFieldGroup::_USCOREthis = _USCOREthis;
		_p->_vbox__IForm_USCOREgetFieldGroup::field = field;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, _vbox__IForm_USCOREgetFieldGroup const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroup", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroup ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroup const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroup", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroup ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroup const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroup", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroup ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroup const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getFieldGroup", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetFieldGroup ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, _vbox__IForm_USCOREgetFieldGroup *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IForm_USCOREgetFieldGroup(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetFieldGroup *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IForm_USCOREgetFieldGroup(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IForm_USCOREgetFieldGroup(struct soap *soap, _vbox__IForm_USCOREgetFieldGroup *p)
{
	if (::soap_read__vbox__IForm_USCOREgetFieldGroup(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IForm_USCOREgetValuesResponse * soap_new__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IForm_USCOREgetValuesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IForm_USCOREgetValuesResponse * soap_new_req__vbox__IForm_USCOREgetValuesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IForm_USCOREgetValuesResponse *_p = ::soap_new__vbox__IForm_USCOREgetValuesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetValuesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IForm_USCOREgetValuesResponse * soap_new_set__vbox__IForm_USCOREgetValuesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IForm_USCOREgetValuesResponse *_p = ::soap_new__vbox__IForm_USCOREgetValuesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetValuesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, _vbox__IForm_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, _vbox__IForm_USCOREgetValuesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IForm_USCOREgetValuesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValuesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IForm_USCOREgetValuesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IForm_USCOREgetValuesResponse(struct soap *soap, _vbox__IForm_USCOREgetValuesResponse *p)
{
	if (::soap_read__vbox__IForm_USCOREgetValuesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IForm_USCOREgetValues * soap_new__vbox__IForm_USCOREgetValues(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IForm_USCOREgetValues(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IForm_USCOREgetValues * soap_new_req__vbox__IForm_USCOREgetValues(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IForm_USCOREgetValues *_p = ::soap_new__vbox__IForm_USCOREgetValues(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetValues::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IForm_USCOREgetValues * soap_new_set__vbox__IForm_USCOREgetValues(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IForm_USCOREgetValues *_p = ::soap_new__vbox__IForm_USCOREgetValues(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IForm_USCOREgetValues::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IForm_USCOREgetValues(struct soap *soap, _vbox__IForm_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValues", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValues ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IForm_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValues", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValues ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IForm_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValues", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValues ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IForm_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IForm_getValues", p->soap_type() == SOAP_TYPE__vbox__IForm_USCOREgetValues ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IForm_USCOREgetValues(struct soap *soap, _vbox__IForm_USCOREgetValues *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IForm_USCOREgetValues(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IForm_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IForm_USCOREgetValues *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IForm_USCOREgetValues(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IForm_USCOREgetValues(struct soap *soap, _vbox__IForm_USCOREgetValues *p)
{
	if (::soap_read__vbox__IForm_USCOREgetValues(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse * soap_new__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse * soap_new_req__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse *_p = ::soap_new__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse * soap_new_set__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse *_p = ::soap_new__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse *p)
{
	if (::soap_read__vbox__IChoiceFormValue_USCOREsetSelectedIndexResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREsetSelectedIndex * soap_new__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IChoiceFormValue_USCOREsetSelectedIndex(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREsetSelectedIndex * soap_new_req__vbox__IChoiceFormValue_USCOREsetSelectedIndex(
	struct soap *soap,
	const std::string& _USCOREthis,
	int index)
{
	_vbox__IChoiceFormValue_USCOREsetSelectedIndex *_p = ::soap_new__vbox__IChoiceFormValue_USCOREsetSelectedIndex(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREsetSelectedIndex::_USCOREthis = _USCOREthis;
		_p->_vbox__IChoiceFormValue_USCOREsetSelectedIndex::index = index;
	}
	return _p;
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREsetSelectedIndex * soap_new_set__vbox__IChoiceFormValue_USCOREsetSelectedIndex(
	struct soap *soap,
	const std::string& _USCOREthis,
	int index)
{
	_vbox__IChoiceFormValue_USCOREsetSelectedIndex *_p = ::soap_new__vbox__IChoiceFormValue_USCOREsetSelectedIndex(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREsetSelectedIndex::_USCOREthis = _USCOREthis;
		_p->_vbox__IChoiceFormValue_USCOREsetSelectedIndex::index = index;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, _vbox__IChoiceFormValue_USCOREsetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndex ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndex ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndex ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_setSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREsetSelectedIndex ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, _vbox__IChoiceFormValue_USCOREsetSelectedIndex *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IChoiceFormValue_USCOREsetSelectedIndex(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREsetSelectedIndex *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IChoiceFormValue_USCOREsetSelectedIndex(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IChoiceFormValue_USCOREsetSelectedIndex(struct soap *soap, _vbox__IChoiceFormValue_USCOREsetSelectedIndex *p)
{
	if (::soap_read__vbox__IChoiceFormValue_USCOREsetSelectedIndex(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse * soap_new__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse * soap_new_req__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse * soap_new_set__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndexResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse *p)
{
	if (::soap_read__vbox__IChoiceFormValue_USCOREgetSelectedIndexResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetSelectedIndex * soap_new__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IChoiceFormValue_USCOREgetSelectedIndex(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetSelectedIndex * soap_new_req__vbox__IChoiceFormValue_USCOREgetSelectedIndex(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IChoiceFormValue_USCOREgetSelectedIndex *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetSelectedIndex(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetSelectedIndex::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetSelectedIndex * soap_new_set__vbox__IChoiceFormValue_USCOREgetSelectedIndex(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IChoiceFormValue_USCOREgetSelectedIndex *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetSelectedIndex(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetSelectedIndex::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndex ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndex ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndex ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndex const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getSelectedIndex", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetSelectedIndex ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetSelectedIndex *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IChoiceFormValue_USCOREgetSelectedIndex(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetSelectedIndex *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IChoiceFormValue_USCOREgetSelectedIndex(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IChoiceFormValue_USCOREgetSelectedIndex(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetSelectedIndex *p)
{
	if (::soap_read__vbox__IChoiceFormValue_USCOREgetSelectedIndex(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetValuesResponse * soap_new__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IChoiceFormValue_USCOREgetValuesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetValuesResponse * soap_new_req__vbox__IChoiceFormValue_USCOREgetValuesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IChoiceFormValue_USCOREgetValuesResponse *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetValuesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetValuesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetValuesResponse * soap_new_set__vbox__IChoiceFormValue_USCOREgetValuesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IChoiceFormValue_USCOREgetValuesResponse *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetValuesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetValuesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetValuesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IChoiceFormValue_USCOREgetValuesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValuesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IChoiceFormValue_USCOREgetValuesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IChoiceFormValue_USCOREgetValuesResponse(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetValuesResponse *p)
{
	if (::soap_read__vbox__IChoiceFormValue_USCOREgetValuesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetValues * soap_new__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IChoiceFormValue_USCOREgetValues(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetValues * soap_new_req__vbox__IChoiceFormValue_USCOREgetValues(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IChoiceFormValue_USCOREgetValues *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetValues(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetValues::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IChoiceFormValue_USCOREgetValues * soap_new_set__vbox__IChoiceFormValue_USCOREgetValues(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IChoiceFormValue_USCOREgetValues *_p = ::soap_new__vbox__IChoiceFormValue_USCOREgetValues(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IChoiceFormValue_USCOREgetValues::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValues", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValues ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValues", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValues ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValues", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValues ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IChoiceFormValue_getValues", p->soap_type() == SOAP_TYPE__vbox__IChoiceFormValue_USCOREgetValues ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetValues *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IChoiceFormValue_USCOREgetValues(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IChoiceFormValue_USCOREgetValues *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IChoiceFormValue_USCOREgetValues(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IChoiceFormValue_USCOREgetValues(struct soap *soap, _vbox__IChoiceFormValue_USCOREgetValues *p)
{
	if (::soap_read__vbox__IChoiceFormValue_USCOREgetValues(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREsetStringResponse * soap_new__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREsetStringResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREsetStringResponse * soap_new_req__vbox__IStringFormValue_USCOREsetStringResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IStringFormValue_USCOREsetStringResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREsetStringResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREsetStringResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREsetStringResponse * soap_new_set__vbox__IStringFormValue_USCOREsetStringResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IStringFormValue_USCOREsetStringResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREsetStringResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREsetStringResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREsetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetStringResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetStringResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetStringResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetStringResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREsetStringResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREsetStringResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetStringResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREsetStringResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREsetStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREsetStringResponse *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREsetStringResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREsetString * soap_new__vbox__IStringFormValue_USCOREsetString(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREsetString(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREsetString * soap_new_req__vbox__IStringFormValue_USCOREsetString(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& text)
{
	_vbox__IStringFormValue_USCOREsetString *_p = ::soap_new__vbox__IStringFormValue_USCOREsetString(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREsetString::_USCOREthis = _USCOREthis;
		_p->_vbox__IStringFormValue_USCOREsetString::text = text;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREsetString * soap_new_set__vbox__IStringFormValue_USCOREsetString(
	struct soap *soap,
	const std::string& _USCOREthis,
	const std::string& text)
{
	_vbox__IStringFormValue_USCOREsetString *_p = ::soap_new__vbox__IStringFormValue_USCOREsetString(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREsetString::_USCOREthis = _USCOREthis;
		_p->_vbox__IStringFormValue_USCOREsetString::text = text;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREsetString(struct soap *soap, _vbox__IStringFormValue_USCOREsetString const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetString ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREsetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetString const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetString ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREsetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetString const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetString ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREsetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetString const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_setString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREsetString ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREsetString(struct soap *soap, _vbox__IStringFormValue_USCOREsetString *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREsetString(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREsetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREsetString *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREsetString(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREsetString(struct soap *soap, _vbox__IStringFormValue_USCOREsetString *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREsetString(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetStringResponse * soap_new__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREgetStringResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetStringResponse * soap_new_req__vbox__IStringFormValue_USCOREgetStringResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IStringFormValue_USCOREgetStringResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREgetStringResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetStringResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetStringResponse * soap_new_set__vbox__IStringFormValue_USCOREgetStringResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IStringFormValue_USCOREgetStringResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREgetStringResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetStringResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetStringResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetStringResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetStringResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetStringResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetStringResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREgetStringResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetStringResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREgetStringResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREgetStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetStringResponse *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREgetStringResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetString * soap_new__vbox__IStringFormValue_USCOREgetString(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREgetString(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetString * soap_new_req__vbox__IStringFormValue_USCOREgetString(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringFormValue_USCOREgetString *_p = ::soap_new__vbox__IStringFormValue_USCOREgetString(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetString::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetString * soap_new_set__vbox__IStringFormValue_USCOREgetString(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringFormValue_USCOREgetString *_p = ::soap_new__vbox__IStringFormValue_USCOREgetString(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetString::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREgetString(struct soap *soap, _vbox__IStringFormValue_USCOREgetString const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetString ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREgetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetString const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetString ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREgetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetString const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetString ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREgetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetString const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetString ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREgetString(struct soap *soap, _vbox__IStringFormValue_USCOREgetString *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREgetString(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREgetString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetString *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREgetString(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREgetString(struct soap *soap, _vbox__IStringFormValue_USCOREgetString *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREgetString(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetClipboardStringResponse * soap_new__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREgetClipboardStringResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetClipboardStringResponse * soap_new_req__vbox__IStringFormValue_USCOREgetClipboardStringResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IStringFormValue_USCOREgetClipboardStringResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREgetClipboardStringResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetClipboardStringResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetClipboardStringResponse * soap_new_set__vbox__IStringFormValue_USCOREgetClipboardStringResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IStringFormValue_USCOREgetClipboardStringResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREgetClipboardStringResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetClipboardStringResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetClipboardStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardStringResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardStringResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardStringResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardStringResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardStringResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardStringResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetClipboardStringResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREgetClipboardStringResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardStringResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREgetClipboardStringResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREgetClipboardStringResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetClipboardStringResponse *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREgetClipboardStringResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetClipboardString * soap_new__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREgetClipboardString(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetClipboardString * soap_new_req__vbox__IStringFormValue_USCOREgetClipboardString(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringFormValue_USCOREgetClipboardString *_p = ::soap_new__vbox__IStringFormValue_USCOREgetClipboardString(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetClipboardString::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetClipboardString * soap_new_set__vbox__IStringFormValue_USCOREgetClipboardString(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringFormValue_USCOREgetClipboardString *_p = ::soap_new__vbox__IStringFormValue_USCOREgetClipboardString(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetClipboardString::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, _vbox__IStringFormValue_USCOREgetClipboardString const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardString ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardString const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardString ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardString const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardString ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardString const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getClipboardString", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetClipboardString ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, _vbox__IStringFormValue_USCOREgetClipboardString *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREgetClipboardString(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetClipboardString *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREgetClipboardString(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREgetClipboardString(struct soap *soap, _vbox__IStringFormValue_USCOREgetClipboardString *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREgetClipboardString(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetMultilineResponse * soap_new__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREgetMultilineResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetMultilineResponse * soap_new_req__vbox__IStringFormValue_USCOREgetMultilineResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IStringFormValue_USCOREgetMultilineResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREgetMultilineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetMultilineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetMultilineResponse * soap_new_set__vbox__IStringFormValue_USCOREgetMultilineResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IStringFormValue_USCOREgetMultilineResponse *_p = ::soap_new__vbox__IStringFormValue_USCOREgetMultilineResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetMultilineResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetMultilineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultilineResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultilineResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultilineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultilineResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultilineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultilineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultilineResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultilineResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultilineResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultilineResponse", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultilineResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetMultilineResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREgetMultilineResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultilineResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREgetMultilineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREgetMultilineResponse(struct soap *soap, _vbox__IStringFormValue_USCOREgetMultilineResponse *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREgetMultilineResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetMultiline * soap_new__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringFormValue_USCOREgetMultiline(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetMultiline * soap_new_req__vbox__IStringFormValue_USCOREgetMultiline(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringFormValue_USCOREgetMultiline *_p = ::soap_new__vbox__IStringFormValue_USCOREgetMultiline(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetMultiline::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStringFormValue_USCOREgetMultiline * soap_new_set__vbox__IStringFormValue_USCOREgetMultiline(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringFormValue_USCOREgetMultiline *_p = ::soap_new__vbox__IStringFormValue_USCOREgetMultiline(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringFormValue_USCOREgetMultiline::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, _vbox__IStringFormValue_USCOREgetMultiline const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultiline", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultiline ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultiline const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultiline", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultiline ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultiline const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultiline", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultiline ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultiline const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringFormValue_getMultiline", p->soap_type() == SOAP_TYPE__vbox__IStringFormValue_USCOREgetMultiline ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, _vbox__IStringFormValue_USCOREgetMultiline *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringFormValue_USCOREgetMultiline(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, const char *URL, _vbox__IStringFormValue_USCOREgetMultiline *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringFormValue_USCOREgetMultiline(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringFormValue_USCOREgetMultiline(struct soap *soap, _vbox__IStringFormValue_USCOREgetMultiline *p)
{
	if (::soap_read__vbox__IStringFormValue_USCOREgetMultiline(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse * soap_new__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse * soap_new_req__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse * soap_new_set__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREsetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREsetInteger * soap_new__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREsetInteger(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREsetInteger * soap_new_req__vbox__IRangedInteger64FormValue_USCOREsetInteger(
	struct soap *soap,
	const std::string& _USCOREthis,
	LONG64 value)
{
	_vbox__IRangedInteger64FormValue_USCOREsetInteger *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREsetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREsetInteger::_USCOREthis = _USCOREthis;
		_p->_vbox__IRangedInteger64FormValue_USCOREsetInteger::value = value;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREsetInteger * soap_new_set__vbox__IRangedInteger64FormValue_USCOREsetInteger(
	struct soap *soap,
	const std::string& _USCOREthis,
	LONG64 value)
{
	_vbox__IRangedInteger64FormValue_USCOREsetInteger *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREsetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREsetInteger::_USCOREthis = _USCOREthis;
		_p->_vbox__IRangedInteger64FormValue_USCOREsetInteger::value = value;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREsetInteger *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREsetInteger(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREsetInteger *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREsetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREsetInteger(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREsetInteger *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREsetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse * soap_new__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetInteger * soap_new__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetInteger(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetInteger * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetInteger(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetInteger *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetInteger::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetInteger * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetInteger(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetInteger *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetInteger::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetInteger *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetInteger(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetInteger *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetInteger(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetInteger *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse * soap_new__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMaximumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMaximum * soap_new__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetMaximum(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMaximum * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetMaximum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMaximum *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMaximum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMaximum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMaximum * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetMaximum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMaximum *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMaximum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMaximum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMaximum *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetMaximum(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMaximum *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMaximum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetMaximum(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMaximum *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMaximum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse * soap_new__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMinimumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMinimum * soap_new__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetMinimum(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMinimum * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetMinimum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMinimum *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMinimum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMinimum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetMinimum * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetMinimum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetMinimum *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetMinimum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetMinimum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMinimum *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetMinimum(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetMinimum *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMinimum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetMinimum(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetMinimum *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetMinimum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse * soap_new__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetSuffixResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetSuffix * soap_new__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedInteger64FormValue_USCOREgetSuffix(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetSuffix * soap_new_req__vbox__IRangedInteger64FormValue_USCOREgetSuffix(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetSuffix *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetSuffix(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetSuffix::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedInteger64FormValue_USCOREgetSuffix * soap_new_set__vbox__IRangedInteger64FormValue_USCOREgetSuffix(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedInteger64FormValue_USCOREgetSuffix *_p = ::soap_new__vbox__IRangedInteger64FormValue_USCOREgetSuffix(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedInteger64FormValue_USCOREgetSuffix::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedInteger64FormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedInteger64FormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetSuffix *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedInteger64FormValue_USCOREgetSuffix(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedInteger64FormValue_USCOREgetSuffix *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedInteger64FormValue_USCOREgetSuffix(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedInteger64FormValue_USCOREgetSuffix(struct soap *soap, _vbox__IRangedInteger64FormValue_USCOREgetSuffix *p)
{
	if (::soap_read__vbox__IRangedInteger64FormValue_USCOREgetSuffix(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse * soap_new__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse * soap_new_req__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse * soap_new_set__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREsetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREsetInteger * soap_new__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREsetInteger(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREsetInteger * soap_new_req__vbox__IRangedIntegerFormValue_USCOREsetInteger(
	struct soap *soap,
	const std::string& _USCOREthis,
	int value)
{
	_vbox__IRangedIntegerFormValue_USCOREsetInteger *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREsetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREsetInteger::_USCOREthis = _USCOREthis;
		_p->_vbox__IRangedIntegerFormValue_USCOREsetInteger::value = value;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREsetInteger * soap_new_set__vbox__IRangedIntegerFormValue_USCOREsetInteger(
	struct soap *soap,
	const std::string& _USCOREthis,
	int value)
{
	_vbox__IRangedIntegerFormValue_USCOREsetInteger *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREsetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREsetInteger::_USCOREthis = _USCOREthis;
		_p->_vbox__IRangedIntegerFormValue_USCOREsetInteger::value = value;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_setInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREsetInteger ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREsetInteger *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREsetInteger(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREsetInteger *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREsetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREsetInteger(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREsetInteger *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREsetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse * soap_new__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getIntegerResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetIntegerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetInteger * soap_new__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetInteger(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetInteger * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetInteger(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetInteger *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetInteger::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetInteger * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetInteger(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetInteger *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetInteger(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetInteger::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetInteger const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getInteger", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetInteger ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetInteger *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetInteger(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetInteger *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetInteger(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetInteger *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetInteger(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse * soap_new__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMaximumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMaximum * soap_new__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetMaximum(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMaximum * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetMaximum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMaximum *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMaximum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMaximum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMaximum * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetMaximum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMaximum *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMaximum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMaximum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximum const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMaximum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMaximum ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMaximum *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetMaximum(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMaximum *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMaximum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetMaximum(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMaximum *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMaximum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse * soap_new__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimumResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMinimumResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMinimum * soap_new__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetMinimum(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMinimum * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetMinimum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMinimum *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMinimum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMinimum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetMinimum * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetMinimum(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetMinimum *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetMinimum(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetMinimum::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimum const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getMinimum", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetMinimum ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMinimum *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetMinimum(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetMinimum *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMinimum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetMinimum(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetMinimum *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetMinimum(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse * soap_new__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffixResponse", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetSuffixResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetSuffix * soap_new__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IRangedIntegerFormValue_USCOREgetSuffix(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetSuffix * soap_new_req__vbox__IRangedIntegerFormValue_USCOREgetSuffix(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetSuffix *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetSuffix(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetSuffix::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IRangedIntegerFormValue_USCOREgetSuffix * soap_new_set__vbox__IRangedIntegerFormValue_USCOREgetSuffix(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IRangedIntegerFormValue_USCOREgetSuffix *_p = ::soap_new__vbox__IRangedIntegerFormValue_USCOREgetSuffix(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IRangedIntegerFormValue_USCOREgetSuffix::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffix const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IRangedIntegerFormValue_getSuffix", p->soap_type() == SOAP_TYPE__vbox__IRangedIntegerFormValue_USCOREgetSuffix ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetSuffix *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IRangedIntegerFormValue_USCOREgetSuffix(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, const char *URL, _vbox__IRangedIntegerFormValue_USCOREgetSuffix *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IRangedIntegerFormValue_USCOREgetSuffix(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IRangedIntegerFormValue_USCOREgetSuffix(struct soap *soap, _vbox__IRangedIntegerFormValue_USCOREgetSuffix *p)
{
	if (::soap_read__vbox__IRangedIntegerFormValue_USCOREgetSuffix(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREsetSelectedResponse * soap_new__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IBooleanFormValue_USCOREsetSelectedResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREsetSelectedResponse * soap_new_req__vbox__IBooleanFormValue_USCOREsetSelectedResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IBooleanFormValue_USCOREsetSelectedResponse *_p = ::soap_new__vbox__IBooleanFormValue_USCOREsetSelectedResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREsetSelectedResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREsetSelectedResponse * soap_new_set__vbox__IBooleanFormValue_USCOREsetSelectedResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IBooleanFormValue_USCOREsetSelectedResponse *_p = ::soap_new__vbox__IBooleanFormValue_USCOREsetSelectedResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREsetSelectedResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, _vbox__IBooleanFormValue_USCOREsetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelectedResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelectedResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelectedResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelectedResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, _vbox__IBooleanFormValue_USCOREsetSelectedResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IBooleanFormValue_USCOREsetSelectedResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelectedResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IBooleanFormValue_USCOREsetSelectedResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IBooleanFormValue_USCOREsetSelectedResponse(struct soap *soap, _vbox__IBooleanFormValue_USCOREsetSelectedResponse *p)
{
	if (::soap_read__vbox__IBooleanFormValue_USCOREsetSelectedResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREsetSelected * soap_new__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IBooleanFormValue_USCOREsetSelected(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREsetSelected * soap_new_req__vbox__IBooleanFormValue_USCOREsetSelected(
	struct soap *soap,
	const std::string& _USCOREthis,
	bool selected)
{
	_vbox__IBooleanFormValue_USCOREsetSelected *_p = ::soap_new__vbox__IBooleanFormValue_USCOREsetSelected(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREsetSelected::_USCOREthis = _USCOREthis;
		_p->_vbox__IBooleanFormValue_USCOREsetSelected::selected = selected;
	}
	return _p;
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREsetSelected * soap_new_set__vbox__IBooleanFormValue_USCOREsetSelected(
	struct soap *soap,
	const std::string& _USCOREthis,
	bool selected)
{
	_vbox__IBooleanFormValue_USCOREsetSelected *_p = ::soap_new__vbox__IBooleanFormValue_USCOREsetSelected(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREsetSelected::_USCOREthis = _USCOREthis;
		_p->_vbox__IBooleanFormValue_USCOREsetSelected::selected = selected;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, _vbox__IBooleanFormValue_USCOREsetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelected ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelected ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelected ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_setSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREsetSelected ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, _vbox__IBooleanFormValue_USCOREsetSelected *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IBooleanFormValue_USCOREsetSelected(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREsetSelected *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IBooleanFormValue_USCOREsetSelected(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IBooleanFormValue_USCOREsetSelected(struct soap *soap, _vbox__IBooleanFormValue_USCOREsetSelected *p)
{
	if (::soap_read__vbox__IBooleanFormValue_USCOREsetSelected(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREgetSelectedResponse * soap_new__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IBooleanFormValue_USCOREgetSelectedResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREgetSelectedResponse * soap_new_req__vbox__IBooleanFormValue_USCOREgetSelectedResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IBooleanFormValue_USCOREgetSelectedResponse *_p = ::soap_new__vbox__IBooleanFormValue_USCOREgetSelectedResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREgetSelectedResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREgetSelectedResponse * soap_new_set__vbox__IBooleanFormValue_USCOREgetSelectedResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IBooleanFormValue_USCOREgetSelectedResponse *_p = ::soap_new__vbox__IBooleanFormValue_USCOREgetSelectedResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREgetSelectedResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, _vbox__IBooleanFormValue_USCOREgetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelectedResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelectedResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelectedResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelectedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelectedResponse", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelectedResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, _vbox__IBooleanFormValue_USCOREgetSelectedResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IBooleanFormValue_USCOREgetSelectedResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelectedResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IBooleanFormValue_USCOREgetSelectedResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IBooleanFormValue_USCOREgetSelectedResponse(struct soap *soap, _vbox__IBooleanFormValue_USCOREgetSelectedResponse *p)
{
	if (::soap_read__vbox__IBooleanFormValue_USCOREgetSelectedResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREgetSelected * soap_new__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IBooleanFormValue_USCOREgetSelected(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREgetSelected * soap_new_req__vbox__IBooleanFormValue_USCOREgetSelected(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IBooleanFormValue_USCOREgetSelected *_p = ::soap_new__vbox__IBooleanFormValue_USCOREgetSelected(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREgetSelected::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IBooleanFormValue_USCOREgetSelected * soap_new_set__vbox__IBooleanFormValue_USCOREgetSelected(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IBooleanFormValue_USCOREgetSelected *_p = ::soap_new__vbox__IBooleanFormValue_USCOREgetSelected(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBooleanFormValue_USCOREgetSelected::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, _vbox__IBooleanFormValue_USCOREgetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelected ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelected ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelected ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelected const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBooleanFormValue_getSelected", p->soap_type() == SOAP_TYPE__vbox__IBooleanFormValue_USCOREgetSelected ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, _vbox__IBooleanFormValue_USCOREgetSelected *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IBooleanFormValue_USCOREgetSelected(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, const char *URL, _vbox__IBooleanFormValue_USCOREgetSelected *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IBooleanFormValue_USCOREgetSelected(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IBooleanFormValue_USCOREgetSelected(struct soap *soap, _vbox__IBooleanFormValue_USCOREgetSelected *p)
{
	if (::soap_read__vbox__IBooleanFormValue_USCOREgetSelected(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetHelpResponse * soap_new__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetHelpResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetHelpResponse * soap_new_req__vbox__IFormValue_USCOREgetHelpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IFormValue_USCOREgetHelpResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetHelpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetHelpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetHelpResponse * soap_new_set__vbox__IFormValue_USCOREgetHelpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IFormValue_USCOREgetHelpResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetHelpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetHelpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, _vbox__IFormValue_USCOREgetHelpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelpResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelpResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelpResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelpResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelpResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelpResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, _vbox__IFormValue_USCOREgetHelpResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetHelpResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelpResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetHelpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetHelpResponse(struct soap *soap, _vbox__IFormValue_USCOREgetHelpResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetHelpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetHelp * soap_new__vbox__IFormValue_USCOREgetHelp(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetHelp(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetHelp * soap_new_req__vbox__IFormValue_USCOREgetHelp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetHelp *_p = ::soap_new__vbox__IFormValue_USCOREgetHelp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetHelp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetHelp * soap_new_set__vbox__IFormValue_USCOREgetHelp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetHelp *_p = ::soap_new__vbox__IFormValue_USCOREgetHelp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetHelp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetHelp(struct soap *soap, _vbox__IFormValue_USCOREgetHelp const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelp", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelp ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetHelp(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelp const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelp", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetHelp(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelp const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelp", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetHelp(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelp const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getHelp", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetHelp ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetHelp(struct soap *soap, _vbox__IFormValue_USCOREgetHelp *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetHelp(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetHelp(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetHelp *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetHelp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetHelp(struct soap *soap, _vbox__IFormValue_USCOREgetHelp *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetHelp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetDescriptionResponse * soap_new__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetDescriptionResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetDescriptionResponse * soap_new_req__vbox__IFormValue_USCOREgetDescriptionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IFormValue_USCOREgetDescriptionResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetDescriptionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetDescriptionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetDescriptionResponse * soap_new_set__vbox__IFormValue_USCOREgetDescriptionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IFormValue_USCOREgetDescriptionResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetDescriptionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetDescriptionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, _vbox__IFormValue_USCOREgetDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescriptionResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescriptionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescriptionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescriptionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescriptionResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescriptionResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, _vbox__IFormValue_USCOREgetDescriptionResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetDescriptionResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescriptionResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetDescriptionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetDescriptionResponse(struct soap *soap, _vbox__IFormValue_USCOREgetDescriptionResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetDescriptionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetDescription * soap_new__vbox__IFormValue_USCOREgetDescription(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetDescription(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetDescription * soap_new_req__vbox__IFormValue_USCOREgetDescription(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetDescription *_p = ::soap_new__vbox__IFormValue_USCOREgetDescription(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetDescription::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetDescription * soap_new_set__vbox__IFormValue_USCOREgetDescription(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetDescription *_p = ::soap_new__vbox__IFormValue_USCOREgetDescription(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetDescription::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetDescription(struct soap *soap, _vbox__IFormValue_USCOREgetDescription const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescription", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescription ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetDescription(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescription const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescription", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescription ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetDescription(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescription const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescription", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescription ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetDescription(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescription const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getDescription", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetDescription ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetDescription(struct soap *soap, _vbox__IFormValue_USCOREgetDescription *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetDescription(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetDescription(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetDescription *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetDescription(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetDescription(struct soap *soap, _vbox__IFormValue_USCOREgetDescription *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetDescription(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetLabelResponse * soap_new__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetLabelResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetLabelResponse * soap_new_req__vbox__IFormValue_USCOREgetLabelResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IFormValue_USCOREgetLabelResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetLabelResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetLabelResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetLabelResponse * soap_new_set__vbox__IFormValue_USCOREgetLabelResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IFormValue_USCOREgetLabelResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetLabelResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetLabelResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, _vbox__IFormValue_USCOREgetLabelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabelResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabelResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabelResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabelResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabelResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabelResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabelResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabelResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, _vbox__IFormValue_USCOREgetLabelResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetLabelResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabelResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetLabelResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetLabelResponse(struct soap *soap, _vbox__IFormValue_USCOREgetLabelResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetLabelResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetLabel * soap_new__vbox__IFormValue_USCOREgetLabel(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetLabel(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetLabel * soap_new_req__vbox__IFormValue_USCOREgetLabel(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetLabel *_p = ::soap_new__vbox__IFormValue_USCOREgetLabel(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetLabel::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetLabel * soap_new_set__vbox__IFormValue_USCOREgetLabel(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetLabel *_p = ::soap_new__vbox__IFormValue_USCOREgetLabel(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetLabel::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetLabel(struct soap *soap, _vbox__IFormValue_USCOREgetLabel const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabel", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabel ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetLabel(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabel const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabel", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabel ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetLabel(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabel const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabel", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabel ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetLabel(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabel const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getLabel", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetLabel ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetLabel(struct soap *soap, _vbox__IFormValue_USCOREgetLabel *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetLabel(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetLabel(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetLabel *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetLabel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetLabel(struct soap *soap, _vbox__IFormValue_USCOREgetLabel *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetLabel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetVisibleResponse * soap_new__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetVisibleResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetVisibleResponse * soap_new_req__vbox__IFormValue_USCOREgetVisibleResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IFormValue_USCOREgetVisibleResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetVisibleResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetVisibleResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetVisibleResponse * soap_new_set__vbox__IFormValue_USCOREgetVisibleResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IFormValue_USCOREgetVisibleResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetVisibleResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetVisibleResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, _vbox__IFormValue_USCOREgetVisibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisibleResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisibleResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisibleResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisibleResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisibleResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisibleResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisibleResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisibleResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisibleResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, _vbox__IFormValue_USCOREgetVisibleResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetVisibleResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisibleResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetVisibleResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetVisibleResponse(struct soap *soap, _vbox__IFormValue_USCOREgetVisibleResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetVisibleResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetVisible * soap_new__vbox__IFormValue_USCOREgetVisible(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetVisible(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetVisible * soap_new_req__vbox__IFormValue_USCOREgetVisible(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetVisible *_p = ::soap_new__vbox__IFormValue_USCOREgetVisible(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetVisible::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetVisible * soap_new_set__vbox__IFormValue_USCOREgetVisible(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetVisible *_p = ::soap_new__vbox__IFormValue_USCOREgetVisible(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetVisible::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetVisible(struct soap *soap, _vbox__IFormValue_USCOREgetVisible const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisible", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisible ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetVisible(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisible const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisible", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisible ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetVisible(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisible const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisible", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisible ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetVisible(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisible const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getVisible", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetVisible ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetVisible(struct soap *soap, _vbox__IFormValue_USCOREgetVisible *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetVisible(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetVisible(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetVisible *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetVisible(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetVisible(struct soap *soap, _vbox__IFormValue_USCOREgetVisible *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetVisible(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetEnabledResponse * soap_new__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetEnabledResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetEnabledResponse * soap_new_req__vbox__IFormValue_USCOREgetEnabledResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IFormValue_USCOREgetEnabledResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetEnabledResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetEnabledResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetEnabledResponse * soap_new_set__vbox__IFormValue_USCOREgetEnabledResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IFormValue_USCOREgetEnabledResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetEnabledResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetEnabledResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, _vbox__IFormValue_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, _vbox__IFormValue_USCOREgetEnabledResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetEnabledResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabledResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetEnabledResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetEnabledResponse(struct soap *soap, _vbox__IFormValue_USCOREgetEnabledResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetEnabledResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetEnabled * soap_new__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetEnabled(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetEnabled * soap_new_req__vbox__IFormValue_USCOREgetEnabled(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetEnabled *_p = ::soap_new__vbox__IFormValue_USCOREgetEnabled(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetEnabled::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetEnabled * soap_new_set__vbox__IFormValue_USCOREgetEnabled(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetEnabled *_p = ::soap_new__vbox__IFormValue_USCOREgetEnabled(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetEnabled::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, _vbox__IFormValue_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabled", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabled", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabled", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getEnabled", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, _vbox__IFormValue_USCOREgetEnabled *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetEnabled(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetEnabled *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetEnabled(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetEnabled(struct soap *soap, _vbox__IFormValue_USCOREgetEnabled *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetEnabled(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetGenerationResponse * soap_new__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetGenerationResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetGenerationResponse * soap_new_req__vbox__IFormValue_USCOREgetGenerationResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IFormValue_USCOREgetGenerationResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetGenerationResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetGenerationResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetGenerationResponse * soap_new_set__vbox__IFormValue_USCOREgetGenerationResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IFormValue_USCOREgetGenerationResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetGenerationResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetGenerationResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, _vbox__IFormValue_USCOREgetGenerationResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGenerationResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGenerationResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGenerationResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGenerationResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGenerationResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGenerationResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGenerationResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGenerationResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGenerationResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGenerationResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGenerationResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, _vbox__IFormValue_USCOREgetGenerationResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetGenerationResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGenerationResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetGenerationResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetGenerationResponse(struct soap *soap, _vbox__IFormValue_USCOREgetGenerationResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetGenerationResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetGeneration * soap_new__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetGeneration(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetGeneration * soap_new_req__vbox__IFormValue_USCOREgetGeneration(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetGeneration *_p = ::soap_new__vbox__IFormValue_USCOREgetGeneration(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetGeneration::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetGeneration * soap_new_set__vbox__IFormValue_USCOREgetGeneration(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetGeneration *_p = ::soap_new__vbox__IFormValue_USCOREgetGeneration(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetGeneration::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, _vbox__IFormValue_USCOREgetGeneration const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGeneration", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGeneration ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGeneration const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGeneration", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGeneration ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGeneration const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGeneration", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGeneration ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGeneration const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getGeneration", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetGeneration ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, _vbox__IFormValue_USCOREgetGeneration *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetGeneration(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetGeneration *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetGeneration(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetGeneration(struct soap *soap, _vbox__IFormValue_USCOREgetGeneration *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetGeneration(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetTypeResponse * soap_new__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetTypeResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetTypeResponse * soap_new_req__vbox__IFormValue_USCOREgetTypeResponse(
	struct soap *soap,
	enum vbox__FormValueType returnval)
{
	_vbox__IFormValue_USCOREgetTypeResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetTypeResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetTypeResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetTypeResponse * soap_new_set__vbox__IFormValue_USCOREgetTypeResponse(
	struct soap *soap,
	enum vbox__FormValueType returnval)
{
	_vbox__IFormValue_USCOREgetTypeResponse *_p = ::soap_new__vbox__IFormValue_USCOREgetTypeResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetTypeResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, _vbox__IFormValue_USCOREgetTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetTypeResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetTypeResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetTypeResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetTypeResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, _vbox__IFormValue_USCOREgetTypeResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetTypeResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetTypeResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetTypeResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetTypeResponse(struct soap *soap, _vbox__IFormValue_USCOREgetTypeResponse *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetTypeResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IFormValue_USCOREgetType * soap_new__vbox__IFormValue_USCOREgetType(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IFormValue_USCOREgetType(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IFormValue_USCOREgetType * soap_new_req__vbox__IFormValue_USCOREgetType(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetType *_p = ::soap_new__vbox__IFormValue_USCOREgetType(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetType::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IFormValue_USCOREgetType * soap_new_set__vbox__IFormValue_USCOREgetType(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IFormValue_USCOREgetType *_p = ::soap_new__vbox__IFormValue_USCOREgetType(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IFormValue_USCOREgetType::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IFormValue_USCOREgetType(struct soap *soap, _vbox__IFormValue_USCOREgetType const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getType", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetType ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IFormValue_USCOREgetType(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getType", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetType ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IFormValue_USCOREgetType(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getType", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetType ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IFormValue_USCOREgetType(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IFormValue_getType", p->soap_type() == SOAP_TYPE__vbox__IFormValue_USCOREgetType ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IFormValue_USCOREgetType(struct soap *soap, _vbox__IFormValue_USCOREgetType *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IFormValue_USCOREgetType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IFormValue_USCOREgetType(struct soap *soap, const char *URL, _vbox__IFormValue_USCOREgetType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IFormValue_USCOREgetType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IFormValue_USCOREgetType(struct soap *soap, _vbox__IFormValue_USCOREgetType *p)
{
	if (::soap_read__vbox__IFormValue_USCOREgetType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringArray_USCOREgetValuesResponse * soap_new__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringArray_USCOREgetValuesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringArray_USCOREgetValuesResponse * soap_new_req__vbox__IStringArray_USCOREgetValuesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IStringArray_USCOREgetValuesResponse *_p = ::soap_new__vbox__IStringArray_USCOREgetValuesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringArray_USCOREgetValuesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStringArray_USCOREgetValuesResponse * soap_new_set__vbox__IStringArray_USCOREgetValuesResponse(
	struct soap *soap,
	const std::vector<std::string> & returnval)
{
	_vbox__IStringArray_USCOREgetValuesResponse *_p = ::soap_new__vbox__IStringArray_USCOREgetValuesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringArray_USCOREgetValuesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, _vbox__IStringArray_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValuesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValuesResponse", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValuesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, _vbox__IStringArray_USCOREgetValuesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringArray_USCOREgetValuesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValuesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringArray_USCOREgetValuesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringArray_USCOREgetValuesResponse(struct soap *soap, _vbox__IStringArray_USCOREgetValuesResponse *p)
{
	if (::soap_read__vbox__IStringArray_USCOREgetValuesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStringArray_USCOREgetValues * soap_new__vbox__IStringArray_USCOREgetValues(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStringArray_USCOREgetValues(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStringArray_USCOREgetValues * soap_new_req__vbox__IStringArray_USCOREgetValues(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringArray_USCOREgetValues *_p = ::soap_new__vbox__IStringArray_USCOREgetValues(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringArray_USCOREgetValues::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStringArray_USCOREgetValues * soap_new_set__vbox__IStringArray_USCOREgetValues(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStringArray_USCOREgetValues *_p = ::soap_new__vbox__IStringArray_USCOREgetValues(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStringArray_USCOREgetValues::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStringArray_USCOREgetValues(struct soap *soap, _vbox__IStringArray_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValues", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValues ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStringArray_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValues", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValues ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStringArray_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValues", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValues ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStringArray_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValues const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStringArray_getValues", p->soap_type() == SOAP_TYPE__vbox__IStringArray_USCOREgetValues ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStringArray_USCOREgetValues(struct soap *soap, _vbox__IStringArray_USCOREgetValues *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStringArray_USCOREgetValues(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStringArray_USCOREgetValues(struct soap *soap, const char *URL, _vbox__IStringArray_USCOREgetValues *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStringArray_USCOREgetValues(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStringArray_USCOREgetValues(struct soap *soap, _vbox__IStringArray_USCOREgetValues *p)
{
	if (::soap_read__vbox__IStringArray_USCOREgetValues(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse * soap_new__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse * soap_new_req__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse *_p = ::soap_new__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse * soap_new_set__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse *_p = ::soap_new__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummyResponse", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummyResponse", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummyResponse", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummyResponse", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(struct soap *soap, _vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse *p)
{
	if (::soap_read__vbox__IMachineGroupsChangedEvent_USCOREgetDummyResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IMachineGroupsChangedEvent_USCOREgetDummy * soap_new__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IMachineGroupsChangedEvent_USCOREgetDummy * soap_new_req__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IMachineGroupsChangedEvent_USCOREgetDummy *_p = ::soap_new__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IMachineGroupsChangedEvent_USCOREgetDummy::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IMachineGroupsChangedEvent_USCOREgetDummy * soap_new_set__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IMachineGroupsChangedEvent_USCOREgetDummy *_p = ::soap_new__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IMachineGroupsChangedEvent_USCOREgetDummy::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummy", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummy ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummy", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummy ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummy", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummy ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IMachineGroupsChangedEvent_getDummy", p->soap_type() == SOAP_TYPE__vbox__IMachineGroupsChangedEvent_USCOREgetDummy ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, const char *URL, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(struct soap *soap, _vbox__IMachineGroupsChangedEvent_USCOREgetDummy *p)
{
	if (::soap_read__vbox__IMachineGroupsChangedEvent_USCOREgetDummy(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse * soap_new__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse * soap_new_req__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse *_p = ::soap_new__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse * soap_new_set__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse *_p = ::soap_new__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControlResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControlResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControlResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControlResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(struct soap *soap, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse *p)
{
	if (::soap_read__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControlResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl * soap_new__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl * soap_new_req__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl *_p = ::soap_new__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl * soap_new_set__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl *_p = ::soap_new__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControl", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControl", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControl", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestDebugControlChangedEvent_getGuestDebugControl", p->soap_type() == SOAP_TYPE__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, const char *URL, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(struct soap *soap, _vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl *p)
{
	if (::soap_read__vbox__IGuestDebugControlChangedEvent_USCOREgetGuestDebugControl(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse * soap_new__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse * soap_new_req__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(
	struct soap *soap,
	enum vbox__UpdateState returnval)
{
	_vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse *_p = ::soap_new__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse * soap_new_set__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(
	struct soap *soap,
	enum vbox__UpdateState returnval)
{
	_vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse *_p = ::soap_new__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(struct soap *soap, _vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentStateChangedEvent_USCOREgetStateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentStateChangedEvent_USCOREgetState * soap_new__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentStateChangedEvent_USCOREgetState * soap_new_req__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentStateChangedEvent_USCOREgetState *_p = ::soap_new__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentStateChangedEvent_USCOREgetState::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentStateChangedEvent_USCOREgetState * soap_new_set__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentStateChangedEvent_USCOREgetState *_p = ::soap_new__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentStateChangedEvent_USCOREgetState::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(struct soap *soap, _vbox__IUpdateAgentStateChangedEvent_USCOREgetState *p)
{
	if (::soap_read__vbox__IUpdateAgentStateChangedEvent_USCOREgetState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotesResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotesResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotesResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotesResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotes", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotes", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotes", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getReleaseNotes", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetReleaseNotes(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURLResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getWebURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetWebURL(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURLResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURLResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getDownloadURL", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetDownloadURL(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(
	struct soap *soap,
	enum vbox__UpdateSeverity returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(
	struct soap *soap,
	enum vbox__UpdateSeverity returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverityResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverityResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverityResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverityResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverityResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverity", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverity", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverity", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getSeverity", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetSeverity(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(
	struct soap *soap,
	enum vbox__UpdateChannel returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(
	struct soap *soap,
	enum vbox__UpdateChannel returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannelResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannelResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannelResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannelResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetChannelResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetChannel *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetChannel::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetChannel *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetChannel::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannel", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannel", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannel", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getChannel", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetChannel *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetChannel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersionResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersionResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersionResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersionResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetVersionResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion * soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion * soap_new_req__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetVersion *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetVersion::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion * soap_new_set__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentAvailableEvent_USCOREgetVersion *_p = ::soap_new__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentAvailableEvent_USCOREgetVersion::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersion", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersion", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersion", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentAvailableEvent_getVersion", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, const char *URL, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(struct soap *soap, _vbox__IUpdateAgentAvailableEvent_USCOREgetVersion *p)
{
	if (::soap_read__vbox__IUpdateAgentAvailableEvent_USCOREgetVersion(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse * soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse * soap_new_req__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse * soap_new_set__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcErrorResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcErrorResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcErrorResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcErrorResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetRcErrorResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetRcError * soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetRcError * soap_new_req__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetRcError *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetRcError::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetRcError * soap_new_set__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetRcError *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetRcError::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcError", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcError ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcError", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcError ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcError", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcError ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getRcError", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetRcError ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetRcError *p)
{
	if (::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetRcError(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse * soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse * soap_new_req__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse * soap_new_set__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsgResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsgResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsgResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsgResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetMsgResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetMsg * soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetMsg * soap_new_req__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetMsg *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetMsg::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentErrorEvent_USCOREgetMsg * soap_new_set__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentErrorEvent_USCOREgetMsg *_p = ::soap_new__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentErrorEvent_USCOREgetMsg::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsg", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsg ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsg", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsg ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsg", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsg ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentErrorEvent_getMsg", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentErrorEvent_USCOREgetMsg ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, const char *URL, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(struct soap *soap, _vbox__IUpdateAgentErrorEvent_USCOREgetMsg *p)
{
	if (::soap_read__vbox__IUpdateAgentErrorEvent_USCOREgetMsg(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse * soap_new__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse * soap_new_req__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse *_p = ::soap_new__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse * soap_new_set__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse *_p = ::soap_new__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHintResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHintResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHintResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHintResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(struct soap *soap, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHintResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint * soap_new__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint * soap_new_req__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint *_p = ::soap_new__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint * soap_new_set__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint *_p = ::soap_new__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHint", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHint", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHint", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentSettingsChangedEvent_getAttributeHint", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, const char *URL, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(struct soap *soap, _vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint *p)
{
	if (::soap_read__vbox__IUpdateAgentSettingsChangedEvent_USCOREgetAttributeHint(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentEvent_USCOREgetAgentResponse * soap_new__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentEvent_USCOREgetAgentResponse * soap_new_req__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentEvent_USCOREgetAgentResponse *_p = ::soap_new__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentEvent_USCOREgetAgentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentEvent_USCOREgetAgentResponse * soap_new_set__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IUpdateAgentEvent_USCOREgetAgentResponse *_p = ::soap_new__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentEvent_USCOREgetAgentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgentResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgentResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgentResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgentResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgentResponse", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgentResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(struct soap *soap, _vbox__IUpdateAgentEvent_USCOREgetAgentResponse *p)
{
	if (::soap_read__vbox__IUpdateAgentEvent_USCOREgetAgentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IUpdateAgentEvent_USCOREgetAgent * soap_new__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IUpdateAgentEvent_USCOREgetAgent(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IUpdateAgentEvent_USCOREgetAgent * soap_new_req__vbox__IUpdateAgentEvent_USCOREgetAgent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentEvent_USCOREgetAgent *_p = ::soap_new__vbox__IUpdateAgentEvent_USCOREgetAgent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentEvent_USCOREgetAgent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IUpdateAgentEvent_USCOREgetAgent * soap_new_set__vbox__IUpdateAgentEvent_USCOREgetAgent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IUpdateAgentEvent_USCOREgetAgent *_p = ::soap_new__vbox__IUpdateAgentEvent_USCOREgetAgent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IUpdateAgentEvent_USCOREgetAgent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, _vbox__IUpdateAgentEvent_USCOREgetAgent const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgent", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgent ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgent const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgent", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgent const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgent", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgent const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IUpdateAgentEvent_getAgent", p->soap_type() == SOAP_TYPE__vbox__IUpdateAgentEvent_USCOREgetAgent ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, _vbox__IUpdateAgentEvent_USCOREgetAgent *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IUpdateAgentEvent_USCOREgetAgent(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, const char *URL, _vbox__IUpdateAgentEvent_USCOREgetAgent *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IUpdateAgentEvent_USCOREgetAgent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IUpdateAgentEvent_USCOREgetAgent(struct soap *soap, _vbox__IUpdateAgentEvent_USCOREgetAgent *p)
{
	if (::soap_read__vbox__IUpdateAgentEvent_USCOREgetAgent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse * soap_new__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse * soap_new_req__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse *_p = ::soap_new__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse * soap_new_set__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse *_p = ::soap_new__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutputResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutputResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutputResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutputResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(struct soap *soap, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutputResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput * soap_new__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput * soap_new_req__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput *_p = ::soap_new__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput * soap_new_set__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput *_p = ::soap_new__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutput", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutput", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutput", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorInfoChangedEvent_getOutput", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, const char *URL, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(struct soap *soap, _vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput *p)
{
	if (::soap_read__vbox__IGuestMonitorInfoChangedEvent_USCOREgetOutput(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(
	struct soap *soap,
	LONG64 returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestampResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestampResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestampResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestampResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestampResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestamp", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestamp", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestamp", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getTimestamp", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetTimestamp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(
	struct soap *soap,
	enum vbox__AdditionsRunLevelType returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(
	struct soap *soap,
	enum vbox__AdditionsRunLevelType returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevelResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevelResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevelResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevelResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevelResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevel", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevel", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevel", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getRunLevel", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetRunLevel(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(
	struct soap *soap,
	enum vbox__AdditionsFacilityStatus returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(
	struct soap *soap,
	enum vbox__AdditionsFacilityStatus returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatusResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatusResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatusResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatusResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatusResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatus", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatus", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatus", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getStatus", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetStatus(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(
	struct soap *soap,
	enum vbox__AdditionsFacilityType returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(
	struct soap *soap,
	enum vbox__AdditionsFacilityType returnval)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacilityResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacilityResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacilityResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacilityResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacilityResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility * soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility * soap_new_req__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility * soap_new_set__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility *_p = ::soap_new__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacility", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacility", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacility", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestAdditionsStatusChangedEvent_getFacility", p->soap_type() == SOAP_TYPE__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, const char *URL, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(struct soap *soap, _vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility *p)
{
	if (::soap_read__vbox__IGuestAdditionsStatusChangedEvent_USCOREgetFacility(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetYResponse * soap_new__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetYResponse * soap_new_req__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetYResponse *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetYResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetYResponse * soap_new_set__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetYResponse *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetYResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getYResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetYResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getYResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetYResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getYResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetYResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getYResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetYResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetYResponse *p)
{
	if (::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetYResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetY * soap_new__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICursorPositionChangedEvent_USCOREgetY(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetY * soap_new_req__vbox__ICursorPositionChangedEvent_USCOREgetY(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetY *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetY(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetY::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetY * soap_new_set__vbox__ICursorPositionChangedEvent_USCOREgetY(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetY *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetY(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetY::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetY const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getY", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetY ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetY const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getY", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetY ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetY const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getY", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetY ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetY const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getY", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetY ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetY *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICursorPositionChangedEvent_USCOREgetY(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetY *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetY(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICursorPositionChangedEvent_USCOREgetY(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetY *p)
{
	if (::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetY(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetXResponse * soap_new__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetXResponse * soap_new_req__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetXResponse *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetXResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetXResponse * soap_new_set__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetXResponse *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetXResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getXResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetXResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getXResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetXResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getXResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetXResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getXResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetXResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetXResponse *p)
{
	if (::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetXResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetX * soap_new__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICursorPositionChangedEvent_USCOREgetX(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetX * soap_new_req__vbox__ICursorPositionChangedEvent_USCOREgetX(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetX *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetX(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetX::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetX * soap_new_set__vbox__ICursorPositionChangedEvent_USCOREgetX(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetX *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetX(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetX::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetX const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getX", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetX ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetX const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getX", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetX ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetX const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getX", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetX ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetX const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getX", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetX ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetX *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICursorPositionChangedEvent_USCOREgetX(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetX *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetX(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICursorPositionChangedEvent_USCOREgetX(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetX *p)
{
	if (::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetX(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse * soap_new__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse * soap_new_req__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse * soap_new_set__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasDataResponse", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse *p)
{
	if (::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetHasDataResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetHasData * soap_new__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__ICursorPositionChangedEvent_USCOREgetHasData(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetHasData * soap_new_req__vbox__ICursorPositionChangedEvent_USCOREgetHasData(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetHasData *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetHasData(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetHasData::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__ICursorPositionChangedEvent_USCOREgetHasData * soap_new_set__vbox__ICursorPositionChangedEvent_USCOREgetHasData(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__ICursorPositionChangedEvent_USCOREgetHasData *_p = ::soap_new__vbox__ICursorPositionChangedEvent_USCOREgetHasData(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__ICursorPositionChangedEvent_USCOREgetHasData::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetHasData const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasData", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasData ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasData const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasData", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasData ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasData const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasData", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasData ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasData const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:ICursorPositionChangedEvent_getHasData", p->soap_type() == SOAP_TYPE__vbox__ICursorPositionChangedEvent_USCOREgetHasData ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetHasData *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__ICursorPositionChangedEvent_USCOREgetHasData(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, const char *URL, _vbox__ICursorPositionChangedEvent_USCOREgetHasData *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetHasData(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__ICursorPositionChangedEvent_USCOREgetHasData(struct soap *soap, _vbox__ICursorPositionChangedEvent_USCOREgetHasData *p)
{
	if (::soap_read__vbox__ICursorPositionChangedEvent_USCOREgetHasData(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new_req__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *_p = ::soap_new__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new_set__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *_p = ::soap_new__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (::soap_read__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new_req__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *_p = ::soap_new__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new_set__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *_p = ::soap_new__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressTaskCompletedEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (::soap_read__vbox__IProgressTaskCompletedEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse * soap_new__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse * soap_new_req__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse *_p = ::soap_new__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse * soap_new_set__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse *_p = ::soap_new__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercentResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercentResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercentResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercentResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(struct soap *soap, _vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse *p)
{
	if (::soap_read__vbox__IProgressPercentageChangedEvent_USCOREgetPercentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressPercentageChangedEvent_USCOREgetPercent * soap_new__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressPercentageChangedEvent_USCOREgetPercent * soap_new_req__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressPercentageChangedEvent_USCOREgetPercent *_p = ::soap_new__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressPercentageChangedEvent_USCOREgetPercent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressPercentageChangedEvent_USCOREgetPercent * soap_new_set__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressPercentageChangedEvent_USCOREgetPercent *_p = ::soap_new__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressPercentageChangedEvent_USCOREgetPercent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercent", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercent ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercent", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercent", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressPercentageChangedEvent_getPercent", p->soap_type() == SOAP_TYPE__vbox__IProgressPercentageChangedEvent_USCOREgetPercent ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, const char *URL, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(struct soap *soap, _vbox__IProgressPercentageChangedEvent_USCOREgetPercent *p)
{
	if (::soap_read__vbox__IProgressPercentageChangedEvent_USCOREgetPercent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressCreatedEvent_USCOREgetCreateResponse * soap_new__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressCreatedEvent_USCOREgetCreateResponse * soap_new_req__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IProgressCreatedEvent_USCOREgetCreateResponse *_p = ::soap_new__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressCreatedEvent_USCOREgetCreateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressCreatedEvent_USCOREgetCreateResponse * soap_new_set__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IProgressCreatedEvent_USCOREgetCreateResponse *_p = ::soap_new__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressCreatedEvent_USCOREgetCreateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(struct soap *soap, _vbox__IProgressCreatedEvent_USCOREgetCreateResponse *p)
{
	if (::soap_read__vbox__IProgressCreatedEvent_USCOREgetCreateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressCreatedEvent_USCOREgetCreate * soap_new__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressCreatedEvent_USCOREgetCreate(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressCreatedEvent_USCOREgetCreate * soap_new_req__vbox__IProgressCreatedEvent_USCOREgetCreate(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressCreatedEvent_USCOREgetCreate *_p = ::soap_new__vbox__IProgressCreatedEvent_USCOREgetCreate(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressCreatedEvent_USCOREgetCreate::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressCreatedEvent_USCOREgetCreate * soap_new_set__vbox__IProgressCreatedEvent_USCOREgetCreate(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressCreatedEvent_USCOREgetCreate *_p = ::soap_new__vbox__IProgressCreatedEvent_USCOREgetCreate(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressCreatedEvent_USCOREgetCreate::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, _vbox__IProgressCreatedEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressCreatedEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__IProgressCreatedEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, _vbox__IProgressCreatedEvent_USCOREgetCreate *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressCreatedEvent_USCOREgetCreate(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__IProgressCreatedEvent_USCOREgetCreate *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressCreatedEvent_USCOREgetCreate(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressCreatedEvent_USCOREgetCreate(struct soap *soap, _vbox__IProgressCreatedEvent_USCOREgetCreate *p)
{
	if (::soap_read__vbox__IProgressCreatedEvent_USCOREgetCreate(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressEvent_USCOREgetProgressIdResponse * soap_new__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressEvent_USCOREgetProgressIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressEvent_USCOREgetProgressIdResponse * soap_new_req__vbox__IProgressEvent_USCOREgetProgressIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IProgressEvent_USCOREgetProgressIdResponse *_p = ::soap_new__vbox__IProgressEvent_USCOREgetProgressIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressEvent_USCOREgetProgressIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressEvent_USCOREgetProgressIdResponse * soap_new_set__vbox__IProgressEvent_USCOREgetProgressIdResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IProgressEvent_USCOREgetProgressIdResponse *_p = ::soap_new__vbox__IProgressEvent_USCOREgetProgressIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressEvent_USCOREgetProgressIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, _vbox__IProgressEvent_USCOREgetProgressIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressIdResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressIdResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressIdResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressIdResponse", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, _vbox__IProgressEvent_USCOREgetProgressIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressEvent_USCOREgetProgressIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressEvent_USCOREgetProgressIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressEvent_USCOREgetProgressIdResponse(struct soap *soap, _vbox__IProgressEvent_USCOREgetProgressIdResponse *p)
{
	if (::soap_read__vbox__IProgressEvent_USCOREgetProgressIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IProgressEvent_USCOREgetProgressId * soap_new__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IProgressEvent_USCOREgetProgressId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IProgressEvent_USCOREgetProgressId * soap_new_req__vbox__IProgressEvent_USCOREgetProgressId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressEvent_USCOREgetProgressId *_p = ::soap_new__vbox__IProgressEvent_USCOREgetProgressId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressEvent_USCOREgetProgressId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IProgressEvent_USCOREgetProgressId * soap_new_set__vbox__IProgressEvent_USCOREgetProgressId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IProgressEvent_USCOREgetProgressId *_p = ::soap_new__vbox__IProgressEvent_USCOREgetProgressId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IProgressEvent_USCOREgetProgressId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, _vbox__IProgressEvent_USCOREgetProgressId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressId", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressId", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressId", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IProgressEvent_getProgressId", p->soap_type() == SOAP_TYPE__vbox__IProgressEvent_USCOREgetProgressId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, _vbox__IProgressEvent_USCOREgetProgressId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IProgressEvent_USCOREgetProgressId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, const char *URL, _vbox__IProgressEvent_USCOREgetProgressId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IProgressEvent_USCOREgetProgressId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IProgressEvent_USCOREgetProgressId(struct soap *soap, _vbox__IProgressEvent_USCOREgetProgressId *p)
{
	if (::soap_read__vbox__IProgressEvent_USCOREgetProgressId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new_req__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *_p = ::soap_new__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new_set__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *_p = ::soap_new__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (::soap_read__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new_req__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *_p = ::soap_new__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new_set__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *_p = ::soap_new__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IHostNameResolutionConfigurationChangeEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (::soap_read__vbox__IHostNameResolutionConfigurationChangeEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPortResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestPort(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getGuestIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetGuestIp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(
	struct soap *soap,
	int returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPortResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostPortResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostPort *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostPort::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostPort *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostPort::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostPort", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostPort *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostPort(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIpResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostIpResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostIp *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostIp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetHostIp *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetHostIp::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getHostIp", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetHostIp *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetHostIp(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(
	struct soap *soap,
	enum vbox__NATProtocol returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(
	struct soap *soap,
	enum vbox__NATProtocol returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProtoResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProtoResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProtoResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProtoResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetProtoResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetProto * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetProto(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetProto * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetProto(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetProto *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetProto(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetProto::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetProto * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetProto(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetProto *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetProto(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetProto::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetProto const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProto", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProto ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProto const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProto", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProto ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProto const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProto", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProto ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProto const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getProto", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetProto ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetProto *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetProto(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetProto *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetProto(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetProto(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetProto *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetProto(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetName * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetName * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetName *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetName * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetName *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetName(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetName *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6Response", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6Response", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6Response", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6Response", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6Response(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetIpv6::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getIpv6", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetIpv6 *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetIpv6(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreateResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetCreateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetCreate * soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetCreate * soap_new_req__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetCreate *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetCreate::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkPortForwardEvent_USCOREgetCreate * soap_new_set__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkPortForwardEvent_USCOREgetCreate *_p = ::soap_new__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkPortForwardEvent_USCOREgetCreate::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkPortForwardEvent_getCreate", p->soap_type() == SOAP_TYPE__vbox__INATNetworkPortForwardEvent_USCOREgetCreate ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, const char *URL, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(struct soap *soap, _vbox__INATNetworkPortForwardEvent_USCOREgetCreate *p)
{
	if (::soap_read__vbox__INATNetworkPortForwardEvent_USCOREgetCreate(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse * soap_new__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServerResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServerResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServerResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServerResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServerResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer * soap_new__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServer", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServer", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServer", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNeedDhcpServer", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNeedDhcpServer(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse * soap_new__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabledResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled * soap_new__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getAdvertiseDefaultIPv6RouteEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetAdvertiseDefaultIPv6RouteEnabled(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse * soap_new__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGatewayResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetGatewayResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetGateway * soap_new__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetGateway(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetGateway * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetGateway(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetGateway *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetGateway(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetGateway::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetGateway * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetGateway(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetGateway *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetGateway(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetGateway::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetGateway const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGateway", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGateway ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGateway const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGateway", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGateway ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGateway const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGateway", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGateway ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGateway const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getGateway", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetGateway ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetGateway *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetGateway(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetGateway *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetGateway(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetGateway(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetGateway *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetGateway(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse * soap_new__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetworkResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetworkResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetworkResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetworkResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNetworkResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNetwork * soap_new__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetNetwork(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNetwork * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetNetwork(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNetwork *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNetwork(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNetwork::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetNetwork * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetNetwork(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetNetwork *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetNetwork(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetNetwork::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNetwork const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetwork", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetwork ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetwork const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetwork", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetwork ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetwork const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetwork", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetwork ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetwork const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getNetwork", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetNetwork ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNetwork *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetNetwork(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetNetwork *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNetwork(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetNetwork(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetNetwork *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetNetwork(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse * soap_new__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabledResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetEnabledResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetEnabled * soap_new__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkSettingEvent_USCOREgetEnabled(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetEnabled * soap_new_req__vbox__INATNetworkSettingEvent_USCOREgetEnabled(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetEnabled *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetEnabled(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetEnabled::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkSettingEvent_USCOREgetEnabled * soap_new_set__vbox__INATNetworkSettingEvent_USCOREgetEnabled(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkSettingEvent_USCOREgetEnabled *_p = ::soap_new__vbox__INATNetworkSettingEvent_USCOREgetEnabled(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkSettingEvent_USCOREgetEnabled::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabled const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkSettingEvent_getEnabled", p->soap_type() == SOAP_TYPE__vbox__INATNetworkSettingEvent_USCOREgetEnabled ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetEnabled *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkSettingEvent_USCOREgetEnabled(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, const char *URL, _vbox__INATNetworkSettingEvent_USCOREgetEnabled *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkSettingEvent_USCOREgetEnabled(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkSettingEvent_USCOREgetEnabled(struct soap *soap, _vbox__INATNetworkSettingEvent_USCOREgetEnabled *p)
{
	if (::soap_read__vbox__INATNetworkSettingEvent_USCOREgetEnabled(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse * soap_new__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse * soap_new_req__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse *_p = ::soap_new__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse * soap_new_set__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse *_p = ::soap_new__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(struct soap *soap, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse *p)
{
	if (::soap_read__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEventResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent * soap_new__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent * soap_new_req__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent *_p = ::soap_new__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent * soap_new_set__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent *_p = ::soap_new__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkCreationDeletionEvent_getCreationEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, const char *URL, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(struct soap *soap, _vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent *p)
{
	if (::soap_read__vbox__INATNetworkCreationDeletionEvent_USCOREgetCreationEvent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new_req__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *_p = ::soap_new__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse * soap_new_set__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *_p = ::soap_new__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfacesResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(struct soap *soap, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse *p)
{
	if (::soap_read__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfacesResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new_req__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *_p = ::soap_new__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces * soap_new_set__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *_p = ::soap_new__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkAlterEvent_getMidlDoesNotLikeEmptyInterfaces", p->soap_type() == SOAP_TYPE__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, const char *URL, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(struct soap *soap, _vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces *p)
{
	if (::soap_read__vbox__INATNetworkAlterEvent_USCOREgetMidlDoesNotLikeEmptyInterfaces(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse * soap_new__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse * soap_new_req__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse *_p = ::soap_new__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse * soap_new_set__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse *_p = ::soap_new__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEventResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(struct soap *soap, _vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse *p)
{
	if (::soap_read__vbox__INATNetworkStartStopEvent_USCOREgetStartEventResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent * soap_new__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent * soap_new_req__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkStartStopEvent_USCOREgetStartEvent *_p = ::soap_new__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkStartStopEvent_USCOREgetStartEvent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent * soap_new_set__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkStartStopEvent_USCOREgetStartEvent *_p = ::soap_new__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkStartStopEvent_USCOREgetStartEvent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkStartStopEvent_getStartEvent", p->soap_type() == SOAP_TYPE__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, const char *URL, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(struct soap *soap, _vbox__INATNetworkStartStopEvent_USCOREgetStartEvent *p)
{
	if (::soap_read__vbox__INATNetworkStartStopEvent_USCOREgetStartEvent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse * soap_new__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse * soap_new_req__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse *_p = ::soap_new__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse * soap_new_set__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse *_p = ::soap_new__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkNameResponse", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(struct soap *soap, _vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse *p)
{
	if (::soap_read__vbox__INATNetworkChangedEvent_USCOREgetNetworkNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__INATNetworkChangedEvent_USCOREgetNetworkName * soap_new__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__INATNetworkChangedEvent_USCOREgetNetworkName * soap_new_req__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkChangedEvent_USCOREgetNetworkName *_p = ::soap_new__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkChangedEvent_USCOREgetNetworkName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__INATNetworkChangedEvent_USCOREgetNetworkName * soap_new_set__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__INATNetworkChangedEvent_USCOREgetNetworkName *_p = ::soap_new__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__INATNetworkChangedEvent_USCOREgetNetworkName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:INATNetworkChangedEvent_getNetworkName", p->soap_type() == SOAP_TYPE__vbox__INATNetworkChangedEvent_USCOREgetNetworkName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, const char *URL, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(struct soap *soap, _vbox__INATNetworkChangedEvent_USCOREgetNetworkName *p)
{
	if (::soap_read__vbox__INATNetworkChangedEvent_USCOREgetNetworkName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse * soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse * soap_new_req__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse * soap_new_set__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilentResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilentResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilentResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilentResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse *p)
{
	if (::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetSilentResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetSilent * soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetSilent * soap_new_req__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetSilent *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetSilent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetSilent * soap_new_set__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetSilent *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetSilent::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilent", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilent ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilent", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilent", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilent ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getSilent", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetSilent ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetSilent *p)
{
	if (::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetSilent(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse * soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse * soap_new_req__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse * soap_new_set__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemovedResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemovedResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemovedResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemovedResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse *p)
{
	if (::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetRemovedResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved * soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved * soap_new_req__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetRemoved *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetRemoved::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved * soap_new_set__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetRemoved *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetRemoved::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemoved", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemoved", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemoved", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getRemoved", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetRemoved *p)
{
	if (::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetRemoved(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse * soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse * soap_new_req__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(
	struct soap *soap,
	vbox__IMediumAttachment *returnval)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse * soap_new_set__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(
	struct soap *soap,
	vbox__IMediumAttachment *returnval)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDeviceResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDeviceResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDeviceResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDeviceResponse", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse *p)
{
	if (::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDeviceResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice * soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice * soap_new_req__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice * soap_new_set__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice *_p = ::soap_new__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDevice", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDevice", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDevice", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IStorageDeviceChangedEvent_getStorageDevice", p->soap_type() == SOAP_TYPE__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, const char *URL, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(struct soap *soap, _vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice *p)
{
	if (::soap_read__vbox__IStorageDeviceChangedEvent_USCOREgetStorageDevice(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetailsResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetailsResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetailsResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetailsResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetailsResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetails", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetails", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetails", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateDetails", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateDetails(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(
	struct soap *soap,
	enum vbox__GuestUserState returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(
	struct soap *soap,
	enum vbox__GuestUserState returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getStateResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetStateResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetState * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetState(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetState * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetState(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetState *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetState(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetState::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetState * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetState(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetState *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetState(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetState::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetState const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getState", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetState ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetState *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetState(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetState *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetState(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetState *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetState(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomainResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomainResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomainResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomainResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetDomainResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetDomain * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetDomain * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetDomain *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetDomain::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetDomain * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetDomain *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetDomain::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomain", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomain ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomain", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomain ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomain", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomain ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getDomain", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetDomain ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetDomain *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetDomain(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getNameResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetNameResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetName * soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestUserStateChangedEvent_USCOREgetName(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetName * soap_new_req__vbox__IGuestUserStateChangedEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetName *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestUserStateChangedEvent_USCOREgetName * soap_new_set__vbox__IGuestUserStateChangedEvent_USCOREgetName(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestUserStateChangedEvent_USCOREgetName *_p = ::soap_new__vbox__IGuestUserStateChangedEvent_USCOREgetName(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestUserStateChangedEvent_USCOREgetName::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetName const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestUserStateChangedEvent_getName", p->soap_type() == SOAP_TYPE__vbox__IGuestUserStateChangedEvent_USCOREgetName ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetName *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestUserStateChangedEvent_USCOREgetName(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, const char *URL, _vbox__IGuestUserStateChangedEvent_USCOREgetName *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestUserStateChangedEvent_USCOREgetName(struct soap *soap, _vbox__IGuestUserStateChangedEvent_USCOREgetName *p)
{
	if (::soap_read__vbox__IGuestUserStateChangedEvent_USCOREgetName(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeightResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeightResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeightResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeightResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetHeightResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetHeight * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetHeight * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetHeight *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetHeight::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetHeight * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetHeight *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetHeight::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeight", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeight ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeight", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeight ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeight", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeight ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getHeight", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetHeight ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetHeight *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetHeight(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidthResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidthResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidthResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidthResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetWidthResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetWidth * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetWidth * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetWidth *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetWidth::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetWidth * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetWidth *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetWidth::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidth", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidth ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidth", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidth ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidth", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidth ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getWidth", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetWidth ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetWidth *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetWidth(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginYResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginYResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginYResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginYResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginYResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginY *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginY::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginY *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginY::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginY", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginY", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginY", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginY", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginY *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginY(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginXResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginXResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginXResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginXResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginXResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginX *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginX::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetOriginX *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetOriginX::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginX", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginX", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginX", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getOriginX", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetOriginX *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetOriginX(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(
	struct soap *soap,
	unsigned int returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenIdResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenIdResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenIdResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenIdResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetScreenIdResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetScreenId *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetScreenId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetScreenId *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetScreenId::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenId", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenId", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenId", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getScreenId", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetScreenId *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetScreenId(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(
	struct soap *soap,
	enum vbox__GuestMonitorChangedEventType returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(
	struct soap *soap,
	enum vbox__GuestMonitorChangedEventType returnval)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeTypeResponse", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetChangeTypeResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType * soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType * soap_new_req__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetChangeType *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetChangeType::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType * soap_new_set__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IGuestMonitorChangedEvent_USCOREgetChangeType *_p = ::soap_new__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IGuestMonitorChangedEvent_USCOREgetChangeType::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeType", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeType", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeType", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IGuestMonitorChangedEvent_getChangeType", p->soap_type() == SOAP_TYPE__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, const char *URL, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(struct soap *soap, _vbox__IGuestMonitorChangedEvent_USCOREgetChangeType *p)
{
	if (::soap_read__vbox__IGuestMonitorChangedEvent_USCOREgetChangeType(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse * soap_new__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse * soap_new_req__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse *_p = ::soap_new__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse * soap_new_set__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(
	struct soap *soap,
	const std::string& returnval)
{
	_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse *_p = ::soap_new__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroupResponse", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(struct soap *soap, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse *p)
{
	if (::soap_read__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroupResponse(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup * soap_new__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup * soap_new_req__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup *_p = ::soap_new__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup * soap_new_set__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(
	struct soap *soap,
	const std::string& _USCOREthis)
{
	_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup *_p = ::soap_new__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup::_USCOREthis = _USCOREthis;
	}
	return _p;
}

/*noinline*/ int soap_write__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup const*p)
{
	soap_free_temp(soap);
	if (soap_begin_send(soap) || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroup", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup ? "" : NULL) || soap_end_send(soap))
		return soap->error;
	return SOAP_OK;
}

/*noinline*/ int soap_PUT__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup const*p)
{
	soap_free_temp(soap);
	if (soap_PUT(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroup", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_PATCH__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup const*p)
{
	soap_free_temp(soap);
	if (soap_PATCH(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroup", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup ? "" : NULL) || soap_end_send(soap) || soap_recv_empty_response(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_POST_send__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup const*p)
{
	soap_free_temp(soap);
	if (soap_POST(soap, URL, NULL, "text/xml; charset=utf-8") || (p->soap_serialize(soap), 0) || p->soap_put(soap, "vbox:IBandwidthGroupChangedEvent_getBandwidthGroup", p->soap_type() == SOAP_TYPE__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup ? "" : NULL) || soap_end_send(soap))
		return soap_closesock(soap);
	return SOAP_OK;
}

/*noinline*/ int soap_read__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup *p)
{
	if (p)
	{	p->soap_default(soap);
		if (soap_begin_recv(soap) || ::soap_get__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(soap, p, NULL, NULL) == NULL || soap_end_recv(soap))
			return soap->error;
	}
	return SOAP_OK;
}

/*noinline*/ int soap_GET__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, const char *URL, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup *p)
{
	if (soap_GET(soap, URL, NULL) || ::soap_read__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ int soap_POST_recv__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(struct soap *soap, _vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup *p)
{
	if (::soap_read__vbox__IBandwidthGroupChangedEvent_USCOREgetBandwidthGroup(soap, p))
		return soap_closesock(soap);
	return soap_closesock(soap);
}

/*noinline*/ _vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse * soap_new__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse(struct soap *soap, int n /*=-1*/)
{
	return soap_instantiate__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse(soap, n, NULL, NULL, NULL);
}

/*noinline*/ _vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse * soap_new_req__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse *_p = ::soap_new__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse::returnval = returnval;
	}
	return _p;
}

/*noinline*/ _vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse * soap_new_set__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse(
	struct soap *soap,
	bool returnval)
{
	_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse *_p = ::soap_new__vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse(soap);
	if (_p)
	{	_p->soap_default(soap);
		_p->_vbox__IVBoxSVCAvailabilityChangedEvent_USCOREgetAvailableResponse::returnval = returnval;
	}
	return _p;
}
